MODULE AMV_EN_TARGET_SELECTION_UTILS_M

USE fw_log_mod

USE NF_PARM
USE GEOCAT_CONSTANTS

USE TYPE_KINDS_AIT
USE COMMON_VAR_VALUE
USE Framework_Global_Variables_Module
USE NUMERICAL_ROUTINES

USE AMV_EN_Forecast_M
USE AMV_EN_FEATURE_TRACKING_UTILS_M
USE AMV_EN_WINDS_INC


IMPLICIT NONE

! Variables accessible to all subroutines in this module
INTEGER(LONG) :: Good_Winds
INTEGER(LONG) :: Box_Size
INTEGER(LONG) :: Total_Points

INTEGER(LONG) :: Channel


! Satellite ID
INTEGER(LONG) :: SENSOR_SERIES

! Clear-sky water vapor flag
INTEGER(LONG) :: CSWV_Flag



REAL(SINGLE)   :: MIN_PERCENT_PRESS_VALUES
REAL(SINGLE)   :: IR_GRADIENT_THRESHOLD





CONTAINS



!-------------------------------------------------------------------------------
!
! Name:
!   Convolve_X
!
! Function:
!   Compute gradient in element direction using a 4-pt centered difference
!
! Description:
!   - Use 5-pt kernel to estimate derivative
!
! Reference:
!   Barron et al. (1994), "Performance of Optical Flow Techniques."
!   International Journal of Computer Vision, 12:1, 43-77.
!
! Inputs:
!   Kernel               5-pt kernel
!   Element              Image element location
!   Line                 Image line location
!   PIXEL_OFFSET         Pixel offset used to compute centered difference
!
! Output:
!   Diff_X               Derivative in element direction
!
! Dependencies:
!   None
!
! Restrictions:
!   - May convert this function to a generic interface
!
! History:
!   4/2007 - Wayne Bresky - Created
!
!-------------------------------------------------------------------------------
FUNCTION Convolve_X(Kernel,Element,Line,BrtTemp,PIXEL_OFFSET) RESULT(Diff_X)

  INTEGER(LONG), INTENT(IN) :: Line
  INTEGER(LONG), INTENT(IN) :: Element
  INTEGER(LONG), INTENT(IN) :: PIXEL_OFFSET
  INTEGER(LONG) :: Pixel

  REAL(SINGLE), DIMENSION(:), INTENT(IN) :: Kernel
  REAL(SINGLE), DIMENSION(:,:), INTENT(IN) :: BrtTemp
  REAL(SINGLE) :: Diff_X

  Diff_X = 0.0

  sum_loop: DO Pixel=-PIXEL_OFFSET, PIXEL_OFFSET
    !what about missing values?
    Diff_X = Diff_X + Kernel(Pixel+3)*BrtTemp(Element+Pixel,Line)

  END DO sum_loop

END FUNCTION Convolve_X

!-------------------------------------------------------------------------------
!
! Name:
!   Convolve_Y
!
! Function:
!   Compute gradient in line direction using a 4-pt centered difference
!
! Description:
!   - Use 5-pt kernel to estimate derivative
!
! Reference:
!   Barron et al. (1994), "Performance of Optical Flow Techniques."
!   International Journal of Computer Vision, 12:1, 43-77.
!
! Inputs:
!   Kernel               5-pt kernel
!   Element              Image element location
!   Line                 Image line location
!   PIXEL_OFFSET         Pixel offset used to compute centered difference
!
! Output:
!   Diff_Y               Derivative in line direction
!
! Dependencies:
!   None
!
! Restrictions:
!   - May convert this function to a generic interface
!
! History:
!   4/2007 - Wayne Bresky - Created
!
!-------------------------------------------------------------------------------
FUNCTION Convolve_Y(Kernel,Element,Line,BrtTemp,PIXEL_OFFSET) RESULT(Diff_Y)

  INTEGER(LONG), INTENT(IN) :: Line
  INTEGER(LONG), INTENT(IN) :: Element
  INTEGER(LONG), INTENT(IN) :: PIXEL_OFFSET
  INTEGER(LONG) :: Pixel

  REAL(SINGLE), DIMENSION(:), INTENT(IN) :: Kernel
  REAL(SINGLE), DIMENSION(:,:), INTENT(IN) :: BrtTemp
  REAL(SINGLE) :: Diff_Y

  Diff_Y = 0.0

  sum_loop: DO Pixel=-PIXEL_OFFSET, PIXEL_OFFSET
    !what about missing values?
    Diff_Y = Diff_Y + Kernel(Pixel+3)*BrtTemp(Element,Line+Pixel)

  END DO sum_loop

END FUNCTION Convolve_Y

! ------------------------------------------------------------------------------
!
! Name:
!   Target_QC
!
! Function:
!   Perform quality control of target scene.
!
! Description:
!   Apply various tests to determine if scene is a suitable target. Tests
!   include:
!
!               contrast (max BrtTemp - min BrtTemp)
!               earth edge (space)
!               cloud amount
!                 - cloud tracers; at least 10 percent cloud coverage
!                 - clear sky tracer; 100 percent clear coverage
!               bad data (reasonable data values)
!               spatial coherence
!               multi-layer check
!               day/night terminator check (visible and 3.9 channel only)
!
! Reference:
!   Nieman et al (1997), "Fully Automated Cloud-Drift Winds in NESDIS
!   Operations." Bulletin of the American Meteorological Society, June 1997.
!
!   Nieman et al (1993), "A Comparison of Several Techniques to Assign Heights
!   to Cloud Tracers." Journal of Applied Meteorology, September 1993.
!
!   Coakley and Bretherton (1982), "Cloud Cover From High-Resolution Scanner
!   Data: Detecting and Allowing for Partially Filled Fields of View." Journal
!   of Geophysical Research, June 1982.
!
! Calling sequence:
!   CALL Target_QC
!
! Inputs:
!   Box_Data                   Data structure holding target box data arrays
!
! Output:
!   QC_Flag              Quality control flag, possible values include:
!                          0 - Good target scene
!                          1 - Target failed contrast test
!                          2 - Target located on earth edge
!
!                          3 - Cloud amount below 10 percent
!                                         or
!                              Target scene not clear enough
!
!                          4 - Bad data (max BrtTemp <= 180 or min BrtTemp = 0)
!                          5 - Bad data (max BrtTemp > 340)
!                          6 - multi-layer scene
!                          7 - target too coherent
!                         13 - target too close to day/night terminator
!                              (0.6 and 3.9 channels only)
!
! Dependencies:
!   Relies on satellite data structure for brightness temperature data.
!   Requires spatial coherence arrays output from "compute_spatial_uniformity"
!   subroutine.
!
! Restrictions:
!   None
!
! History:
!   5/2007 - Wayne Bresky - Created
!  10/2008 - Wayne Bresky - Added check for day/night terminator
!  04/2010 - Wayne Bresky - Introduced data structure to hold target box data
!-------------------------------------------------------------------------------
SUBROUTINE Target_QC(NavType, Box_Data, QC_Flag)

  CHARACTER(LEN=*), INTENT(IN) :: NavType
  TYPE(Target_Box_Data), INTENT(INOUT) :: Box_Data
  INTEGER(LONG), INTENT(OUT) :: QC_Flag

  INTEGER(LONG) :: Number_Of_Lines
  INTEGER(LONG) :: Number_Of_Elements
  INTEGER(LONG) :: Total_Sample
  INTEGER(LONG) :: Line
  INTEGER(LONG) :: Element
  INTEGER(LONG) :: Peak_Sample_Size
  INTEGER(LONG) :: Cold_Sample_Size
  INTEGER(LONG) :: Filtered_Sample_Size
  INTEGER(LONG) :: Cloudy_Pixels
  INTEGER(LONG) :: Cloudy_Pixels_WV
  INTEGER(LONG) :: Cloudy_Threshold
  INTEGER(LONG) :: Sample
  INTEGER(LONG) :: Sum_Of_Samples
  INTEGER(LONG) :: Peak
  INTEGER(LONG) :: Peak_Cold
  INTEGER(LONG), ALLOCATABLE, DIMENSION(:) :: Peak_Slots
  INTEGER(LONG), ALLOCATABLE, DIMENSION(:) :: Cold_Slots

  REAL(SINGLE), DIMENSION(Total_Points) :: Mean_Values_Filtered_Sample
  REAL(SINGLE) :: BrtTemp_Gradient_Threshold
  REAL(SINGLE) :: Sample_Threshold
  REAL(SINGLE) :: Coherence_Threshold
  REAL(SINGLE) :: Min_Box_Value
  REAL(SINGLE) :: Max_Box_Value
  REAL(SINGLE) :: Range_Of_Values
  REAL(SINGLE) :: Solar_Zen_Center


  ! ----------------------------------------------------------------------------
  ! Initialize variables
  ! ----------------------------------------------------------------------------

  Number_Of_Elements = SIZE(Box_Data%Mean,1)
  Number_Of_Lines = SIZE(Box_Data%Mean,2)
  Peak_Sample_Size = 0
  Filtered_Sample_Size = 0
  Cold_Sample_Size = 0
  Total_Sample = 0
  QC_Flag = sym%SUCCESS

  ! The BT extremes are needed for the contrast test

  Max_Box_Value = MAXVAL(Box_Data%BrtTemp)
  Min_Box_Value = MINVAL(Box_Data%BrtTemp)

  Sample_Threshold = 0.0
  Cloudy_Pixels = 0
  Cloudy_Pixels_WV = 0
  Sum_Of_Samples = 0

  ! pick up solar zenith angle at center of target box

  Solar_Zen_Center = Box_Data%Sol_Zen(Number_Of_Elements/2 + 1, &
                                         Number_Of_Lines/2 + 1)

  ! Avoid the day/night terminator when processing visible and 3.9 channels

  IF (Channel .EQ. NATIVE_ABI_CHN2) THEN

    IF (Solar_Zen_Center .GT. MAX_SOLAR_ZEN_VISIBLE) THEN

      QC_Flag = TERMINATOR_FAILURE
      RETURN

    ENDIF

  ELSE IF (Channel .EQ. NATIVE_ABI_CHN7) THEN

    IF (Solar_Zen_Center .LT. MIN_SOLAR_ZEN_SWIR .OR. &
        Solar_Zen_Center .GT. MAX_SOLAR_ZEN_SWIR) THEN

      QC_Flag = TERMINATOR_FAILURE
      RETURN

    ENDIF

  ENDIF

  ! Use a 10 percent cloud amount threshold for cloud-tracked winds
  ! this is the default

  Cloudy_Threshold = NINT(REAL(Number_Of_Elements * Number_Of_Lines) * 0.1)

  ! For the clear-sky WV winds require a completely clear scene
  ! (i.e., no cloudy pixels allowed)

  IF (CSWV_Flag .EQ. sym%YES) Cloudy_Threshold = 0

  line_loop: DO Line=1, Number_Of_Lines

    element_loop: DO Element=1, Number_Of_Elements

      ! ------------------------------------------------------------------------
      ! Discard target if any portion of the box is located in space
      ! ------------------------------------------------------------------------

      IF (Box_Data%Space(Element,Line) == SYM%SPACE) THEN
        QC_Flag = EARTH_EDGE_FAILURE
        RETURN
      ENDIF

      IF (Box_Data%StdDev(Element,Line) .NE. MISSING_VALUE_REAL4) &
                                  Total_Sample = Total_Sample + 1

      ! ------------------------------------------------------------------------
      ! Keep track of number of cloudy pixels in box. Accept all cloudy and
      ! probably cloudy pixels.
      ! ------------------------------------------------------------------------

      ! for polar winds only count cloudy pixels not probably cloudy pixels
      ! this increases the coverage of clear-sky WV winds - 1/25/16

      IF (TRIM(NavType) .EQ. 'PS') THEN

        IF (Box_Data%Cloud_Mask(Element,Line) == SYM%CLOUDY) THEN

          Cloudy_Pixels = Cloudy_Pixels + 1

          ! For the mid- and upper-level WV only count cloudy pixels above 600 mb. This
          ! allows winds to be generated in clear regions above low clouds.

          IF (Channel .EQ. NATIVE_ABI_CHN8 .AND. Box_Data%Cld_Top_Press(Element,Line) .LT. &
              CLR_CLDY_PRESS_CUTOFF) Cloudy_Pixels_WV = Cloudy_Pixels_WV + 1

          IF (Channel .EQ. NATIVE_ABI_CHN9 .AND. Box_Data%Cld_Top_Press(Element,Line) .LT. &
              CLR_CLDY_PRESS_CUTOFF) Cloudy_Pixels_WV = Cloudy_Pixels_WV + 1

        ENDIF

      ELSE

        IF (Box_Data%Cloud_Mask(Element,Line) == SYM%CLOUDY .OR. &
            Box_Data%Cloud_Mask(Element,Line) == SYM%PROB_CLOUDY) THEN

          Cloudy_Pixels = Cloudy_Pixels + 1

          ! For the mid- and upper-level WV only count cloudy pixels above 600 mb. This
          ! allows winds to be generated in clear regions above low clouds.

          IF (Channel .EQ. NATIVE_ABI_CHN8 .AND. Box_Data%Cld_Top_Press(Element,Line) .LT. &
              CLR_CLDY_PRESS_CUTOFF) Cloudy_Pixels_WV = Cloudy_Pixels_WV + 1

          IF (Channel .EQ. NATIVE_ABI_CHN9 .AND. Box_Data%Cld_Top_Press(Element,Line) .LT. &
              CLR_CLDY_PRESS_CUTOFF) Cloudy_Pixels_WV = Cloudy_Pixels_WV + 1

        ENDIF

      ENDIF !1/25/16

      ! Keep track of pixels that are spatially coherent.

      IF (Box_Data%StdDev(Element,Line) .GE. 0.0 .AND. Box_Data%StdDev &
              (Element,Line) .LE. STDDEV_THRESHOLD .AND. Box_Data%Mean &
                                        (Element, Line) .GT. 0.0) THEN

        Filtered_Sample_Size = Filtered_Sample_Size + 1
        Mean_Values_Filtered_Sample(Filtered_Sample_Size) = &
                             Box_Data%Mean(Element, Line)

      ENDIF

    END DO element_loop

  END DO line_loop

  ! ----------------------------------------------------------------------------
  ! Apply cloud amount threshold. For the cloud-top winds, exclude scenes which
  ! do not have at least 10 percent cloud cover. For the clear-sky WV winds,
  ! require that the entire scene be clear. Ignore low clouds when processing
  ! the 6.2 channel.
  ! ----------------------------------------------------------------------------

  ! save cloudy pixel count - wcb 08/31/12

  Box_Data%CloudyPixels = Cloudy_Pixels

  SELECT CASE(Channel)

  CASE (NATIVE_ABI_CHN2, NATIVE_ABI_CHN7, NATIVE_ABI_CHN14)  ! visible, SWIR and LWIR

    IF (Cloudy_Pixels .LT. Cloudy_Threshold) THEN

      QC_Flag = CLOUD_AMOUNT_FAILURE
      RETURN

    ENDIF

  CASE (NATIVE_ABI_CHN8 : NATIVE_ABI_CHN9)  ! mid- and upper-level WV

    ! These bands are unique because we use them to track cloud and clear sky
    ! features. This means we have to test for two conditions.

    IF ((CSWV_Flag .EQ. sym%NO .AND. Cloudy_Pixels_WV .LT. Cloudy_Threshold) .OR. &
        (CSWV_Flag .EQ. sym%YES .AND. Cloudy_Pixels_WV .GT. Cloudy_Threshold)) THEN

      QC_Flag = CLOUD_AMOUNT_FAILURE
      RETURN

    ENDIF

  CASE (NATIVE_ABI_CHN10)  ! low-level WV

    ! For this channel we can't ignore low-level clouds, so check total number
    ! of cloudy pixels and fail if box isn't completely clear. We are only
    ! tracking clear sky features with this band.

    IF (CSWV_Flag .EQ. sym%YES .AND. Cloudy_Pixels .GT. Cloudy_Threshold) THEN

      QC_Flag = CLOUD_AMOUNT_FAILURE
      RETURN

    ENDIF

  END SELECT

  ! ----------------------------------------------------------------------------
  ! Apply contrast check
  ! ----------------------------------------------------------------------------

  Range_Of_Values = Max_Box_Value - Min_Box_Value
  IF (Channel .EQ. NATIVE_ABI_CHN2) THEN

    !aab SWIR - Mods for VIIRS...use different threshold for VIIRS SWIR
    !           VIIRS SWIR is a reflectance value, so it's treated as a VIS channel
    !BrtTemp_Gradient_Threshold = VISIBLE_GRADIENT_THRESHOLD * Box_Size / &
    !                                                   NOMINAL_BOX_SIZE
    IF ( Sensor_Series == SERIES_JPSS_VIIRS ) THEN
      BrtTemp_Gradient_Threshold = VISIBLE_GRADIENT_THRESHOLD_VIIRS * Box_Size / &
                                                          NOMINAL_BOX_SIZE
    ELSE
      BrtTemp_Gradient_Threshold = VISIBLE_GRADIENT_THRESHOLD * Box_Size / &
                                                          NOMINAL_BOX_SIZE
    ENDIF

  ELSE IF (Channel .EQ. NATIVE_ABI_CHN7) THEN

    ! aab Tandem (dbscan) 
    !BrtTemp_Gradient_Threshold = SWIR_GRADIENT_THRESHOLD * Box_Size / &
    !                                            NOMINAL_SWIR_BOX_SIZE
    ! now using lower threshold for SWIR winds 
    BrtTemp_Gradient_Threshold = SWIR_GRADIENT_THRESHOLD

  ! clear-sky WV

  ELSE IF (Channel .EQ. NATIVE_ABI_CHN8  .AND. CSWV_Flag .EQ. sym%YES .OR. &
           Channel .EQ. NATIVE_ABI_CHN9  .AND. CSWV_Flag .EQ. sym%YES .OR. &
           Channel .EQ. NATIVE_ABI_CHN10 .AND. CSWV_Flag .EQ. sym%YES) THEN

    BrtTemp_Gradient_Threshold = WVCS_GRADIENT_THRESHOLD * Box_Size / &
                                                     NOMINAL_BOX_SIZE

  ! cloud-top WV (note: we do not use band 10 for cloud tracking)

  ELSE IF (Channel .EQ. NATIVE_ABI_CHN8 .AND. CSWV_Flag .EQ. sym%NO .OR. &
           Channel .EQ. NATIVE_ABI_CHN9 .AND. CSWV_Flag .EQ. sym%NO) THEN

    BrtTemp_Gradient_Threshold = WVCT_GRADIENT_THRESHOLD * Box_Size / &
                                                     NOMINAL_BOX_SIZE

  ELSE IF (Channel .EQ. NATIVE_ABI_CHN14) THEN

    ! aab Tandem (dbscan) 
    !BrtTemp_Gradient_Threshold = IR_GRADIENT_THRESHOLD * Box_Size / &
    !                                               NOMINAL_BOX_SIZE
    ! now using lower threshold for LWIR winds
    BrtTemp_Gradient_Threshold = IR_GRADIENT_THRESHOLD

  ENDIF


  IF (Range_Of_Values .LT. BrtTemp_Gradient_Threshold) THEN

    QC_Flag = GRADIENT_THRESHOLD_FAILURE
    RETURN

  ENDIF

  ! ----------------------------------------------------------------------------
  ! Flag target scenes with max/min values outside of the acceptable range
  ! ----------------------------------------------------------------------------

  IF (Channel .EQ. NATIVE_ABI_CHN2) THEN

    ! check reflectance values instead of BT but use same error code

    IF (Min_Box_Value .LT. MIN_VALID_REFLECTANCE .OR. &
        Max_Box_Value .GT. MAX_VALID_REFLECTANCE) THEN
      QC_Flag = BAD_BT_FAILURE
      RETURN
    ENDIF

  ELSE

    IF (Min_Box_Value .LT. MIN_VALID_BT .OR. &
        Max_Box_Value .GT. MAX_VALID_BT) THEN

      QC_Flag = BAD_BT_FAILURE
      RETURN

    ENDIF

  ENDIF

  ! ----------------------------------------------------------------------------
  ! For WV channels this is the extent of the target QC.
  ! ----------------------------------------------------------------------------

  ! polar winds test
  ! do not perform additional QC

  !021915
  !IF (Channel .EQ. NATIVE_ABI_CHN8  .OR. Channel .EQ. NATIVE_ABI_CHN9 .OR. &
  !    Channel .EQ. NATIVE_ABI_CHN10) RETURN

  IF (Channel .EQ. NATIVE_ABI_CHN2  .OR. Channel .EQ. NATIVE_ABI_CHN7 .OR. &
      Channel .EQ. NATIVE_ABI_CHN8  .OR. Channel .EQ. NATIVE_ABI_CHN9 .OR. &
      Channel .EQ. NATIVE_ABI_CHN10 ) RETURN


  IF (TRIM(NavType) .EQ. 'PS') RETURN

  ! ----------------------------------------------------------------------------
  ! Apply spatial coherence check
  ! ----------------------------------------------------------------------------

  Coherence_Threshold = COHERENCE_THRESHOLD_PCT * REAL(Total_Sample)

  ! aab Tandem (dbscan) 
  ! disable spatial coherency check
  !IF (REAL(Filtered_Sample_Size) .GT. Coherence_Threshold) THEN

  !  QC_Flag = COHERENCY_FAILURE
  !  RETURN

  !ENDIF

  IF (Filtered_Sample_Size > 0) THEN

    ! --------------------------------------------------------------------------
    ! Perform cluster analysis on filtered sample
    ! --------------------------------------------------------------------------

    CALL Cluster_Analysis(Mean_Values_Filtered_Sample(1:Filtered_Sample_Size), &
                                    Cold_Slots, Peak_Slots, Peak, Peak_Cold)

    ! --------------------------------------------------------------------------
    ! Count the number of warm and cold samples output from cluster analysis
    ! --------------------------------------------------------------------------

    sample_loop: DO Sample= 1, Filtered_Sample_Size

      IF (Cold_Slots(Sample) .EQ. 1) Cold_Sample_Size = Cold_Sample_Size + 1
      IF (Peak_Slots(Sample) .EQ. 1) Peak_Sample_Size = Peak_Sample_Size + 1

    END DO sample_loop

    ! --------------------------------------------------------------------------
    ! Filter out multi-layer cloud scenes (the warmest layer is assumed
    ! to be the surface).
    ! --------------------------------------------------------------------------

    Sum_Of_Samples = Cold_Sample_Size + Peak_Sample_Size
    Sample_Threshold = SAMPLE_THRESHOLD_PCT * Filtered_Sample_Size

    IF (REAL(Sum_Of_Samples) .LT. Sample_Threshold) THEN

      QC_Flag = MULTIPLE_LAYERS_FAILURE
      RETURN

    ENDIF

    DEALLOCATE(Cold_Slots, Peak_Slots)

  ENDIF

END SUBROUTINE Target_QC

! ------------------------------------------------------------------------------
!
! Name:
!   Cluster_Analysis
!
! Function:
!   Identify clusters from spatially coherent (StdDev <= threshold)
!   sample of 3x3 mean values. The sample is filtered before calling this
!   routine.
!
! Description:
!   - A histogram is created from the input 3x3 mean data
!   - The peak frequency is identified
!   - A Gaussian histogram is generated centered on the peak location
!   - Points are selected by applying standard deviation thresholds
!   - The process above is repeated for the peak frequency of the cold end
!
! Reference:
!   Nieman et al (1993), "A Comparison of Several Techniques to Assign Heights
!   to Cloud Tracers." Journal of Applied Meteorology, September 1993.
!   Page 1563.
!
! Calling sequence:
!   CALL Cluster_Analysis
!
! Inputs:
!   Input_Data                Input 3x3 mean data
!   Number_Of_Points          Number of values in Input_Data array
!
! Outputs:
!   Cold_Slots                Selected points from the histogram analysis of the
!                             cold peak
!   Peak_Slots                Selected points from the histogram analysis of the
!                             overall peak
!   Max_Frequency_Slot        Radiance value of histogram peak
!   Max_Frequency_Slot_Cold   Radiance value of cold peak
!
! Dependencies:
!   Requires a spatially coherent filtered sample of 3x3 mean values
!
! Restrictions:
!
! History:
!   5/2007 - Wayne Bresky - Created
!
!-------------------------------------------------------------------------------
SUBROUTINE Cluster_Analysis (Input_Data, Cold_Slots, &
                                       Peak_Slots, Max_Frequency_Slot, &
                                              Max_Frequency_Slot_Cold)
  REAL(SINGLE), INTENT(IN), DIMENSION(:) :: Input_Data
  INTEGER(LONG), INTENT(OUT), ALLOCATABLE, DIMENSION(:) :: Cold_Slots
  INTEGER(LONG), INTENT(OUT), ALLOCATABLE, DIMENSION(:) :: Peak_Slots
  INTEGER(LONG), INTENT(OUT) :: Max_Frequency_Slot
  INTEGER(LONG), INTENT(OUT) :: Max_Frequency_Slot_Cold

  INTEGER(LONG), PARAMETER :: Number_Of_StdDev_Cutoffs = 4
  INTEGER(LONG), PARAMETER :: Maximum_Number_Of_Cold_Clusters = 5
  REAL(SINGLE), PARAMETER :: Maximum_Variance = 25.0
  INTEGER(LONG), DIMENSION(Number_Of_StdDev_Cutoffs) :: StdDev_Cutoffs
  INTEGER(LONG):: Number_Of_Points
  INTEGER(LONG), ALLOCATABLE, DIMENSION(:) :: Slot_Values
  INTEGER(LONG), ALLOCATABLE, DIMENSION(:) :: Histogram
  INTEGER(LONG), ALLOCATABLE, DIMENSION(:) :: Gaussian_Histogram
  INTEGER(LONG) :: Slot_Number
  INTEGER(LONG) :: Max_Frequency
  INTEGER(LONG) :: Slot
  INTEGER(LONG) :: Point
  INTEGER(LONG) :: Frequency
  INTEGER(LONG) :: Cold_Counter
  INTEGER(LONG) :: Max_Frequency_Cold

  REAL(SINGLE) :: Variance_LHS
  REAL(SINGLE) :: Variance_RHS
  REAL(SINGLE) :: StdDev_LHS
  REAL(SINGLE) :: StdDev_RHS
  Number_Of_Points = SIZE(Input_Data)
  ALLOCATE(Cold_Slots(Number_Of_Points), Peak_Slots(Number_Of_Points))
  ALLOCATE(Slot_Values(Total_Points), Histogram(NUMBER_OF_SLOTS))

  ! ----------------------------------------------------------------------------
  ! Initialize variables
  ! ----------------------------------------------------------------------------

  StdDev_Cutoffs(1:Number_Of_StdDev_Cutoffs) = 0
  Cold_Slots(1:Number_Of_Points) = 0
  Peak_Slots(1:Number_Of_Points) = 0

  ! ----------------------------------------------------------------------------
  ! Create a 1-D histogram
  ! ----------------------------------------------------------------------------

  CALL Make_Histogram(Input_Data, Slot_Values, &
                   Max_Frequency_Slot, Max_Frequency, Histogram)

  ! ----------------------------------------------------------------------------
  ! Fit half-Gaussian curves to both sides of peak frequency using the three
  ! closest points on either side of the peak to estimate the average variance
  ! on each side.
  ! ----------------------------------------------------------------------------

  CALL Gaussian_Fit (Max_Frequency_Slot, Histogram, Variance_LHS, Variance_RHS)

  ! ----------------------------------------------------------------------------
  ! Constrain variances to an upper limit
  ! ----------------------------------------------------------------------------

  IF (Variance_LHS .GT. Maximum_Variance) Variance_LHS = Maximum_Variance
  IF (Variance_RHS .GT. Maximum_Variance) Variance_RHS = Maximum_Variance

  ! ----------------------------------------------------------------------------
  ! Call routine to compute Gaussian curve for all slots. This is the full
  ! Gaussian curve created from the two average variance values.
  ! ----------------------------------------------------------------------------

  ALLOCATE(Gaussian_Histogram(NUMBER_OF_SLOTS))

  CALL Gaussian_Curve (Max_Frequency_Slot, Max_Frequency, Variance_LHS, &
                                      Variance_RHS, Gaussian_Histogram)

  ! ----------------------------------------------------------------------------
  ! Compute indices corresponding to point selection thresholds. These
  ! thresholds will be used to filter the sample according to the following
  ! rules: Select all points within 1 standard deviation of peak. Between 1 - 3
  ! standard deviations only select as many points as suggested by the Gaussian
  ! fit. Exclude all points more than 3 standard deviations from peak.
  ! ----------------------------------------------------------------------------

  StdDev_LHS = SQRT(Variance_LHS) / INTERVAL_LENGTH
  StdDev_RHS = SQRT(Variance_RHS) / INTERVAL_LENGTH

  StdDev_Cutoffs(1) = Max_Frequency_Slot - SIGMA_3 * StdDev_LHS
  StdDev_Cutoffs(2) = Max_Frequency_Slot - SIGMA_1 * StdDev_LHS
  StdDev_Cutoffs(3) = Max_Frequency_Slot + SIGMA_1 * StdDev_RHS
  StdDev_Cutoffs(4) = Max_Frequency_Slot + SIGMA_3 * StdDev_RHS

  peak_loop: DO Point = 1, Number_Of_Points

    Slot = Slot_Values(Point)

    ! --------------------------------------------------------------------------
    ! Select all points within 1 S.D. of Peak.
    ! --------------------------------------------------------------------------

    IF (Slot .GE. StdDev_Cutoffs(2) .AND. Slot .LE. StdDev_Cutoffs(3)) THEN
      Peak_Slots(Point) = 1

    ! --------------------------------------------------------------------------
    ! On the interval 1 - 3 S.D. select only as many points as suggested by
    ! Gaussian fit.
    ! --------------------------------------------------------------------------

    ELSE IF ((Slot .GE. StdDev_Cutoffs(1) .AND. Slot .LT. StdDev_Cutoffs(2)) &
       .OR. (Slot .GT. StdDev_Cutoffs(3) .AND. Slot .LE. StdDev_Cutoffs(4))) &
                                                                        THEN

      IF (Gaussian_Histogram(Slot) .GT. 0) THEN
        Peak_Slots(Point) = 1
        Gaussian_Histogram(Slot) = Gaussian_Histogram(Slot) - 1
      ENDIF

    ENDIF

  END DO peak_loop

  ! ----------------------------------------------------------------------------
  ! Find peak frequency of 5 coldest clusters.
  ! ----------------------------------------------------------------------------

  Max_Frequency_Cold = 0
  Max_Frequency_Slot_Cold = 0
  Cold_Counter = 0

  ! search from cold end
  slot_loop: DO Slot_Number = 1, NUMBER_OF_SLOTS

    Frequency = Histogram(Slot_Number)

    IF (Frequency .GE. 1) Cold_Counter = Cold_Counter + 1

    IF (Frequency .GT. Max_Frequency_Cold) THEN
      Max_Frequency_Cold = Histogram(Slot_Number)
      Max_Frequency_Slot_Cold = Slot_Number
    ENDIF

    IF (Cold_Counter .GE. Maximum_Number_Of_Cold_Clusters) EXIT slot_loop

  END DO slot_loop

  ! ----------------------------------------------------------------------------
  ! Repeat process used above, this time for the cold sample.
  ! ----------------------------------------------------------------------------

  CALL Gaussian_Fit(Max_Frequency_Slot_Cold, Histogram, Variance_LHS, &
                                                        Variance_RHS)

  IF (Variance_LHS .GT. Maximum_Variance) Variance_LHS = Maximum_Variance
  IF (Variance_RHS .GT. Maximum_Variance) Variance_RHS = Maximum_Variance

  CALL Gaussian_Curve(Max_Frequency_Slot_Cold, Max_Frequency_Cold, &
                   Variance_LHS, Variance_RHS, Gaussian_Histogram)

  StdDev_LHS = SQRT(Variance_LHS) / INTERVAL_LENGTH
  StdDev_RHS = SQRT(Variance_RHS) / INTERVAL_LENGTH

  StdDev_Cutoffs(1) = Max_Frequency_Slot_Cold - SIGMA_3 * StdDev_LHS
  StdDev_Cutoffs(2) = Max_Frequency_Slot_Cold - SIGMA_1 * StdDev_LHS
  StdDev_Cutoffs(3) = Max_Frequency_Slot_Cold + SIGMA_1 * StdDev_RHS
  StdDev_Cutoffs(4) = Max_Frequency_Slot_Cold + SIGMA_3 * StdDev_RHS

  warm_loop: DO Point = 1, Number_Of_Points

    Slot = Slot_Values(Point)

    ! --------------------------------------------------------------------------
    ! Select all points within 1 S.D. of Peak.
    ! --------------------------------------------------------------------------

    IF (Slot .GE. StdDev_Cutoffs(2) .AND. Slot .LE. StdDev_Cutoffs(3)) THEN

      Cold_Slots(Point) = 1

    ! --------------------------------------------------------------------------
    ! On the interval 1 - 3 S.D. select only as many points as suggested by
    ! Gaussian fit.
    ! --------------------------------------------------------------------------

    ELSE IF ((Slot .GE. StdDev_Cutoffs(1) .AND. Slot .LT. StdDev_Cutoffs(2)) &
       .OR. (Slot .GT. StdDev_Cutoffs(3) .AND. Slot .LE. StdDev_Cutoffs(4))) &
                                                                        THEN

      IF (Gaussian_Histogram(Slot) .GT. 0) THEN
        Cold_Slots(Point) = 1
        Gaussian_Histogram(Slot) = Gaussian_Histogram(Slot) - 1
      ENDIF

    ENDIF

  END DO warm_loop

  DEALLOCATE(Histogram, Slot_Values, Gaussian_Histogram)

END SUBROUTINE Cluster_Analysis

! ------------------------------------------------------------------------------
!
! Name:
!   Make_Histogram
!
! Function:
!   Construct a 1-D histogram using image (radiance) data.
!
! Description:
!
! Reference:
!   None
!
! Calling sequence:
!   CALL Make_Histogram
!
! Inputs:
!   Input_Data           Input image data
!   Number_Of_Points     Number of values in Input_Data array
!
! Outputs:
!   Slot_Values          Output array marking each data point's resultant
!                        histogram slot
!   Histogram            Output array of # of points in each histogram
!                        slot (i.e. the histogram)
!
! Dependencies:
!
! Restrictions:
!
! History:
!   5/2007 - Wayne Bresky - Created
!
!-------------------------------------------------------------------------------
SUBROUTINE Make_Histogram(Input_Data, Slot_Values, Peak_Slot, Peak_Value, Histogram)

  REAL(SINGLE), INTENT(IN), DIMENSION(:) :: Input_Data
  INTEGER(LONG), DIMENSION(:) :: Slot_Values
  INTEGER(LONG), INTENT(OUT) :: Peak_Slot
  INTEGER(LONG), INTENT(OUT) :: Peak_Value
  INTEGER(LONG), DIMENSION(:), INTENT(OUT)  :: Histogram
  INTEGER(LONG) :: Number_Of_Points
  INTEGER(LONG) :: Point
  INTEGER(LONG) :: Data_Value


  Number_Of_Points = SIZE(Input_Data)
  ! ----------------------------------------------------------------------------
  ! Initialize variables
  ! ----------------------------------------------------------------------------

  Histogram(1:NUMBER_OF_SLOTS) = 0
  Slot_Values(1:Total_Points) = 0
  Peak_Slot = 0
  Peak_Value = 0
  Data_Value = 0

  ! ----------------------------------------------------------------------------
  ! Loop through data and fill histogram
  ! ----------------------------------------------------------------------------

  data_loop: DO Point=1, Number_Of_Points

    ! --------------------------------------------------------------------------
    ! Calculate which histogram slot data point falls into
    ! --------------------------------------------------------------------------

    Slot_Values(Point) = NINT((Input_Data(Point) - MIN_HISTOGRAM_VALUE) &
                                                     / INTERVAL_LENGTH)
    Data_Value = Slot_Values(Point)

    ! --------------------------------------------------------------------------
    ! Add point to correct histogram slot and keep track of max frequency
    ! --------------------------------------------------------------------------
    !021915
    IF ( Data_Value .GT. 0 .AND. Data_Value .LE. NUMBER_OF_SLOTS) THEN
       Histogram(Data_Value) = Histogram(Data_Value) + 1

       IF (Histogram(Data_Value) .GT. Peak_Value) THEN
          Peak_Value = Histogram(Data_Value)
          Peak_Slot =  Data_Value
       ENDIF
    ENDIF

  END DO data_loop

END SUBROUTINE Make_Histogram

! ------------------------------------------------------------------------------
!
! Name:
!   Make_Histogram_Temp
!
! Function:
!   Construct a 1-D histogram using temperature data (either BT or CTT) then
!   determine temperature threshold using coldest 20 (WV) or 25 (IR) percent
!   of histogram.
!
! Description:
!
! Reference:
!   None
!
! Calling sequence:
!   CALL Make_Histogram_Temp
!
! Inputs:
!   Box_Data                      Data structure holding target box data
!   Number_Of_Points              Number of values in Temp_Data array
!
! Outputs:
!   Cold_Sample_Counter           Number of points in cold sample
!   Variance_Press                Variance of Cld_Top_Press values (cold sample)
!   Inversion_Sample_Flag         Flag indicating whether or not a low-level
!                                 inversion is present
!
! Dependencies:
!
! Restrictions:
!
! History:
!  08/2007 - Wayne Bresky - Created
!  03/2009 - Wayne Bresky - Added low-level inversion flag
!  07/2009 - Wayne Bresky - Added cloud height values
!  04/2010 - Wayne Bresky - Introduced target box data structure
!
!-------------------------------------------------------------------------------
SUBROUTINE Make_Histogram_Temp(NavType, Box_Data, Number_Of_Points, Cold_Sample_Counter, &
                                         Variance_Press, Inversion_Sample_Flag)
  CHARACTER(len=*), PARAMETER :: FUNC = "Make_Histogram_Temp"
  CHARACTER(LEN=*), INTENT(IN) :: NavType
  TYPE(Target_Box_Data), INTENT(INOUT) :: Box_Data
  INTEGER(LONG), INTENT(IN) :: Number_Of_Points
  INTEGER(LONG), INTENT(OUT) :: Cold_Sample_Counter
  REAL(SINGLE), INTENT(OUT) :: Variance_Press
  INTEGER(BYTE), INTENT(OUT) :: Inversion_Sample_Flag

  INTEGER(LONG) :: Point
  INTEGER(LONG) :: Data_Value
  INTEGER(LONG) :: BrtTemp
  INTEGER(LONG) :: Cold_Sample
  INTEGER(LONG) :: Number_Of_BrtTemp_Slots = BRTTEMP_MAX - BRTTEMP_MIN + 1
  INTEGER(LONG) :: Histogram_Points
  INTEGER(LONG) :: Point_Cutoff
  INTEGER(LONG) :: Number_Of_Bins
  INTEGER(LONG) :: Cold_Slot_Threshold
  INTEGER(LONG) :: Lower_Bound
  INTEGER(LONG) :: Upper_Bound
  INTEGER(SHORT), ALLOCATABLE, DIMENSION(:) :: Slot_Values
  INTEGER(LONG), ALLOCATABLE, DIMENSION(:) :: Histogram
  INTEGER(LONG) :: Count_Sample1
  INTEGER(LONG) :: Count_Sample2
  INTEGER(LONG), ALLOCATABLE, DIMENSION(:) :: Histogram_Sample1
  INTEGER(LONG), ALLOCATABLE, DIMENSION(:) :: Histogram_Sample2
  INTEGER(LONG), SAVE :: Num_Call = 0
  CHARACTER(len=100) :: message

  ! 1-D data
  REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Input_Data
  REAL(DOUBLE), ALLOCATABLE, DIMENSION(:) :: Cloud_Top_Pressure
  REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Cld_Hgt
  INTEGER(BYTE), ALLOCATABLE, DIMENSION(:) :: Cld_Top_Press_Quality
  INTEGER(BYTE), ALLOCATABLE, DIMENSION(:) :: Cloud_Mask
  INTEGER(BYTE), ALLOCATABLE, DIMENSION(:) :: LL_Inver_Flag
  !WCB - add cloud height quality flag
  INTEGER(BYTE), ALLOCATABLE, DIMENSION(:) :: CldHgtQF

  ! cold sample arrays
  REAL(DOUBLE), DIMENSION(:), ALLOCATABLE :: Pressure_Cold_Sample
  REAL(SINGLE), DIMENSION(:), ALLOCATABLE :: BrtTemp_Cold_Sample
  REAL(SINGLE), DIMENSION(:), ALLOCATABLE :: Cld_Hgt_Cold_Sample
  REAL(SINGLE) :: Cold_Threshold
  REAL(DOUBLE) :: Sum_Press
  REAL(DOUBLE) :: Sum_Press2



  ALLOCATE(Histogram(Number_Of_BrtTemp_Slots), source = 0)
  ALLOCATE(Slot_Values(Total_Points), source = MISSING_VALUE_INT2)
  ALLOCATE(Histogram_Sample1(Number_Of_BrtTemp_Slots), source = 0)
  ALLOCATE(Histogram_Sample2(Number_Of_BrtTemp_Slots), source = 0)
  ALLOCATE(Pressure_Cold_Sample(Total_Points), source = MISSING_VALUE_REAL8)
  ALLOCATE(Cld_Hgt_Cold_Sample(Total_Points), source = MISSING_VALUE_REAL4)
  ALLOCATE(BrtTemp_Cold_Sample(Total_Points), source = MISSING_VALUE_REAL4)

  Num_Call = Num_Call + 1

  ! ----------------------------------------------------------------------------
  ! Initialize variables
  ! ----------------------------------------------------------------------------

  IF (Channel .EQ. NATIVE_ABI_CHN8  .AND. CSWV_Flag .EQ. sym%YES .OR. &
      Channel .eq. NATIVE_ABI_CHN9  .AND. CSWV_Flag .EQ. sym%YES .OR. &
      Channel .EQ. NATIVE_ABI_CHN10 .AND. CSWV_Flag .EQ. sym%YES) THEN

    ! Clear-sky WV threshold

    Cold_Threshold = WVCS_COLD_THRESHOLD

  ELSE IF (Channel .EQ. NATIVE_ABI_CHN8 .AND. CSWV_Flag .EQ. sym%NO) THEN

    ! Cloud-top WV threshold

    Cold_Threshold = WVCT_COLD_THRESHOLD

  ELSE IF (Channel .EQ. NATIVE_ABI_CHN9 .AND. CSWV_Flag .EQ. sym%NO) THEN

    ! Cloud-top WV threshold

    Cold_Threshold = WVCT_COLD_THRESHOLD

  ELSE

    Cold_Threshold = IR_COLD_THRESHOLD

  ENDIF

  IF(Num_Call .EQ. 1) THEN
      WRITE(message, *) 'Cold_Threshold = ', Cold_Threshold
      CALL fw_log_debug(FUNC, message)
  ENDIF

  Inversion_Sample_Flag = sym%NO
  Data_Value = 0
  Histogram_Points = 0
  Count_Sample1 = 0
  Count_Sample2 = 0
  Point_Cutoff = 0
  Cold_Sample = 0
  Cold_Sample_Counter = 0
  Number_Of_Bins = 0
  Cold_Slot_Threshold = 0
  Sum_Press = 0.0
  Sum_Press2 = 0.0
  Variance_Press = 0.0

  ! Reshape 2-D arrays to 1-D.
  ! For the CSWV winds construct the histogram from brightness temperatures,
  ! otherwise use cloud-top temperatures.
  ALLOCATE(Input_Data(Total_Points))
  IF (CSWV_Flag .EQ. sym%YES) THEN
    Input_Data = RESHAPE(Box_Data%BrtTemp, (/Total_Points/))
  ELSE
    Input_Data = RESHAPE(Box_Data%Cld_Top_Temp, (/Total_Points/))
  ENDIF

  ALLOCATE(Cloud_Mask(Total_Points))
  Cloud_Mask = RESHAPE(Box_Data%Cloud_Mask, (/Total_Points/))

  ALLOCATE(Cloud_Top_Pressure(Total_Points))
  Cloud_Top_Pressure = RESHAPE(Box_Data%Cld_Top_Press, (/Total_Points/))

  ALLOCATE(Cld_Top_Press_Quality(Total_Points))
  Cld_Top_Press_Quality = RESHAPE(Box_Data%Cld_Top_Press_Quality, &
                                                (/Total_Points/))

  ALLOCATE(LL_Inver_Flag(Total_Points))
  LL_Inver_Flag = RESHAPE(Box_Data%LL_Inver, (/Total_Points/))

  ALLOCATE(Cld_Hgt(Total_Points))
  Cld_Hgt = RESHAPE(Box_Data%Cld_Hgt, (/Total_Points/))

  !WCB - add cloud height quality flag
  ALLOCATE(CldHgtQF(Total_Points))
  CldHgtQF = RESHAPE(Box_Data%CldHgtQF, (/Total_Points/))

  ! Set min/max bounds of histogram

  Lower_Bound = MAX(MINVAL(Input_Data), MIN_VALID_BT) *  SCALE_FACTOR
  Upper_Bound = MIN(MAXVAL(Input_Data), MAX_VALID_BT) *  SCALE_FACTOR

  ! ----------------------------------------------------------------------------
  ! Loop through data and fill histogram.
  ! ----------------------------------------------------------------------------

  data_loop: DO Point=1, Number_Of_Points

    ! filter out cloudy pixels for the clear-sky WV, otherwise
    ! check for clear pixels and missing CTP values

    IF (TRIM(NavType) .EQ. 'PS' .AND. CSWV_Flag .EQ. sym%YES) THEN

       ! for polar clear sky winds only check for cloudy pixels - 1/25/16
       IF (Cloud_Mask(Point) .EQ. SYM%CLOUDY) CYCLE

    ElSE IF (TRIM(NavType) .EQ. 'PS' .AND. CSWV_Flag .EQ. sym%NO) THEN

       ! for polar cloudy winds check for clear and prob clear pixels - 1/25/16
       IF (Cloud_Mask(Point) .EQ. SYM%CLEAR .OR. &
           Cloud_Mask(Point) .EQ. SYM%PROB_CLEAR .OR. &
           !WCB - add cloud height quality flag
           CldHgtQF(Point) .EQ. CTH_DQF_MARGINAL_RETREVIAL .OR.  &
           Cloud_Top_Pressure(Point) .EQ. MISSING_VALUE_REAL4) CYCLE

    ElSE IF (TRIM(NavType) .NE. 'PS' .AND. CSWV_Flag .EQ. sym%YES) THEN

       ! for geostationary clear sky winds check for both prob cloudy
       ! and cloudy pixels - 1/25/16

      IF (Cloud_Mask(Point) .EQ. SYM%CLOUDY .OR. &
          Cloud_Mask(Point) .EQ. SYM%PROB_CLOUDY) CYCLE

    ELSE IF (TRIM(NavType) .NE. 'PS' .AND. CSWV_Flag .EQ. sym%NO) THEN

      ! for geostationary cloudy winds check for both clear and prob clear
      ! pixels and missing CTP - 1/25/16

      IF (Cloud_Mask(Point) .EQ. SYM%CLEAR .OR. &
          Cloud_Mask(Point) .EQ. SYM%PROB_CLEAR  .OR. &
          !WCB - add cloud height quality flag
          CldHgtQF(Point) .EQ. CTH_DQF_MARGINAL_RETREVIAL .OR.  &
          Cloud_Top_Pressure(Point) .EQ. MISSING_VALUE_REAL4) CYCLE

    ENDIF

    ! Check for reasonable temperature values

    IF (Input_Data(Point) .EQ. MISSING_VALUE_REAL4 .OR. &
        Input_Data(Point) .LT. MIN_VALID_BT .OR. &
        Input_Data(Point) .GT. MAX_VALID_BT) CYCLE

    ! --------------------------------------------------------------------------
    ! Calculate which histogram slot data point falls into
    ! --------------------------------------------------------------------------

    Slot_Values(Point) = NINT(Input_Data(Point) * REAL( SCALE_FACTOR)) - &
                                                        BRTTEMP_MIN + 1

    Data_Value = Slot_Values(Point)

    ! --------------------------------------------------------------------------
    ! Check low-level inversion flag before adding point to correct histogram
    ! slot.
    ! --------------------------------------------------------------------------

    IF (LL_Inver_Flag(Point) .EQ. sym%YES) THEN

      Count_Sample2 = Count_Sample2 + 1
      Histogram_Sample2(Data_Value) = Histogram_Sample2(Data_Value) + 1

    ELSE

      Count_Sample1 = Count_Sample1 + 1
      Histogram_Sample1(Data_Value) = Histogram_Sample1(Data_Value) + 1

    ENDIF

  END DO data_loop

  ! Use sample with larger number of points

  IF (Count_Sample1 .GT. Count_Sample2) THEN

    Histogram(:) = Histogram_Sample1(:)
    Histogram_Points = Count_Sample1

  ELSE IF (Count_Sample1 .LE. Count_Sample2) THEN

    Histogram(:) = Histogram_Sample2(:)
    Histogram_Points = Count_Sample2
    Inversion_Sample_Flag = sym%YES

  ENDIF

  ! Set threshold number of points based on number of points in histogram
  ! and percentage.

  Point_Cutoff = NINT(REAL(Histogram_Points) * Cold_Threshold)

  ! Scan histogram from the cold end and determine cutoff slot

  threshold_loop: DO BrtTemp = Lower_Bound, Upper_Bound

    Cold_Sample = Cold_Sample + Histogram(BrtTemp)

    IF (Histogram(BrtTemp) .GT. 0) Number_Of_Bins = Number_Of_Bins + 1

    IF (Cold_Sample .GT. Point_Cutoff .AND. Number_Of_Bins .GT. 1) THEN

      Cold_Sample = Cold_Sample - Histogram(BrtTemp)
      Cold_Slot_Threshold = BrtTemp - 1
      EXIT

    ! Keep at least one histogram bin
    ELSE IF (Cold_Sample .GT. Point_Cutoff .AND. Number_Of_Bins .EQ. 1) THEN

      Cold_Sample = Cold_Sample
      Cold_Slot_Threshold = BrtTemp
      EXIT

    ELSE IF (Cold_Sample .LE. Point_Cutoff .AND. BrtTemp .EQ. Upper_Bound) THEN

      Cold_Sample = Cold_Sample
      Cold_Slot_Threshold = BrtTemp
      EXIT

    ENDIF

  END DO threshold_loop

  ! Identify cold sample. Keep track of temperature, pressure and cloud height.

  IF (Cold_Sample .GT. 0) THEN

    DO Point=1, Number_Of_Points

      IF (Slot_Values(Point) .NE. MISSING_VALUE_INT2 .AND. Slot_Values(Point) &
                     .LE. Cold_Slot_Threshold .AND. LL_Inver_Flag(Point) .EQ. &
                                                  Inversion_Sample_Flag) THEN

        ! Add point to cold sample array

        Cold_Sample_Counter = Cold_Sample_Counter + 1
        Pressure_Cold_Sample(Cold_Sample_Counter) = Cloud_Top_Pressure(Point)
        BrtTemp_Cold_Sample(Cold_Sample_Counter) = Input_Data(Point)
        Sum_Press2 = Sum_Press2 + Cloud_Top_Pressure(Point)**2
        Cld_Hgt_Cold_Sample(Cold_Sample_Counter) = Cld_Hgt(Point)

      ENDIF

    ENDDO

    ! Compute the variance of the cold sample

    IF (Cold_Sample_Counter .EQ. 1) THEN

      Sum_Press = Pressure_Cold_Sample(1)
      Variance_Press = 0.0

    ELSE IF (Cold_Sample_Counter .GT. 1) THEN

      Sum_Press = SUM(Pressure_Cold_Sample(1:Cold_Sample_Counter))
      Variance_Press = Sum_Press2 / Cold_Sample_Counter - &
                     (Sum_Press / Cold_Sample_Counter)**2

    ENDIF

    ! Copy array data to target box data structure

    Box_Data%Pressure_Cold_Sample(:) = Pressure_Cold_Sample(:)
    Box_Data%BrtTemp_Cold_Sample(:) = BrtTemp_Cold_Sample(:)
    Box_Data%Cld_Hgt_Cold_Sample(:) = Cld_Hgt_Cold_Sample(:)

  ENDIF

  DEALLOCATE(Histogram, Histogram_Sample1, Histogram_Sample2, Slot_Values, &
        Input_Data, Cloud_Mask, Cloud_Top_Pressure, Cld_Top_Press_Quality, &
                 LL_Inver_Flag, Pressure_Cold_Sample, BrtTemp_Cold_Sample, &
                                             Cld_Hgt_Cold_Sample, Cld_Hgt, &
                                             !WCB - add cloud height quality
                                             !flag
                                             CldHgtQF)


END SUBROUTINE Make_Histogram_Temp

! ------------------------------------------------------------------------------
!
! Name:
!   Gaussian_Fit
!
! Function:
!   Fit two half-Gaussian curves to a histogram peak
!
! Description:
!
! Reference:
!   None
!
! Calling sequence:
!   CALL Gaussian_Fit
!
! Inputs:
!   Center_Point         Center histogram point (i.e., peak) to fit curve to
!   Histogram            Array of histogram values
!
! Outputs:
!   Avg_Variance_LHS     Variance describing left-hand-side Gaussian curve
!   Avg_Variance_RHS     Variance describing right-hand-side Gaussian curve
!
! Dependencies:
!
! Restrictions:
!
! History:
!   5/2007 - Wayne Bresky - Created
!   9/2016 - Updated for boundary check
!
!-------------------------------------------------------------------------------
SUBROUTINE Gaussian_Fit(Center_Point, Histogram, Avg_Variance_LHS, &
                                                 Avg_Variance_RHS)

  INTEGER(LONG), INTENT(IN) :: Center_Point
  INTEGER(LONG), INTENT(IN), DIMENSION(:) :: Histogram
  INTEGER(LONG)  :: Second_Point
  INTEGER(LONG)  :: Non_Zero_Count_LHS
  INTEGER(LONG)  :: Non_Zero_Count_RHS
  INTEGER(LONG)  :: Lower_Bound
  INTEGER(LONG)  :: Upper_Bound

  REAL(SINGLE), INTENT(OUT) :: Avg_Variance_LHS
  REAL(SINGLE), INTENT(OUT) :: Avg_Variance_RHS
  REAL(SINGLE) :: Value1_Center
  REAL(SINGLE) :: Value2_Center
  REAL(SINGLE) :: Average_Value_Center
  REAL(SINGLE) :: Value1_Second
  REAL(SINGLE) :: Value2_Second
  REAL(SINGLE) :: Average_Value_Second
  REAL(SINGLE) :: Denominator
  REAL(SINGLE) :: Numerator
  REAL(SINGLE) :: Central_Frequency
  REAL(SINGLE) :: Second_Frequency
  REAL(SINGLE) :: Variance
  REAL(SINGLE) :: Sum_Variance_LHS
  REAL(SINGLE) :: Sum_Variance_RHS

  ! ----------------------------------------------------------------------------
  ! Initialize variables
  ! ----------------------------------------------------------------------------

  Non_Zero_Count_LHS = 0
  Non_Zero_Count_RHS = 0
  Value1_Center = 0.0
  Value2_Center = 0.0
  Average_Value_Center = 0.0
  Central_Frequency = 0.0
  Value1_Second = 0.0
  Value2_Second = 0.0
  Average_Value_Second = 0.0
  Second_Frequency = 0.0
  Numerator = 0.0
  Denominator = 0.0
  Avg_Variance_LHS = 0.0
  Avg_Variance_RHS = 0.0
  Sum_Variance_LHS = 0.0
  Sum_Variance_RHS = 0.0
  Lower_Bound = 0
  Upper_Bound = NUMBER_OF_SLOTS

  ! ----------------------------------------------------------------------------
  ! Compute average value of center point.
  ! Note: Averaging may be unneccessary. Might use actual value of peak.
  ! ----------------------------------------------------------------------------

  Value1_Center = MIN_HISTOGRAM_VALUE + REAL(Center_Point - 1) * INTERVAL_LENGTH
  Value2_Center = Value1_Center + INTERVAL_LENGTH
  Average_Value_Center = (Value1_Center + Value2_Center) / 2.0
  Central_Frequency = REAL(Histogram(Center_Point))

  IF (Central_Frequency .LT. 0.0) Central_Frequency = 0.0

  point_loop: DO Second_Point = Center_Point - 3, Center_Point + 3

    ! --------------------------------------------------------------------------
    ! Avoid center point and bounds of histogram
    ! --------------------------------------------------------------------------

    !IF (Second_Point .EQ. Center_Point) CYCLE
    IF (Second_Point .EQ. Center_Point .OR. &
        Second_Point .LE. Lower_Bound .OR. &
        Second_Point .GT. Upper_Bound) CYCLE

    Value1_Second = MIN_HISTOGRAM_VALUE + REAL(Second_Point - 1) &
                                               * INTERVAL_LENGTH
    Value2_Second = Value1_Second + INTERVAL_LENGTH
    Average_Value_Second = (Value1_Second + Value2_Second) / 2.0
    Second_Frequency = REAL(Histogram(Second_Point))

    IF (Second_Frequency .LT. 0.0) Second_Frequency = 0.0

    IF (Second_Frequency .NE. 0.0 .AND. Central_Frequency .NE. 0.0 .AND. &
                           Second_Frequency .NE. Central_Frequency) THEN
      Numerator = -1.0 * (Average_Value_Second - Average_Value_Center)**2
      Denominator = 2.0 * ALOG(Second_Frequency / Central_Frequency)
      Variance = Numerator/Denominator
    ELSE
      Variance = 0.0
    ENDIF

    ! --------------------------------------------------------------------------
    ! Count number of non-zero variance estimates.
    ! --------------------------------------------------------------------------

    IF (Variance .GT. 0.0 .AND. Second_Point .LT. Center_Point) THEN
      Non_Zero_Count_LHS = Non_Zero_Count_LHS + 1
      Sum_Variance_LHS = Sum_Variance_LHS + Variance
    ELSE IF (Variance .GT. 0.0 .AND. Second_Point .GT. Center_Point) THEN
      Non_Zero_Count_RHS = Non_Zero_Count_RHS + 1
      Sum_Variance_RHS = Sum_Variance_RHS + Variance
    ENDIF

  END DO point_loop

  ! ----------------------------------------------------------------------------
  ! Determine average variance for each half curve.
  ! ----------------------------------------------------------------------------

  IF (Non_Zero_Count_LHS .GT. 0) Avg_Variance_LHS = Sum_Variance_LHS / &
                                              REAL(Non_Zero_Count_LHS)
  IF (Non_Zero_Count_RHS .GT. 0) Avg_Variance_RHS = Sum_Variance_RHS / &
                                              REAL(Non_Zero_Count_RHS)

END SUBROUTINE Gaussian_Fit
! ------------------------------------------------------------------------------
!
! Name:
!   Gaussian_Curve
!
! Function:
!  Compute the full Gaussian curve from two half-Gaussian estimates.
!
! Description:
!   - Determine interval over which the Gaussian is to be computed (-/+ 5 S.D.)
!   - Evaluate Gaussian function
!
! Reference:
!   None
!
! Calling sequence:
!   CALL Gaussian_Curve
!
! Inputs:
!   Max_Frequency_Slot   Center point of Gaussian curve.
!   Max_Frequency        Frequency at center of histogram.
!   Variance_LHS         Variance estimate for left side of curve.
!   Variance_RHS         Variance estimate for right side of curve.
!
! Outputs:
!   Gaussian_Histogram   Full Gaussian histogram.
!
! Dependencies:
!
! Restrictions:
!
! History:
!   5/2007 - Wayne Bresky - Created
!
!-------------------------------------------------------------------------------
SUBROUTINE Gaussian_Curve(Max_Frequency_Slot, Max_Frequency, Variance_LHS, &
                                         Variance_RHS, Gaussian_Histogram)

  INTEGER(LONG), INTENT(IN) :: Max_Frequency, Max_Frequency_Slot
  INTEGER(LONG), INTENT(OUT), DIMENSION(:) :: Gaussian_Histogram
  INTEGER(LONG) :: Slot_High, Slot_Low, Slot_Number

  REAL(SINGLE), INTENT(IN) :: Variance_LHS, Variance_RHS
  REAL(SINGLE) :: Radiance_Center_Avg, Radiance_Center_High, Radiance_Center_Low
  REAL(SINGLE) :: Radiance_Point_Avg, Radiance_Point_High, Radiance_Point_Low
  REAL(SINGLE) :: Gaussian_Exponent, Variance

  ! ----------------------------------------------------------------------------
  ! Initialize variables
  ! ----------------------------------------------------------------------------

  Radiance_Center_Low = 0.0
  Radiance_Center_High = 0.0
  Radiance_Center_Avg = 0.0
  Radiance_Point_Low = 0.0
  Radiance_Point_High = 0.0
  Radiance_Point_Avg = 0.0
  Gaussian_Histogram(1:NUMBER_OF_SLOTS) = 0

  Radiance_Center_Low = MIN_HISTOGRAM_VALUE + REAL(Max_Frequency_Slot - 1) &
                                                         * INTERVAL_LENGTH
  Radiance_Center_High = Radiance_Center_Low + INTERVAL_LENGTH
  Radiance_Center_Avg = (Radiance_Center_Low + Radiance_Center_High) / 2.0

  ! ----------------------------------------------------------------------------
  ! Set interval as -/+ 5 standard deviation units
  ! ----------------------------------------------------------------------------

  Slot_Low = Max_Frequency_Slot - NINT(5.0 * SQRT(Variance_LHS))
  Slot_High = Max_Frequency_Slot + NINT(5.0 * SQRT(Variance_RHS))
  IF (Slot_Low .LT. 1) Slot_Low = 1
  IF (Slot_High .GT. NUMBER_OF_SLOTS) Slot_High = NUMBER_OF_SLOTS

  slot_loop: DO Slot_Number = Slot_Low, Slot_High

    Gaussian_Exponent = MISSING_VALUE_REAL4

    IF (Slot_Number .LE. Max_Frequency_Slot) Variance = Variance_LHS
    IF (Slot_Number .GT. Max_Frequency_Slot) Variance = Variance_RHS

    Radiance_Point_Low = MIN_HISTOGRAM_VALUE + REAL(Slot_Number - 1) * &
                                                       INTERVAL_LENGTH
    Radiance_Point_High = Radiance_Point_Low + INTERVAL_LENGTH
    Radiance_Point_Avg = (Radiance_Point_Low + Radiance_Point_High) / 2.0
    IF (Variance .GT. 0.0) Gaussian_Exponent = -1.0 * (Radiance_Point_Avg &
                             - Radiance_Center_Avg)**2 / (2.0 * Variance)

    ! --------------------------------------------------------------------------
    ! Evaluate Gaussian function
    ! --------------------------------------------------------------------------

    IF (Gaussian_Exponent .LT. LOWER_GAUSSIAN_EXPONENT) THEN
      Gaussian_Histogram(Slot_Number) = 0
    ELSE
      Gaussian_Histogram(Slot_Number) = INT(Max_Frequency * &
                                    EXP(Gaussian_Exponent))
    ENDIF

  END DO slot_loop

END SUBROUTINE Gaussian_Curve

!-------------------------------------------------------------------------------
!
! Name:
!   Gross_Error_Checks
!
! Function:
!   Apply gross error checks to AMV and flag suspect winds
!
! Description:
!   Check AMV wind components for large accelerations and apply channel-specific
!   tests using the forecast wind estimate.
!
! Reference:
!
! Inputs:
!   U1               First vector u-component
!   U2               Second vector u-component
!   V1               First vector v-component
!   V2               Second vector v-component
!   U_Fcst           Forecast u-component
!   V_Fcst           Forecast v-component
!   Median_P         Median pressure assignment of AMV
!
! Output:
!   QC_Flag          Quality flag. A value greater than 0 indicates the AMV
!                    has failed some test.
!
! Dependencies:
!   None
!
! Restrictions:
!   None
!
! History:
!   02/09/2009 - Wayne Bresky - Created with input from Chris Velden
!                               and Steve Wanzong of CIMSS
!   11/22/2021 - Wayne Bresky - Implement pressure cutoff thresholds for various 
!                               cloud types
!
!-------------------------------------------------------------------------------


SUBROUTINE Gross_Error_Checks(NavType, U1, U2, V1, V2, U_Fcst, V_Fcst, Median_PW, DomCldType, QC_Flag)

  ! AMV quality control flag
  INTEGER(LONG), INTENT(INOUT) :: QC_Flag
  ! dominant cloud type of target scene
  INTEGER(LONG), INTENT(IN) :: DomCldType

  ! AMV vector components
  REAL(SINGLE), INTENT(IN) :: U1
  REAL(SINGLE), INTENT(IN) :: U2
  REAL(SINGLE), INTENT(IN) :: V1
  REAL(SINGLE), INTENT(IN) :: V2
  REAL(SINGLE), INTENT(IN) :: Median_PW
  REAL(SINGLE) ::  U_Avg
  REAL(SINGLE) ::  V_Avg
  REAL(SINGLE) ::  Speed_AMV
  REAL(SINGLE) ::  Dir_AMV

  REAL(SINGLE)  Vec_Diff
  REAL(SINGLE)  Vec_Diff_Cutoff

  ! Forecast vector components
  REAL(SINGLE), INTENT(IN) :: U_Fcst
  REAL(SINGLE), INTENT(IN) :: V_Fcst


  ! Max acceleration threshold
  REAL(SINGLE) :: Max_Acceleration

  ! Component accelerations
  REAL(SINGLE) :: U_Acceleration
  REAL(SINGLE) :: V_Acceleration


  CHARACTER(LEN=*), INTENT(IN) :: NavType

  ! ----------------------------------------------------------------------------
  ! Check wind component accelerations and flag those exceeding max limit
  ! ----------------------------------------------------------------------------

  Max_Acceleration = ACCEL_THRESHOLD
  IF (Channel .EQ. NATIVE_ABI_CHN2) Max_Acceleration = ACCEL_THRESHOLD_VZ

  U_Acceleration = ABS(U2 - U1)
  V_Acceleration = ABS(V2 - V1)

  IF (U_Acceleration .GT. Max_Acceleration .AND. &
      V_Acceleration .LE. Max_Acceleration) THEN

    QC_Flag = U_ACCELERATION_FAILURE
    RETURN

  ELSE IF (U_Acceleration .LE. Max_Acceleration .AND. &
           V_Acceleration .GT. Max_Acceleration) THEN

    QC_Flag = V_ACCELERATION_FAILURE
    RETURN

  ELSE IF (U_Acceleration .GT. Max_Acceleration .AND. &
           V_Acceleration .GT. Max_Acceleration) THEN

    QC_Flag = UV_ACCELERATION_FAILURE
    RETURN

  ENDIF

  ! ----------------------------------------------------------------------------
  ! Compute average wind.
  ! ----------------------------------------------------------------------------

  U_Avg = (U1 + U2) / 2.0
  V_Avg = (V1 + V2) / 2.0

  CALL UV2Spd(Speed_AMV, Dir_AMV, U_Avg, V_Avg)

  ! ----------------------------------------------------------------------------
  ! Flag slow winds.
  ! ----------------------------------------------------------------------------

  IF (Speed_AMV .LT. 3.0) THEN

    QC_Flag = SLOW_WIND_FAILURE
    RETURN

  ENDIF

  ! WCB
  ! Implement pressure limit on thick ice, cirrus, supercooled and liquid cloud scenes and
  ! discard all mixed cloud types. Applied only to cloud-track winds.
  IF (TRIM(NavType) .NE. 'PS' ) THEN

    IF (CSWV_Flag .EQ. sym%NO) THEN

      IF (DomCldType .EQ. sym%MIXED_TYPE) THEN

        QC_Flag = GROSS_ERROR_FAILURE
        RETURN

      ENDIF

      IF (Median_PW .GT. 500. .AND. (DomCldType .EQ. sym%TICE_TYPE .OR. DomCldType .EQ. sym%CIRRUS_TYPE)) THEN
        QC_Flag = GROSS_ERROR_FAILURE
        RETURN

      ENDIF

      IF (Median_PW .LT. 500. .AND. (DomCldType .EQ. sym%WATER_TYPE .OR. DomCldType .EQ. sym%SUPERCOOLED_TYPE)) THEN
        QC_Flag = GROSS_ERROR_FAILURE
        RETURN

      ENDIF

    ENDIF

  ENDIF

  ! ----------------------------------------------------------------------------
  ! Convert forecast u-/v-components to speed and direction
  ! ----------------------------------------------------------------------------

  !For additional possible tests:
  !CALL UV2Spd(Speed_Fcst, Dir_Fcst, U_Fcst, V_Fcst)
  !Speed_Diff = Speed_AMV - Speed_Fcst
  !Abs_Dir_Diff1 = ABS( Dir_AMV - Dir_Fcst )
  !Abs_Dir_Diff2 = ABS( ABS( (Dir_Fcst - Dir_AMV) ) - DEGREE360 )

  Vec_Diff = SQRT( (U_Avg - U_Fcst)**2 + (V_Avg - V_Fcst)**2 )

  ! ----------------------------------------------------------------------------
  ! Apply channel-specific gross error checks using the forecast wind.
  ! ----------------------------------------------------------------------------

  IF (Channel .EQ. NATIVE_ABI_CHN2) THEN

    Vec_Diff_Cutoff = VEC_DIFF_VZ

  ELSE IF (Channel .EQ. NATIVE_ABI_CHN7) THEN

    Vec_Diff_Cutoff = VEC_DIFF_SWIR

  ELSE IF (Channel .EQ. NATIVE_ABI_CHN8 .AND. CSWV_Flag .EQ. sym%NO) THEN

    Vec_Diff_Cutoff = VEC_DIFF_WVCT8

  ELSE IF (Channel .EQ. NATIVE_ABI_CHN8 .AND. CSWV_Flag .EQ. sym%YES) THEN

    Vec_Diff_Cutoff = VEC_DIFF_WVCS8

  ELSE IF (Channel .EQ. NATIVE_ABI_CHN9) THEN

    Vec_Diff_Cutoff = VEC_DIFF_WVCS9

  ELSE IF (Channel .EQ. NATIVE_ABI_CHN10) THEN

    Vec_Diff_Cutoff = VEC_DIFF_WVCS10

  ELSE IF (Channel .EQ. NATIVE_ABI_CHN14 .AND. TRIM(NavType) .NE. 'PS') THEN

    Vec_Diff_Cutoff = VEC_DIFF_LWIR

  ELSE IF (Channel .EQ. NATIVE_ABI_CHN14 .AND. TRIM(NavType) .EQ. 'PS') THEN

    Vec_Diff_Cutoff = VEC_DIFF_LWIR_POLAR

  ENDIF

  IF (Vec_Diff .GT. Vec_Diff_Cutoff) THEN

    QC_Flag = GROSS_ERROR_FAILURE
    RETURN

  ENDIF

  QC_Flag = GOOD_TARGET

END SUBROUTINE Gross_Error_Checks




!-------------------------------------------------------------------------------
!
! Name:
!   UV2Spd
!
! Function:
!   Converts the u- and v-components of a wind vector to speed and direction.
!
! Description:
!   This routine takes the u- and v-components of a wind vector and converts
!   them to speed and direction.
!
! Reference:
!   None.
!
! Calling Sequence:
!   CALL UV2Spd
!
! Inputs:
!   U                        U-component wind (a west wind is positive)
!   V                        V-component wind (a south wind is positive)
!
! Outputs:
!   Spd                      Wind speed (m/s)
!   Dir                      Wind direction (degrees)
!
! Dependencies:
!   None.
!
! Restrictions:
!   None.
!
! History:
! 08/2009 - Wayne Bresky - Created
! ------------------------------------------------------------------------------
SUBROUTINE UV2Spd(Spd,Dir,U,V)

  REAL(SINGLE), PARAMETER :: RADDEG = DTOR**(-1)
  REAL(SINGLE) :: Spd
  REAL(SINGLE) :: Dir
  REAL(SINGLE), INTENT(IN) :: U
  REAL(SINGLE), INTENT(IN) :: V
  REAL(SINGLE) :: Ang

  IF (U .EQ. 0. .AND. V .EQ. 0.) THEN
    Spd = 0.
    Dir = 0.
    RETURN
  ENDIF

  Spd = SQRT(U*U + V*V)
  IF (U .EQ. 0. .AND. V .LT. 0.) THEN
    Dir = DEGREE0
  ELSE IF (V .EQ. 0. .AND. U .LT. 0.) THEN
    Dir = DEGREE90
  ELSE IF (U .EQ. 0. .AND. V .GT. 0.) THEN
    Dir = DEGREE180
  ELSE IF (V .EQ. 0. .AND. U .GT. 0.) THEN
    Dir = DEGREE270
  ELSE IF (U .LT. 0. .AND. V .LT. 0.) THEN
    Ang = ASIN(ABS(U)/Spd)
    Dir = Ang*RADDEG
  ELSE IF (U .LT. 0. .AND. V .GT. 0.) THEN
    Ang = ASIN(ABS(V)/Spd)
    Dir = Ang*RADDEG + DEGREE90
  ELSE IF (U .GT. 0. .AND. V .GT. 0.) THEN
    Ang = ASIN(ABS(U)/Spd)
    Dir = Ang*RADDEG + DEGREE180
  ELSE IF (U .GT. 0. .AND. V .LT. 0.) THEN
    Ang = ASIN(ABS(V)/Spd)
    Dir = Ang*RADDEG + DEGREE270
  ENDIF

  RETURN

END SUBROUTINE UV2Spd

!-------------------------------------------------------------------------------
!
! Name:
!   Spd2UV
!
! Function:
!   Converts speed and direction to u- and v-components.
!
! Description:
!   This routine decomposes a wind vector into u- and v-components.
!
! Reference:
!   None.
!
! Calling Sequence:
!   CALL Spd2UV
!
! Inputs:
!   Spd                      Wind speed (m/s)
!   Dir                      Wind direction (degrees)
!
! Outputs:
!   U                        U-component wind (a west wind is positive)
!   V                        V-component wind (a south wind is positive)
!
! Dependencies:
!   None.
!
! Restrictions:
!   None.
!
! History:
! 08/2009 - Wayne Bresky - Created
! ------------------------------------------------------------------------------
SUBROUTINE Spd2UV(Spd,Dir,U,V)

  REAL(SINGLE) :: Spd
  REAL(SINGLE) :: Dir
  REAL(SINGLE) :: U
  REAL(SINGLE) :: V
  REAL(SINGLE) :: Ang

  IF (Spd .EQ. 0.) THEN
    U = 0.
    V = 0.
    RETURN
  ENDIF

  IF (Dir .EQ. DEGREE0 .OR. Dir .EQ. DEGREE360) THEN
    U = 0.
    V = - Spd
  ELSE IF (Dir .EQ. DEGREE90) THEN
    U = -Spd
    V = 0.
  ELSE IF (Dir .EQ. DEGREE180) THEN
    U = 0.
    V = Spd
  ELSE IF (Dir .EQ. DEGREE270) THEN
    U = Spd
    Dir = 0.
  ELSE IF (Dir .GT. DEGREE0 .AND. Dir .LT. DEGREE90) THEN
    Ang = Dir*DTOR
    U = - Spd*SIN(Ang)
    V = - Spd*COS(Ang)
  ELSE IF (Dir .GT. DEGREE90 .AND. Dir .LT. DEGREE180) THEN
    Ang = (Dir- DEGREE90)*DTOR
    U = - Spd*COS(Ang)
    V =   Spd*SIN(Ang)
  ELSE IF (Dir .GT. DEGREE180 .AND. Dir .LT. DEGREE270) THEN
    Ang = (Dir - DEGREE180)*DTOR
    U =   Spd*SIN(Ang)
    V =   Spd*COS(Ang)
  ELSE IF (Dir .GT. DEGREE270 .AND. Dir .LT. DEGREE360) THEN
    Ang = (Dir - DEGREE270)*DTOR
    U =   Spd*COS(Ang)
    V = - Spd*SIN(Ang)
  ENDIF

  RETURN

END SUBROUTINE Spd2UV

!-------------------------------------------------------------------------------
!
! Name:
!   Compute_Zenith_Angle
!
! Function:
!   Computes the satellite zenith angle for a given earth location
!
! Description:
!   Computes the satellite zenith angle for a given latitude and longitude.
!   The satellite location is also required.
!
! Reference:
!   None.
!
! Calling Sequence:
!   CALL Compute_Zenith_Angle
!
! Inputs:
!   glon                     Satellite longitude
!   glat                     Satellite latitude
!   xlon                     Longitude of pixel
!   xlat                     Latitude of pixel
!
! Outputs:
!   zenith                   Satellite zenith angle
!
! Dependencies:
!   None.
!
! Restrictions:
!   None.
!
! History:
! 08/2009 - Wayne Bresky - Created
! ------------------------------------------------------------------------------
SUBROUTINE Compute_Zenith_Angle(glon, glat, xlon, xlat, zenith)

  REAL(SINGLE), INTENT(IN)  :: glon
  REAL(SINGLE), INTENT(IN)  :: glat
  REAL(SINGLE), INTENT(IN)  :: xlon
  REAL(SINGLE), INTENT(IN)  :: xlat
  REAL(SINGLE), INTENT(OUT) :: zenith

  ! Local variables
  REAL(DOUBLE) :: satlon
  REAL(DOUBLE) :: satlat
  REAL(DOUBLE) :: lat
  REAL(DOUBLE) :: lon
  REAL(DOUBLE) :: beta
  REAL(DOUBLE) :: sin_beta

  zenith = MISSING_VALUE_REAL4

  satlon = glon
  satlat = glat


  lon = (xlon - satlon) * DTOR   ! in radians
  lat = (xlat - satlat) * DTOR   ! in radians

  beta = ACOS( COS(lat) * COS(lon) )
  sin_beta = SIN(beta)

  ! zenith angle
  ! R**2 + (R+h)**2 = 1.808e09
  ! 2R(R+h) = 5.37e08
  ! R is the radius of the earth and h is the height of the satellite

  zenith = ASIN(MAX(-1.0_real8, MIN(1.0_real8, 42164.0* sin_beta / &
                                 SQRT(1.808e09 - 5.3725e08*COS(beta)))))
  zenith = zenith / DTOR

END SUBROUTINE Compute_Zenith_Angle

!-------------------------------------------------------------------------------
!
! Name:
!   Fill_Search_Box
!
! Function:
!   Loads data from the temporal data buffer into search box.
!
! Description:
!   This routine loads brightness temperature data from the buffer into the
!   search box. It requires the input of the target center point and the
!   forecast displacement in pixels.
!
! Reference:
!   None.
!
! Calling Sequence:
!   CALL Fill_Search_Box
!
! Inputs:
!   Target_Center_Element      Image element of target box center point
!   Target_Center_Line         Image line of target box center point
!   Delta_X                    Forecast element displacement
!   Delta_Y                    Forecast line displacement
!   Search_Half_Width_Line     Half the number of lines in the search region
!   Search_Half_Width_Element  Half the number of elements in the search region
!   Lines_In_Buffer            Total number of lines in the data buffer
!   Search_Buffer              Temporal brightness temperature data
!
! Outputs:
!   Search_BrtTemp_Values      Search box brightness temperature values
!   QC_Flag                    Status flag
!
! Dependencies:
!   Requires the temporal data buffers (first and third images) be full.
!
! Restrictions:
!   None.
!
! History:
! 08/2009 - Wayne Bresky - Created
! ------------------------------------------------------------------------------
SUBROUTINE  Fill_Search_Box(Elems, Target_Center_Element, Target_Center_Line, &
                             Delta_X, Delta_Y, Search_Half_Width_Line, &
                           Search_Half_Width_Element, Lines_In_Buffer, &
                        Search_Buffer, Search_BrtTemp_Values, QC_Flag)

  ! buffer coordinates of target box center
  INTEGER(LONG), INTENT(IN) :: Target_Center_Line
  INTEGER(LONG), INTENT(IN) :: Target_Center_Element
  ! buffer coordinates of search box center
  INTEGER(LONG) Search_Center_Line
  INTEGER(LONG) Search_Center_Element
  INTEGER(LONG), INTENT(IN) :: Search_Half_Width_Element
  INTEGER(LONG), INTENT(IN) :: Search_Half_Width_Line
  INTEGER(LONG), INTENT(IN) :: Lines_In_Buffer
  INTEGER(LONG), INTENT(INOUT) :: QC_Flag
  INTEGER(LONG) Search_Start_Line
  INTEGER(LONG) Search_End_Line
  INTEGER(LONG) Search_Start_Element
  INTEGER(LONG) Search_End_Element
  INTEGER(LONG) :: Search_Line_Size
  INTEGER(LONG) :: Search_Element_Size

  ! distance between target box center and search box center
  REAL(SINGLE), INTENT(IN) :: Delta_X
  REAL(SINGLE), INTENT(IN) :: Delta_Y
  REAL(SINGLE), DIMENSION(:,:), INTENT(IN) :: Search_Buffer
  REAL(SINGLE), DIMENSION(:,:), INTENT(INOUT) :: Search_BrtTemp_Values

  INTEGER(LONG), INTENT(IN) :: Elems


  ! Compute nominal bounds of search region in buffer

  Search_Center_Element = Target_Center_Element + INT(Delta_X)
  Search_Center_Line = Target_Center_Line + INT(Delta_Y)

  Search_Start_Line = Search_Center_Line - Search_Half_Width_Line
  Search_End_Line = Search_Center_Line + Search_Half_Width_Line
  Search_Start_Element = Search_Center_Element - Search_Half_Width_Element
  Search_End_Element = Search_Center_Element + Search_Half_Width_Element


  ! Center search on expected location. Do not exceed bounds of buffer.

  Search_Start_Line = MAX(1, Search_Start_Line)
  Search_End_Line = MIN(Lines_In_Buffer, Search_End_Line)
  Search_Line_Size = Search_End_Line - Search_Start_Line + 1
  Search_Start_Element = MAX(1, Search_Start_Element)
  Search_End_Element = MIN(Elems, Search_End_Element)
  Search_Element_Size = Search_End_Element - Search_Start_Element + 1

  ! Fail if we do not have a full-sized search box.

  IF (Search_Line_Size .LT. (Search_Half_Width_Line * 2 + 1) .OR. &
    Search_Element_Size .LT. (Search_Half_Width_Element * 2 + 1)) THEN

    QC_Flag = SEARCH_NOT_FULL_FAILURE
    RETURN

  ELSE

    Search_BrtTemp_Values(1:Search_Element_Size, 1:Search_Line_Size) = &
                Search_Buffer(Search_Start_Element:Search_End_Element, &
                                    Search_Start_Line:Search_End_Line)
  ENDIF

  !IF (ANY(Search_BrtTemp_Values == MISSING_VALUE_REAL4)) QC_Flag = MISSING_DATA_SEARCH
  IF (ALL(Search_BrtTemp_Values == MISSING_VALUE_REAL4)) QC_Flag = MISSING_DATA_SEARCH

END SUBROUTINE Fill_Search_Box

!-------------------------------------------------------------------------------
!
! Name:
!   Compute_End_Points
!
! Function:
!   Computes the end point of a vector in earth coordinates
!
! Description:
!   Given a starting point and displacement expressed in pixel coordinates,
!   this routine computes the end point in earth coordinates.
!
! Reference:
!   None.
!
! Calling Sequence:
!   CALL Compute_End_Points
!
! Inputs:
!   Search_Element           Image element of starting point
!   Element_Disp             Element displacement
!   Search_Line              Image line of starting point
!   Line_Disp                Line displacement
!   Sat_ID                   Satellite ID
!
! Outputs:
!   Lat_Match                Latitude of vector end point
!   Lon_Match                Longitude of vector end point
!
! Dependencies:
!   None.
!
! Restrictions:
!   None.
!
! History:
! 08/2009 - Wayne Bresky - Created
! 01/2012 - Wayne Bresky - Added PS map projection
! ------------------------------------------------------------------------------
SUBROUTINE Compute_End_Points(Nav, Search_Element, Element_Disp, Search_Line, &
                              Line_Disp, Lat_Match, Lon_Match)
  TYPE(Nav_t), INTENT(IN):: Nav

  REAL(SINGLE), INTENT(IN) :: Search_Element
  REAL(SINGLE), INTENT(IN) :: Search_Line
  REAL(SINGLE), INTENT(IN) :: Element_Disp
  REAL(SINGLE), INTENT(IN) :: Line_Disp
  REAL(SINGLE) Match_Element
  REAL(SINGLE) Match_Line
  REAL(SINGLE), INTENT(OUT) :: Lat_Match
  REAL(SINGLE), INTENT(OUT) :: Lon_Match

  REAL(DOUBLE) :: Latitude
  REAL(DOUBLE) :: Longitude




  ! Compute the endpoints of both vectors in image coordinates and convert
  ! to earth location.

  SELECT CASE (Nav%Sensor_Series)

  CASE (SERIES_MSG_SEVIRI)

    ! reverse sign of element displacement to account for EUMETSAT
    ! coordinate system

    Match_Element = Search_Element - Element_Disp
    Match_Line = Search_Line - Line_Disp
    CALL pixcoord2geocoord_dp(Nav, Match_Element, Match_Line, Latitude, Longitude)

    Lat_Match = REAL(Latitude)
    Lon_Match = REAL(Longitude)

!  CASE (SERIES_GOES_N_IMG)
!
!    Match_Element = Search_Element + Element_Disp
!    Match_Line = Search_Line + Line_Disp
!    CALL pixcoord2geocoord_gvar(Match_Element, Match_Line, &
!                          sat_xstride, Lat_Match, Lon_Match)

  CASE (SERIES_GOESR_ABI, SERIES_HIMAWARI_AHI)

    Match_Element = Search_Element + Element_Disp
    Match_Line = Search_Line + Line_Disp
    CALL pixcoord2geocoord_abi_real(Nav, Match_Element, Match_Line, &
                                         Latitude, Longitude)

    Lat_Match = REAL(Latitude)
    Lon_Match = REAL(Longitude)

    ! Because JMA sets their longitudes from 0 to 360, and
    ! we want 180 to -180, we need to switch here for longitudes
    ! that are greater than 180.

    IF (Lon_Match > 180.0) Lon_Match = Lon_Match - 360.0

  END SELECT

  ! polar winds test
  IF (TRIM(Nav%NavType) .EQ. 'PS' ) THEN

    Match_Element = Search_Element + Element_Disp
    Match_Line = Search_Line + Line_Disp
    CALL pixcoord2geocoord_ps(Nav, Match_Element, Match_Line, Lat_Match, Lon_Match)

    Lon_Match = -Lon_Match

  ENDIF

END SUBROUTINE Compute_End_Points

!-------------------------------------------------------------------------------
!
! Name:
!   Pixel_Factor
!
! Function:
!   Computes the ratio of E-W distance to N-S distance for a pixel
!
! Description:
!   Computes the ratio of x-distance to y-distance for a given pixel location.
!   This ratio is useful for normalizing a displacement expressed in elements
!   to a displacement expressed in lines without having to repeatedly transform
!   between pixel coordinates and earth coordinates.
!
! Reference:
!   None.
!
! Calling Sequence:
!   CALL Pixel_Factor
!
! Inputs:
!   Sat_ID                   Satellite ID
!   Point1_Element           Image element
!   Point1_Line              Image Line
!
! Outputs:
!   Factor                   Ratio of E-W distance to N-S distance
!
! Dependencies:
!   None.
!
! Restrictions:
!   None.
!
! History:
! 1/2010 - Wayne Bresky - Created
! ------------------------------------------------------------------------------
SUBROUTINE Pixel_Factor(Nav, Point1_Element, Point1_Line, Factor)
  CHARACTER(LEN=*), PARAMETER :: ROUTINE_NAME = "Pixel_Factor"
  TYPE(Nav_t), INTENT(IN):: Nav
  REAL(SINGLE), INTENT(IN) :: Point1_Element
  REAL(SINGLE), INTENT(IN) :: Point1_Line
  REAL(SINGLE), INTENT(OUT) :: Factor
  REAL(DOUBLE) Point1_Lat
  REAL(DOUBLE) Point1_Lon
  REAL(DOUBLE) Point2_Lat
  REAL(DOUBLE) Point2_Lon
  REAL(DOUBLE) Point3_Lat
  REAL(DOUBLE) Point3_Lon
  REAL(SINGLE) Pt1_Lat_Single
  REAL(SINGLE) Pt1_Lon_Single
  REAL(SINGLE) Pt2_Lat_Single
  REAL(SINGLE) Pt2_Lon_Single
  REAL(SINGLE) Pt3_Lat_Single
  REAL(SINGLE) Pt3_Lon_Single
  REAL(SINGLE) zlat1
  REAL(SINGLE) zlon1
  REAL(SINGLE) zlat2
  REAL(SINGLE) zlon2
  REAL(SINGLE) clat1
  REAL(SINGLE) clon1
  REAL(SINGLE) slat1
  REAL(SINGLE) slon1
  REAL(SINGLE) clat2
  REAL(SINGLE) clon2
  REAL(SINGLE) slat2
  REAL(SINGLE) slon2
  REAL(SINGLE) xx
  REAL(SINGLE) yy
  REAL(SINGLE) zz
  REAL(SINGLE) ARCL    !arclength
  REAL(SINGLE) DIST
  REAL(SINGLE) XDIST
  REAL(SINGLE) YDIST

  REAL(SINGLE), PARAMETER :: D2RAD = 0.017453292
  REAL(SINGLE), PARAMETER :: R = 6.378E3




  SELECT CASE(Nav%Sensor_Series)

  CASE (SERIES_MSG_SEVIRI)

    CALL pixcoord2geocoord_dp(Nav, Point1_Element, Point1_Line, Point1_Lat, Point1_Lon)

    CALL pixcoord2geocoord_dp(Nav, Point1_Element+1., Point1_Line, Point2_Lat, Point2_Lon)

    CALL pixcoord2geocoord_dp(Nav, Point1_Element, Point1_Line+1., Point3_Lat, Point3_Lon)

    Pt1_Lat_Single = REAL(Point1_Lat)
    Pt1_Lon_Single = REAL(Point1_Lon)
    Pt2_Lat_Single = REAL(Point2_Lat)
    Pt2_Lon_Single = REAL(Point2_Lon)
    Pt3_Lat_Single = REAL(Point3_Lat)
    Pt3_Lon_Single = REAL(Point3_Lon)

!  CASE (SERIES_GOES_N_IMG)
!
!    CALL pixcoord2geocoord_gvar(Point1_Element, Point1_Line, sat_xstride, &
!                                 Pt1_Lat_Single, Pt1_Lon_Single)
!    CALL pixcoord2geocoord_gvar(Point1_Element+1., Point1_Line, sat_xstride, &
!                                    Pt2_Lat_Single, Pt2_Lon_Single)
!    CALL pixcoord2geocoord_gvar(Point1_Element, Point1_Line+1., sat_xstride, &
!                                    Pt3_Lat_Single, Pt3_Lon_Single)

  CASE (SERIES_GOESR_ABI)

    CALL pixcoord2geocoord_abi_real(Nav, Point1_Element, Point1_Line, &
                                    Point1_Lat, Point1_Lon)
    CALL pixcoord2geocoord_abi_real(Nav, Point1_Element+1., Point1_Line, &
                                    Point2_Lat, Point2_Lon)
    CALL pixcoord2geocoord_abi_real(Nav, Point1_Element, Point1_Line+1., &
                                    Point3_Lat, Point3_Lon)

    Pt1_Lat_Single = REAL(Point1_Lat)
    Pt1_Lon_Single = REAL(Point1_Lon)
    Pt2_Lat_Single = REAL(Point2_Lat)
    Pt2_Lon_Single = REAL(Point2_Lon)
    Pt3_Lat_Single = REAL(Point3_Lat)
    Pt3_Lon_Single = REAL(Point3_Lon)

  CASE (SERIES_HIMAWARI_AHI)

    CALL pixcoord2geocoord_abi_real(Nav, Point1_Element, Point1_Line, &
                                    Point1_Lat, Point1_Lon)
    Pt1_Lat_Single = REAL(Point1_Lat)
    Pt1_Lon_Single = REAL(Point1_Lon)
    IF (Pt1_Lon_Single > 180.0) Pt1_Lon_Single = Pt1_Lon_Single - 360.0

    CALL pixcoord2geocoord_abi_real(Nav, Point1_Element+1., Point1_Line, &
                                    Point2_Lat, Point2_Lon)

    Pt2_Lat_Single = REAL(Point2_Lat)
    Pt2_Lon_Single = REAL(Point2_Lon)
    IF (Pt2_Lon_Single > 180.0) Pt2_Lon_Single = Pt2_Lon_Single - 360.0

    CALL pixcoord2geocoord_abi_real(Nav, Point1_Element, Point1_Line+1., &
                                    Point3_Lat, Point3_Lon)

    Pt3_Lat_Single = REAL(Point3_Lat)
    Pt3_Lon_Single = REAL(Point3_Lon)
    IF (Pt3_Lon_Single > 180.0) Pt3_Lon_Single = Pt3_Lon_Single - 360.0


  END SELECT

  ! polar winds test
  IF (TRIM(Nav%NavType) .EQ. 'PS') THEN

    CALL pixcoord2geocoord_ps(Nav, Point1_Element, Point1_Line, Pt1_Lat_Single, Pt1_Lon_Single)
    CALL pixcoord2geocoord_ps(Nav, Point1_Element+1., Point1_Line, Pt2_Lat_Single, Pt2_Lon_Single)
    CALL pixcoord2geocoord_ps(Nav, Point1_Element, Point1_Line+1., Pt3_Lat_Single, Pt3_Lon_Single)

  END IF

  ! Calculate earth distance between lines and elements
  ! This code comes from McIDAS subroutine m0distnc.for

  ! Convert degrees to radians
  zlat1 = Pt1_Lat_Single * D2RAD
  zlon1 = Pt1_Lon_Single * D2RAD
  zlat2 = Pt2_Lat_Single * D2RAD
  zlon2 = Pt2_Lon_Single * D2RAD

  ! Compute sines and cosines
  clat1=COS(zlat1)
  clon1=COS(zlon1)
  slat1=SIN(zlat1)
  slon1=SIN(zlon1)
  clat2=COS(zlat2)
  clon2=COS(zlon2)
  slat2=SIN(zlat2)
  slon2=SIN(zlon2)

  ! set up trig to get distance

  xx=clat2*clon2-clat1*clon1
  yy=clat2*slon2-clat1*slon1
  zz=slat2-slat1
  DIST=SQRT(xx*xx+yy*yy+zz*zz)
  ARCL=2.*ASIN(DIST/2.)*R
  XDIST=ARCL

  zlat2 = Pt3_Lat_Single * D2RAD
  zlon2 = Pt3_Lon_Single * D2RAD

  clat2=COS(zlat2)
  clon2=COS(zlon2)
  slat2=SIN(zlat2)
  slon2=SIN(zlon2)

  xx=clat2*clon2-clat1*clon1
  yy=clat2*slon2-clat1*slon1
  zz=slat2-slat1
  DIST=SQRT(xx*xx+yy*yy+zz*zz)
  ARCL=2.*ASIN(DIST/2.)*R
  YDIST=ARCL

  Factor = XDIST/YDIST

END SUBROUTINE Pixel_Factor

!-------------------------------------------------------------------------------
!
! Name:
!   Check_Height_Assignment
!
! Function:
!   Checks the AMV height assignment for errors.
!
! Description:
!   Checks if the AMV height assignment is missing or based on a
!   small (less than 2%) sample of cloudy pixels. The subroutine
!   also applies channel-specific pressure thresholds.
!
! Reference:
!   None.
!
! Calling Sequence:
!   CALL Check_Height_Assignment
!
! Inputs:
!   Point_Index              Number of pixels used to assign height
!   Median_Press             Pressure assignment of AMV
!   Press_Profile            Forecast pressure levels
!
! Outputs:
!   QC_Flag                  Quality control flag
!
! Dependencies:
!   None.
!
! Restrictions:
!   None.
!
! History:
! 04/2010 - Wayne Bresky - Created
! ------------------------------------------------------------------------------
SUBROUTINE Check_Height_Assignment(Point_Index, Median_Press, &
                                      Press_Profile, QC_Flag)

  INTEGER(LONG), INTENT(INOUT) :: QC_Flag
  INTEGER(LONG), INTENT(IN) :: Point_Index
  INTEGER(LONG) Min_Sample_Size
  REAL(SINGLE), INTENT(IN) :: Median_Press
  REAL(SINGLE), DIMENSION(:), INTENT(IN) :: Press_Profile
  REAL(SINGLE) PMIN
  REAL(SINGLE) PMAX

  ! First check if median pressure is missing or less than the value of
  ! the first pressure level. This applies to all bands.

  IF (Median_Press .EQ. MISSING_VALUE_REAL4 .OR. &
      Median_Press .LT. Press_Profile(1) ) THEN

    QC_Flag = BAD_PRESS_FAILURE
    RETURN

  ENDIF

  ! Check to see if we are processing clear-sky WV winds and set
  ! pressure thresholds accordingly

  IF (CSWV_Flag .EQ. sym%NO) THEN

    ! For cloud-track winds also check size of CTP sample.

    Min_Sample_Size = CEILING(REAL(Total_Points) * MIN_PERCENT_PRESS_VALUES)

    IF (Point_Index .LT. Min_Sample_Size) THEN

      QC_Flag = BAD_PRESS_FAILURE
      RETURN

    ENDIF

    SELECT CASE(Channel)

    ! set upper and lower limits for all cloud-track channels

    CASE(NATIVE_ABI_CHN2)
      !aab SWIR - Mods for VIIRS...use different threshold for VIIRS SWIR
      !           VIIRS SWIR is a reflectance value, so it's treated as a VIS channel
      !PMIN = PMIN_VISIBLE
      IF ( Sensor_Series == SERIES_JPSS_VIIRS ) THEN
        PMIN = PMIN_VISIBLE_VIIRS
      ELSE
        PMIN = PMIN_VISIBLE
      ENDIF
      PMAX = PMAX_ALL_WINDS

    CASE(NATIVE_ABI_CHN7)
      PMIN = PMIN_SWIR
      PMAX = PMAX_ALL_WINDS
    CASE(NATIVE_ABI_CHN8 : NATIVE_ABI_CHN10)
      PMIN = PMIN_CTWV
      IF ( Sensor_Series == SERIES_EOS_MODIS ) THEN
         PMAX = PMAX_CTWV_MODIS
      ELSE
         PMAX = PMAX_CTWV
      ENDIF
    CASE(NATIVE_ABI_CHN14)
      PMIN = PMIN_LWIR
      PMAX = PMAX_ALL_WINDS
    END SELECT

  ELSE IF (CSWV_Flag .EQ. sym%YES) THEN

    SELECT CASE(Channel)

    ! set upper and lower limits for clear-sky WV winds

    CASE(NATIVE_ABI_CHN8 : NATIVE_ABI_CHN9)
      PMIN = PMIN_CTWV
      PMAX = PMAX_ALL_WINDS
    CASE(NATIVE_ABI_CHN10)
      PMIN = PMIN_CSWV10
      PMAX = PMAX_CSWV10
    END SELECT

  ENDIF

  ! Check min/max limits

  IF (Median_Press .LT. PMIN .OR. Median_Press .GT. PMAX) THEN

    QC_Flag = PRESS_THRESHOLD_FAILURE
    RETURN

  ENDIF

END SUBROUTINE Check_Height_Assignment

!-------------------------------------------------------------------------------
!
! Name:
!   Interpolate_To_AMV_Press
!
! Function:
!   Interpolates the forecast wind to the AMV pressure.
!
! Description:
!   Performs a linear interpolation of the forecast wind to the AMV
!   pressure assignment.
!
! Reference:
!   None.
!
! Calling Sequence:
!   CALL Interpolate_To_AMV_Press
!
! Inputs:
!   Press_Levels             Forecast pressure levels
!   Fcst_Prof                Forecast profile data structure
!
! Input/Output:
!   Output                   Output data structure
!
! Dependencies:
!   None.
!
! Restrictions:
!   None.
!
! History:
! 04/2010 - Wayne Bresky - Created
! ------------------------------------------------------------------------------
SUBROUTINE Interpolate_To_AMV_Press(Output, Press_Levels, Fcst_Prof)

  TYPE(Output_Variables), INTENT(INOUT) :: Output
  TYPE(Forecast_Profiles), INTENT(IN) :: Fcst_Prof
  INTEGER(LONG), INTENT(IN) :: Press_Levels
  INTEGER(LONG) :: Level

  ! Locate nearest forecast level corresponding to median pressure.

  CALL Locate(Fcst_Prof%Pressure, Press_Levels, Output%Median_Press, Level)

  ! Interpolate forecast wind to median pressure level.

  IF ( (Level+1) .LE. Press_Levels) THEN

    Output%U_Fcst = ((Fcst_Prof%Pressure(Level+1) - Output%Median_Press) * &
                         Fcst_Prof%U_Wind(Level) +  (Output%Median_Press - &
                 Fcst_Prof%Pressure(Level)) * Fcst_Prof%U_Wind(Level+1)) / &
                (Fcst_Prof%Pressure(Level+1) - Fcst_Prof%Pressure(Level))

    Output%V_Fcst = ((Fcst_Prof%Pressure(Level+1) - Output%Median_Press) * &
                         Fcst_Prof%V_Wind(Level) +  (Output%Median_Press - &
                 Fcst_Prof%Pressure(Level)) * Fcst_Prof%V_Wind(Level+1)) / &
                (Fcst_Prof%Pressure(Level+1) - Fcst_Prof%Pressure(Level))

  ELSE

    Output%U_Fcst = Fcst_Prof%U_Wind(Level)
    Output%V_Fcst = Fcst_Prof%V_Wind(Level)

  ENDIF

END SUBROUTINE Interpolate_To_AMV_Press

!-------------------------------------------------------------------------------
!
! Name:
!   Assign Height
!
! Function:
!   Assigns a representative height (pressure) to the AMV.
!
! Description:
!   Assigns a representative height to the AMV by either finding
!   the median cloud-top pressure of a sample of cloudy pixels
!   or by finding the forecast level corresponding to a median
!   brightness temperature.
!
! Reference:
!   None.
!
! Calling Sequence:
!   CALL Assign Height
!
! Inputs:
!   Box_Data                 Target box data structure
!   Fcst_Prof                Forecast profile data structure
!
! Input/Output:
!   Output                   Output data structure of current target scene
!
! Outputs:
!   QC_Flag                  Quality control flag
!
! Dependencies:
!   None.
!
! Restrictions:
!   None.
!
! History:
! 04/2010 - Wayne Bresky - Created
! ------------------------------------------------------------------------------
SUBROUTINE Assign_Height(Press_Levels, Output, Box_Data, Fcst_Prof, QC_Flag)

  INTEGER(LONG), INTENT(IN) :: Press_Levels
  TYPE(Output_Variables), INTENT(INOUT) :: Output
  TYPE(Target_Box_Data), INTENT(INOUT) :: Box_Data
  TYPE(Forecast_Profiles), INTENT(IN) :: Fcst_Prof

  INTEGER(LONG), INTENT(INOUT) :: QC_Flag
  INTEGER(LONG) Median_Level

  REAL(SINGLE) a

  ! find median values of pressure, temperature, brightness temperature
  ! and cloud height

  CALL Sort_Shell_NP(Output%Point_Index, Box_Data%Pressure_Cold_Sample, &
                                                   Output%Median_Press)

  ! need to add cloud top temperature here

  CALL Sort_Shell_NP(Output%Point_Index, Box_Data%BrtTemp_Cold_Sample, &
                                                Output%Median_BrtTemp)

  CALL Sort_Shell_NP(Output%Point_Index, Box_Data%Cld_Hgt_Cold_Sample, &
                                                    Output%Median_Hgt)

  ! For the clear-sky water vapor winds find level in forecast profile
  ! corresponding to median BrtTemp.

  IF (CSWV_Flag .EQ. sym%YES .AND. Output%Median_BrtTemp .NE. MISSING_VALUE_REAL4) THEN

    CALL Locate(Fcst_Prof%Temp, Press_levels, Output%Median_BrtTemp, &
                                                       Median_Level)

    ! Check for level index of zero which can happen if median BT is
    ! colder than coldest temperature in (26-level) profile. May need
    ! to access higher resolution profile to correct this. For now we
    ! will flag the target as bad. If we don't flag the target the
    ! result is a pressure value of NaN.

    IF (Median_Level .EQ. 0) THEN

      QC_Flag = BAD_PRESS_FAILURE
      RETURN

    ENDIF

    ! Interpolate to find pressure associated with median BrtTemp

    a = LOG(Output%Median_BrtTemp/Fcst_Prof%Temp(Median_Level)) / &
                          LOG(Fcst_Prof%Temp(Median_Level + 1)  / &
                                 Fcst_Prof%Temp(Median_Level))

    IF (a .NE. 0.0) Output%Median_Press =  Fcst_Prof%Pressure(Median_Level)* &
                         EXP(a * LOG (Fcst_Prof%Pressure(Median_Level + 1) / &
                                        Fcst_Prof%Pressure(Median_Level)))

  ENDIF ! clear-sky WV check

END SUBROUTINE Assign_Height


SUBROUTINE IncrementElement(QC_Flag, Start_Element)
  CHARACTER(LEN=*), PARAMETER :: FUNC = "IncrementElement"
  INTEGER(LONG), INTENT(IN) :: QC_Flag
  INTEGER(LONG), INTENT(INOUT) :: Start_Element

  INTEGER(LONG) :: Element_Shift

  ! ------------------------------------------------------------------------
  ! Reset starting element for next box
  ! ------------------------------------------------------------------------

  ! Range of flag values (1-7) indicating target failures
  IF (QC_Flag .GT. 0 .AND. QC_Flag .LE. 7) THEN

    Element_Shift = Box_Size / 2

    ! if fixed spacing of output is desired use this setting
    !Element_Shift = NOMINAL_BOX_SIZE

  ELSE

    ! use nominal box size instead of target box size
    ! this results in slight overlap for 11 micron channel which uses
    ! box size of 19 (nominal size is 15)
    !Element_Shift = Box_Size

    Element_Shift = NOMINAL_BOX_SIZE

  ENDIF

  Start_Element = Start_Element + Element_Shift

END SUBROUTINE IncrementElement

!-------------------------------------------------------------------------------
!
! Name:
!   Find_Combined_Median
!
! Function:
!   Combines two samples and finds median value.
!
! Description:
!   This subroutine combines two samples of data (either cloud-top
!   pressure values or brightness temperature values) and finds the
!   median of the combined sample. The two samples come from the
!   nested tracking output of the reverse and forward vectors.
!
! Reference:
!   None.
!
! Calling Sequence:
!   CALL Find_Combined_Median
!
! Inputs:
!   DBSCAN_Out               DBSCAN output data structure
!   LL_Inver_Flag            Low-level inversion flag
!   Fcst_Prof                Forecast profile data structure
!   Output                   Output data structure of current target scene
!
! Input/Output
!   QC_Flag                  Quality control flag
!
! Outputs
!   Combined_Median          Median pressure associated with combined sample
!   Combined_Median_Hgt      Median height associated with combined sample
!
!
! Dependencies:
!   None.
!
! Restrictions:
!   None.
!
! History:
! 04/2010 - Wayne Bresky - Created
! 08/2010 - Wayne Bresky - Added DBSCAN output structure
! ------------------------------------------------------------------------------
SUBROUTINE Find_Combined_Median(DBSCAN_Out, Fcst_Prof, Output, &
                               Combined_Median, Combined_Median_Hgt, QC_Flag)

  TYPE(DBSCAN_Output), INTENT(IN) :: DBSCAN_Out
  TYPE(Forecast_Profiles), INTENT(IN) :: Fcst_Prof
  TYPE(Output_Variables), INTENT(INOUT) :: Output
  REAL(SINGLE), INTENT(OUT) :: Combined_Median
  REAL(SINGLE), INTENT(OUT) :: Combined_Median_Hgt
  INTEGER(LONG), INTENT(INOUT) :: QC_Flag

  INTEGER(LONG) :: Combined_Sum
  INTEGER(LONG) :: Filtered_Sum
  INTEGER(LONG) :: Point


  REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Combined_CTP_Sample
  REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Filtered_CTP_Sample
  REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Combined_Hgt_Sample
  REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Combined_CldTemp_Sample
  REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Filtered_CldTemp_Sample
  REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Combined_HgtErr_Sample
  REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Combined_TempErr_Sample
  REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: OD_Sample
  REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: ACHA_Cost_Sample
  REAL(SINGLE) Min_CTP
  REAL(SINGLE) Max_CTP
  REAL(SINGLE) Min_CTT
  REAL(SINGLE) Max_CTT
  REAL(SINGLE) :: Combined_Median_CldTemp
  REAL(SINGLE) :: Combined_Median_BrtTemp
  REAL(SINGLE) Combined_Median_HgtErr
  REAL(SINGLE) Combined_Median_TempErr
  REAL(SINGLE) SumOfValues
  REAL(SINGLE) SumOfWeights
  REAL(SINGLE) WAvg
  REAL(SINGLE) Mean_CTP
  REAL(SINGLE) Mean_CTT
  REAL(SINGLE) Variance_CTP
  REAL(SINGLE) SD_CTP
  REAL(SINGLE) Filtered_Median
  REAL(SINGLE) Filtered_Median_CldTemp
  ! optical depth
  REAL(SINGLE) Min_OD
  REAL(SINGLE) Max_OD
  REAL(SINGLE) Median_OD
  ! ACHA cost
  REAL(SINGLE) Min_Cost
  REAL(SINGLE) Max_Cost
  REAL(SINGLE) Median_Cost
  INTEGER(LONG) :: i
  INTEGER(LONG) :: counts
  INTEGER(LONG) :: maxcount
  INTEGER(LONG) :: dominant_phase
  INTEGER(LONG) :: dominant_type



  ! Initialize output value to missing

  Combined_Median = MISSING_VALUE_REAL4
  Filtered_Median = MISSING_VALUE_REAL4
  Combined_Median_CldTemp = MISSING_VALUE_REAL4
  Filtered_Median_CldTemp = MISSING_VALUE_REAL4
  Combined_Median_Hgt = MISSING_VALUE_REAL4
  Combined_Median_BrtTemp = MISSING_VALUE_REAL4
  Combined_Median_HgtErr = MISSING_VALUE_REAL4
  Combined_Median_TempErr = MISSING_VALUE_REAL4
  Median_OD = MISSING_VALUE_REAL4
  Median_Cost = MISSING_VALUE_REAL4

  ! added for Weighted CTP
  SumOfValues = 0.0
  SumOfWeights = 0.0
  WAvg = 0.0

  ! added for filtering of outliers
  Mean_CTP = 0.0
  Mean_CTT = 0.0
  Variance_CTP = 0.0
  SD_CTP = 0.0
  Filtered_Sum = 0

  ! combine the sample from the reverse vector with the sample
  ! from the forward vector

  Combined_Sum = DBSCAN_Out%Number_CTP_Sample1 + DBSCAN_Out%Number_CTP_Sample2

  counts = 0
  maxcount = 0
  dominant_phase = MISSING_VALUE_LONG
  DO I = sym%PHASE_MIN, sym%PHASE_MAX
     counts = COUNT(DBSCAN_Out%Phase_Sample1(1:DBSCAN_Out%Number_CTP_Sample1) == I)
     counts = counts + COUNT(DBSCAN_Out%Phase_Sample2(1:DBSCAN_Out%Number_CTP_Sample2) == I)
     IF(counts > maxcount) THEN
        dominant_phase = I
        maxcount = counts
     ENDIF
  ENDDO
  Output%Cloud_Phase = dominant_phase

  counts = 0
  maxcount = 0
  dominant_type = MISSING_VALUE_LONG
  DO I = sym%TYPE_MIN, sym%TYPE_MAX
     counts = COUNT(DBSCAN_Out%Type_Sample1(1:DBSCAN_Out%Number_CTP_Sample1) == I)
     counts = counts + COUNT(DBSCAN_Out%Type_Sample2(1:DBSCAN_Out%Number_CTP_Sample2) == I)
     IF(counts > maxcount) THEN
        dominant_type = I
        maxcount = counts
     ENDIF
  ENDDO
  Output%Cloud_Type = dominant_type


  ALLOCATE(Combined_CTP_Sample(Combined_Sum))
  ALLOCATE(Filtered_CTP_Sample(Combined_Sum))
  ALLOCATE(Combined_CldTemp_Sample(Combined_Sum))
  ALLOCATE(Filtered_CldTemp_Sample(Combined_Sum))
  ALLOCATE(Combined_Hgt_Sample(Combined_Sum))
  ALLOCATE(Combined_HgtErr_Sample(Combined_Sum))
  ALLOCATE(Combined_TempErr_Sample(Combined_Sum))
  ALLOCATE(OD_Sample(Combined_Sum))
  ALLOCATE(ACHA_Cost_Sample(Combined_Sum))

  Combined_CTP_Sample(1:DBSCAN_Out%Number_CTP_Sample1) = DBSCAN_Out% &
                    CTP_5x5_Sample1(1:DBSCAN_Out%Number_CTP_Sample1)

  Combined_CTP_Sample(DBSCAN_Out%Number_CTP_Sample1+1:) = DBSCAN_Out% &
                     CTP_5x5_Sample2(1:DBSCAN_Out%Number_CTP_Sample2)

  CALL Sort_Shell_NP(Combined_Sum, Combined_CTP_Sample, &
                                       Combined_Median)

  ! Find combined median cloud temperature

  Combined_CldTemp_Sample(1:DBSCAN_Out%Number_CTP_Sample1) = DBSCAN_Out% &
                    CldTemp_5x5_Sample1(1:DBSCAN_Out%Number_CTP_Sample1)

  Combined_CldTemp_Sample(DBSCAN_Out%Number_CTP_Sample1+1:) = DBSCAN_Out% &
                     CldTemp_5x5_Sample2(1:DBSCAN_Out%Number_CTP_Sample2)

  CALL Sort_Shell_NP(Combined_Sum, Combined_CldTemp_Sample, &
                                   Combined_Median_CldTemp)

  ! Find combined median cloud height

  Combined_Hgt_Sample(1:DBSCAN_Out%Number_CTP_Sample1) = DBSCAN_Out% &
                 Cld_Hgt_5x5_Sample1(1:DBSCAN_Out%Number_CTP_Sample1)

  Combined_Hgt_Sample(DBSCAN_Out%Number_CTP_Sample1+1:) = DBSCAN_Out% &
                 Cld_Hgt_5x5_Sample2(1:DBSCAN_Out%Number_CTP_Sample2)

  CALL Sort_Shell_NP(Combined_Sum, Combined_Hgt_Sample, &
                                   Combined_Median_Hgt)

  ! Find combined median height and temperature error

  Combined_HgtErr_Sample(1:DBSCAN_Out%Number_CTP_Sample1) = DBSCAN_Out% &
                   Press_Error_Sample1(1:DBSCAN_Out%Number_CTP_Sample1)

  Combined_HgtErr_Sample(DBSCAN_Out%Number_CTP_Sample1+1:) = DBSCAN_Out% &
                    Press_Error_Sample2(1:DBSCAN_Out%Number_CTP_Sample2)

  CALL Sort_Shell_NP(Combined_Sum, Combined_HgtErr_Sample, &
                                   Combined_Median_HgtErr)

  Combined_TempErr_Sample(1:DBSCAN_Out%Number_CTP_Sample1) = DBSCAN_Out% &
                     Temp_Error_Sample1(1:DBSCAN_Out%Number_CTP_Sample1)

  Combined_TempErr_Sample(DBSCAN_Out%Number_CTP_Sample1+1:) = DBSCAN_Out% &
                      Temp_Error_Sample2(1:DBSCAN_Out%Number_CTP_Sample2)

  CALL Sort_Shell_NP(Combined_Sum, Combined_TempErr_Sample, &
                                   Combined_Median_TempErr)

  ! Find median optical depth

  OD_Sample(1:DBSCAN_Out%Number_CTP_Sample1) = DBSCAN_Out% &
              Cld_OD_Sample1(1:DBSCAN_Out%Number_CTP_Sample1)

  OD_Sample(DBSCAN_Out%Number_CTP_Sample1+1:) = DBSCAN_Out% &
              Cld_OD_Sample2(1:DBSCAN_Out%Number_CTP_Sample2)

  CALL Sort_Shell_NP(Combined_Sum, OD_Sample, Median_OD)

  ! Find median cost

  ACHA_Cost_Sample(1:DBSCAN_Out%Number_CTP_Sample1) = DBSCAN_Out% &
              ACHA_Cost_Sample1(1:DBSCAN_Out%Number_CTP_Sample1)

  ACHA_Cost_Sample(DBSCAN_Out%Number_CTP_Sample1+1:) = DBSCAN_Out% &
              ACHA_Cost_Sample2(1:DBSCAN_Out%Number_CTP_Sample2)

  CALL Sort_Shell_NP(Combined_Sum, ACHA_Cost_Sample, Median_Cost)

  ! added for Weighted CTP (weighted by correlation)

  !DO Point=1,DBSCAN_Out%Number_CTP_Sample1

  !  ! use cold branch
  !  IF (DBSCAN_Out%CldTemp_5x5_Sample1(Point) .GT. Mean_CTT) CYCLE

  !  SumOfValues = SumOfValues + DBSCAN_Out%CTP_5x5_Sample1(Point) * DBSCAN_Out%CORR_5x5_Sample1(Point)
  !  SumOfWeights = SumOfWeights + DBSCAN_Out%CORR_5x5_Sample1(Point)

  !ENDDO

  !DO Point=1,DBSCAN_Out%Number_CTP_Sample2

  !  ! use cold branch
  !  IF (DBSCAN_Out%CldTemp_5x5_Sample2(Point) .GT. Mean_CTT) CYCLE

  !  SumOfValues = SumOfValues + DBSCAN_Out%CTP_5x5_Sample2(Point) * DBSCAN_Out%CORR_5x5_Sample2(Point)
  !  SumOfWeights = SumOfWeights + DBSCAN_Out%CORR_5x5_Sample2(Point)

  !ENDDO

  !WAvg = SumOfValues / SumOfWeights

  !IF (ISNAN(WAvg)) THEN

  !  WAvg = MISSING_VALUE_REAL4

  !ENDIF

  ! keep track of min and max values

  Min_CTP = MINVAL(Combined_CTP_Sample)
  Max_CTP = MAXVAL(Combined_CTP_Sample)
  Min_CTT = MINVAL(Combined_CldTemp_Sample)
  Max_CTT = MAXVAL(Combined_CldTemp_Sample)
  Min_OD = MINVAL(OD_Sample)
  Max_OD = MAXVAL(OD_Sample)
  Min_Cost = MINVAL(ACHA_Cost_Sample)
  Max_Cost = MAXVAL(ACHA_Cost_Sample)


  ! save values in output structure

  Output%Min_CTP = Min_CTP
  Output%Max_CTP = Max_CTP
  Output%Min_CTT = Min_CTT
  Output%Max_CTT = Max_CTT
  Output%Combined_Median = Combined_Median
  Output%Min_OD = Min_OD
  Output%Max_OD = Max_OD
  Output%Median_OD = Median_OD
  Output%Min_Cost = Min_Cost
  Output%Max_Cost = Max_Cost
  Output%Median_Cost = Median_Cost

  !use weighted pressure
  !Combined_Median = WAvg
  !Output%Combined_Median = WAvg
  !

  Output%Combined_Median_CldTemp = Combined_Median_CldTemp
  Output%Combined_Median_Hgt = Combined_Median_Hgt
  Output%Combined_Median_HgtErr = Combined_Median_HgtErr
  Output%Combined_Median_TempErr = Combined_Median_TempErr
  Output%Weighted_PW = WAvg

  ! update MedianPress
  Output%Median_Press = Combined_Median

  !deallocate combined sample arrays

  DEALLOCATE(Combined_CTP_Sample)
  DEALLOCATE(Filtered_CTP_Sample)
  DEALLOCATE(Combined_CldTemp_Sample)
  DEALLOCATE(Filtered_CldTemp_Sample)
  DEALLOCATE(Combined_Hgt_Sample)
  DEALLOCATE(Combined_HgtErr_Sample)
  DEALLOCATE(Combined_TempErr_Sample)
  DEALLOCATE(OD_Sample)
  DEALLOCATE(ACHA_Cost_Sample)

  CALL Check_Height_Assignment(Combined_Sum, Combined_Median, &
                                 Fcst_Prof%Pressure, QC_Flag)

END SUBROUTINE Find_Combined_Median

!-------------------------------------------------------------------------------
!
! Name:
!   Dominant_Cloud_Phase
!
! Function:
!   Find dominant cloud phase in target scene. Clear phase is ignored.
!
! Description:
!   Returns the dominant cloud phase in the target scene.  Will become
!   a diagnostic output variable.
!     CLEAR_PHASE       = 0     clear cloud mask
!     WATER_PHASE       = 1     liquid water clouds warmer than 273.16 K
!     SUPERCOOLED_PHASE = 2     liquid water clouds colder than 273.16 K
!     MIXED_PHASE       = 3     very cold liquid clouds with some ice
!     ICE_PHASE         = 4     ice clouds
!     UNKNOWN_PHASE     = 5     bad input data
!
! Reference:
!   None.
!
! Calling Sequence:
!   CALL Dominant_Cloud_Phase
!
! Inputs:
!   Box_Data                 Target box data structure
!
! Input/Output:
!   Output                   Output data structure of current target scene
!
! Outputs:
!   Main_Cloud_Phase         Dominant cloud phase of target scene.
!
! Dependencies:
!   None.
!
! Restrictions:
!   None.
!
! History:
! 08/2010 - Steve Wanzong - Created
! ------------------------------------------------------------------------------
SUBROUTINE Dominant_Cloud_Phase(Box_Data, Main_Cloud_Phase)

  TYPE(Target_Box_Data), INTENT(IN) :: Box_Data

  INTEGER(LONG), INTENT(OUT) :: Main_Cloud_Phase

  INTEGER(LONG), PARAMETER :: PHASE_LOOP_NUM = 6
  INTEGER(LONG), DIMENSION(PHASE_LOOP_NUM) :: Phase_Type
  INTEGER(LONG) :: Loop_Index
  INTEGER(LONG) :: Phase_Count

  ! How many clear phase pixels in target scene?

  Phase_Type(1) = COUNT(Box_Data%Cloud_Phase == 0)

  ! How many water phase pixels in target scene?

  Phase_Type(2) = COUNT(Box_Data%Cloud_Phase == 1)

  ! How many supercooled phase pixels in target scene?

  Phase_Type(3) = COUNT(Box_Data%Cloud_Phase == 2)

  ! How many mixed phase pixels in target scene?

  Phase_Type(4) = COUNT(Box_Data%Cloud_Phase == 3)

  ! How many ice phase pixels in target scene?

  Phase_Type(5) = COUNT(Box_Data%Cloud_Phase == 4)

  ! How many unknown phase pixels in target scene?

  Phase_Type(6) = COUNT(Box_Data%Cloud_Phase == 5)

  ! Find main phase type

  Phase_Count = 0
  Main_Cloud_Phase = 0

  ! Skip clear phase, so begin loop at Index 2.

  phase_loop: DO Loop_Index = 2, PHASE_LOOP_NUM

    IF (Phase_Type(Loop_Index) > Phase_Count) THEN

      Phase_Count = Phase_Type(Loop_Index)
      Main_Cloud_Phase = Loop_Index - 1

    ENDIF

  END DO phase_loop

END SUBROUTINE Dominant_Cloud_Phase

!-------------------------------------------------------------------------------
!
! Name:
!   Dominant_Cloud_Type
!
! Function:
!   Find dominant cloud type in target scene. Clear type is ignored.
!
! Description:
!   Returns the dominant cloud type in the target scene.  Will become
!   a diagnostic output variable.  Technically, FOG_TYPE and OVERSHOOTING_TYPE
!   are not baseline cloud type's, but for ease of coding, they are included.
!     CLEAR_TYPE        = 0     clear cloud mask
!     FOG_TYPE          = 1
!     WATER_TYPE        = 2     liquid water clouds, warmer than 273.16 K
!     SUPERCOOLED_TYPE  = 3     liquid water clouds, colder than 273.16 K
!     MIXED_TYPE        = 4     very cold liquid water clouds with some ice
!     TICE_TYPE         = 5     thick, opaque ice clouds
!     CIRRUS_TYPE       = 6     thin, semi-transparent ice clouds
!     OVERLAP_TYPE      = 7     multi-layer clouds, ice over water
!     OVERSHOOTING_TYPE = 8
!     UNKNOWN_TYPE      = 9     bad input data
!
! Reference:
!   None.
!
! Calling Sequence:
!   CALL Dominant_Cloud_Type
!
! Inputs:
!   Box_Data                 Target box data structure
!
! Input/Output:
!   Output                   Output data structure of current target scene
!
! Outputs:
!   Main_Cloud_Phase         Dominant cloud type of target scene.
!
! Dependencies:
!   None.
!
! Restrictions:
!   None.
!
! History:
! 08/2010 - Steve Wanzong - Created
! ------------------------------------------------------------------------------
SUBROUTINE Dominant_Cloud_Type(Box_Data, Main_Cloud_Type)

  TYPE(Target_Box_Data), INTENT(IN) :: Box_Data

  INTEGER(LONG), INTENT(OUT) :: Main_Cloud_Type

  INTEGER(LONG), PARAMETER :: TYPE_LOOP_NUM = 10
  INTEGER(LONG), DIMENSION(TYPE_LOOP_NUM) :: Cloud_Type
  INTEGER(LONG) :: Loop_Index
  INTEGER(LONG) :: Type_Count


  ! How many clear type pixels in target scene?

  Cloud_Type(1) = COUNT(Box_Data%Cloud_Type == 0)

  ! How many fog type pixels in target scene?

  Cloud_Type(2) = COUNT(Box_Data%Cloud_Type == 1)

  ! How many water type pixels in target scene?

  Cloud_Type(3) = COUNT(Box_Data%Cloud_Type == 2)

  ! How many supercooled type pixels in target scene?

  Cloud_Type(4) = COUNT(Box_Data%Cloud_Type == 3)

  ! How many mixed type pixels in target scene?

  Cloud_Type(5) = COUNT(Box_Data%Cloud_Type == 4)

  ! How many tice type pixels in target scene?

  Cloud_Type(6) = COUNT(Box_Data%Cloud_Type == 5)

  ! How many cirrus type pixels in target scene?

  Cloud_Type(7) = COUNT(Box_Data%Cloud_Type == 6)

  ! How many overlap type pixels in target scene?

  Cloud_Type(8) = COUNT(Box_Data%Cloud_Type == 7)

  ! How many overshooting type pixels in target scene?

  Cloud_Type(9) = COUNT(Box_Data%Cloud_Type == 8)

  ! How many unknown type pixels in target scene?

  Cloud_Type(10) = COUNT(Box_Data%Cloud_Type == 9)

  ! Find main cloud type

  Type_Count = 0
  Main_Cloud_Type = 0

  ! Skip clear type, so begin loop at Index 2.

  type_loop: DO Loop_Index = 2, TYPE_LOOP_NUM

    IF (Cloud_Type(Loop_Index) > Type_Count) THEN

      Type_Count = Cloud_Type(Loop_Index)
      Main_Cloud_Type = Loop_Index - 1

    ENDIF

  END DO type_loop

END SUBROUTINE Dominant_Cloud_Type







END MODULE AMV_EN_TARGET_SELECTION_UTILS_M

MODULE AMV_EN_FEATURE_TRACKING_UTILS_M
!-------------------------------------------------------------------------------
!> @file
! Name:
!   Feature_Tracking_Utils
!
! Function:
!   A collection of pattern-matching utilities used to derive atmospheric motion
!   vectors from an image sequence (3 or more images).
!
! Description:
!   The routines in this module are called by the main target selection program
!   to perform correlation matching of satellite features.
!
! References:
!   Velden et al (2005), "Recent Innovations in Deriving Tropospheric Winds From
!   Meteorological Satellites." Bulletin of the American Meteorological Society,
!   February 2005.
!
!   Nieman et al (1997), "Fully Automated Cloud-Drift Winds in NESDIS
!   Operations." Bulletin of the American Meteorological Society, June 1997.
!
! Calling sequence:
!   See description below
!
! Inputs:
!   See description below
!
! Outputs:
!   See description below
!
! Dependencies:
!   None
!
! Restrictions:
!   None
!
! History:
!     07/2007 - Wayne Bresky - Created
!  04/27/2009 - Wayne Bresky - Nested tracking introduced
!     11/2009 - Wayne Bresky - DBSCAN cluster analysis implemented within
!                              nested tracking
!     04/2010 - Wayne Bresky - Code Unit Test Review (CUTR) changes
!> @ingroup WINDS_AMV_EN
!-------------------------------------------------------------------------------

 USE TYPE_KINDS_AIT
 USE GEOCAT_CONSTANTS
 USE Framework_Global_Variables_Module
 USE NF_PARM
 USE COMMON_VAR_VALUE

 USE AMV_EN_TargetBox_m
 USE AMV_EN_DBSCAN_m
 USE AMV_EN_Output_m
 USE AMV_EN_NAV_MSG_M
 USE AMV_EN_NAV_ABI_M
 USE AMV_EN_NAV_POLAR_M
 USE AMV_EN_Nav_M
 USE AMV_EN_WINDS_INC




IMPLICIT NONE

! sub-vector number (1=reverse, 2=forward)
INTEGER(LONG), PARAMETER :: REVERSE = 1
INTEGER(LONG), PARAMETER :: FORWARD = 2

INTEGER(SHORT), PARAMETER :: MATCH_ON_BOUNDARY_FAILURE  = 15
INTEGER(SHORT), PARAMETER :: MISSING_DATA_SEARCH        = 20
INTEGER(SHORT), PARAMETER :: ZERO_INITIAL_SAMPLE        = 21
INTEGER(SHORT), PARAMETER :: ZERO_FINAL_SAMPLE          = 22

! Target box dimensions
INTEGER(LONG) :: Target_Line_Size
INTEGER(LONG) :: Target_Element_Size

! Search box dimensions
INTEGER(LONG) :: Search_Line_Size
INTEGER(LONG) :: Search_Element_Size

! Correlation lag matrix dimensions
INTEGER(LONG) :: Lag_Line_Size
INTEGER(LONG) :: Lag_Element_Size
REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Lag_Matrix
REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: XCorr_Values

! 1-D data
REAL(SINGLE), DIMENSION(:), ALLOCATABLE :: Target_1D
REAL(SINGLE), DIMENSION(:), ALLOCATABLE :: Search_1D

! DBSCAN parameters
INTEGER(BYTE),PARAMETER :: APPEND_PT = 0
INTEGER(BYTE),PARAMETER :: DELETE_PT = 1
REAL(SINGLE), PARAMETER :: UNCLASSIFIED = 0.0
REAL(SINGLE), PARAMETER :: NOISE = 1.0
REAL(SINGLE), PARAMETER :: CLASSIFIED = 2.0


CONTAINS

!-------------------------------------------------------------------------------
!
! Name:
!   Compute_Correlation
!
! Function:
!   Finds a match in the brightness temperature field of a subsequent image.
!
! Description:
!   A pattern matching routine which utilizes one of two methods to find
!   a match in the brightness temperature field of a larger search region.
!   The match is found by either minimizing the sum-of-squared differences
!   (SSD) or maximizing the linear correlation (also called the cross
!   correlion). The routine returns a displacement of the match "relative"
!   to the center of the search region. The program that calls this routine
!   must convert the relative displacement to an actual displacement.
!
! References:
!   Nieman et al (1997), "Fully Automated Cloud-Drift Winds in NESDIS
!   Operations." Bulletin of the American Meteorological Society, June 1997.
!
!   Merrill (1989), "Advances in the automated production of wind estimates
!   from geostationary satellite imaging." Proc. Fourth Conf. Satellite
!   Meteorology, San Diego, CA, Amer. Meteor. Soc., 246-249.
!
! Calling sequence:
!   Call Compute_Correlation
!
! Input:
!   Box_Data                  Target box data structure
!   Search_BT_Values          Brightness temperature values for search region
!   Lag_Table                 List of positions in spiral
!
! Output:
!   Line_Disp                 Line displacement of match relative to center
!                             of search
!   Element_Disp              Element displacement of match  relative to
!                             center of search
!   Least_Square_Error        Minimum sum of squared differences value
!   Target_Scene_Mean         Mean brightness temperature value of target
!   Match_Scene_Mean          Mean brightness temperature value of match
!   Target_Scene_StdDev       Standard deviation of target scene brightness
!                             temperature values
!   Match_Scene_StdDev        Standard deviation of match scene brightness
!                             temperature values
!   Corr_Coeff                Linear correlation value of matching scene
!   Status_Flag               Success value:
!                                 0 - Match found
!                               200 - Match found on boundary of lag matrix
!                               300 - Missing data
!
! Dependencies:
!   None
!
! Restrictions:
!   None
!
! History:
!  08/2007 - Wayne Bresky - Created
!  04/2010 - Wayne Bresky - CUTR changes
!
!-------------------------------------------------------------------------------
SUBROUTINE Compute_Correlation(Box_Data, Search_BT_Values, Lag_Table, &
                                          Delta_X_Fcst, Delta_Y_Fcst, &
                         Line_Disp, Element_Disp, Least_Square_Error, &
            Target_Scene_Mean, Match_Scene_Mean, Target_Scene_StdDev, &
                         Match_Scene_StdDev, Corr_Coeff, Status_Flag, &
                                                          SSD_Matrix)

  TYPE(Target_Box_Data), INTENT(IN) :: Box_Data

  ! Lag matrix center point
  INTEGER(LONG) :: Lag_Center_Element
  INTEGER(LONG) :: Lag_Center_Line
  INTEGER(LONG) :: Total_Points_Lag

  ! Flag to indicate success or failure of correlation matching
  INTEGER(LONG), INTENT(OUT) :: Status_Flag

  ! Least square error and linear correlation coefficient associated match
  INTEGER(LONG), INTENT(OUT) :: Least_Square_Error
  REAL(SINGLE), INTENT(OUT) :: Corr_Coeff

  INTEGER(LONG), DIMENSION(:, :), INTENT(IN) :: Lag_Table

  REAL(SINGLE), INTENT(INOUT), DIMENSION(:) :: SSD_Matrix

  ! Minimum SSD value and location
  REAL(DOUBLE) :: Min_SSD_Value
  INTEGER(LONG) :: Min_SSD_Location
  INTEGER(LONG) :: Min_SSD_Element
  INTEGER(LONG) :: Min_SSD_Line

  INTEGER(LONG) :: Match_Lag_Element
  INTEGER(LONG) :: Match_Lag_Line

  ! Offset for location of match area within search grid
  INTEGER(LONG) :: Match_Offset
  INTEGER(LONG) Diff_In_Size

  INTEGER(LONG) :: Element_Counter_Search
  INTEGER(LONG) :: Element
  INTEGER(LONG) :: Line
  INTEGER(LONG) :: Search_Index
  INTEGER(LONG) :: Total_Points_Search

  ! Brightness Temperature data and statistics for target and match scenes
  REAL(SINGLE), INTENT(IN), DIMENSION(:,:) :: Search_BT_Values
  REAL(SINGLE), INTENT(IN) :: Delta_X_Fcst
  REAL(SINGLE), INTENT(IN) :: Delta_Y_Fcst

  REAL(DOUBLE), INTENT(OUT) :: Target_Scene_Mean
  REAL(DOUBLE), INTENT(OUT) :: Target_Scene_StdDev
  REAL(DOUBLE), INTENT(OUT) :: Match_Scene_Mean
  REAL(DOUBLE), INTENT(OUT) :: Match_Scene_StdDev

  REAL(DOUBLE) :: Sum_Target
  REAL(DOUBLE) :: Sum_Squared_Target
  REAL(DOUBLE) :: Sum_Squared_Match
  REAL(DOUBLE) :: Target_Scene_Variance
  REAL(DOUBLE) :: Match_Scene_Variance

  ! Vector displcement in satellite coordinates
  REAL(SINGLE), INTENT(OUT) :: Line_Disp
  REAL(SINGLE), INTENT(OUT) :: Element_Disp
  REAL(SINGLE) :: Fractional_Element
  REAL(SINGLE) :: Fractional_Line
  INTEGER(LONG) :: Total_Points_Target
  REAL(DOUBLE) :: Corr_Coeff_DB

  !-----------------------------------------------------------------------------
  ! Initialize variables
  !-----------------------------------------------------------------------------

  Target_Element_Size = SIZE(Box_Data%BrtTemp, 1)
  Target_Line_Size = SIZE(Box_Data%BrtTemp, 2)
  Total_Points_Target = Target_Element_Size * Target_Line_Size
  Search_Element_Size = SIZE(Search_BT_Values, 1)
  Search_Line_Size = SIZE(Search_BT_Values, 2)
  Total_Points_Search = Search_Element_Size * Search_Line_Size
  Line_Disp = 0.0
  Element_Disp = 0.0
  Least_Square_Error = 0
  Status_Flag = 0
  Corr_Coeff = 0.0
  Target_Scene_Mean = 0.0
  Target_Scene_StdDev = 0.0
  Match_Scene_Mean = 0.0
  Match_Scene_StdDev = 0.0
  Sum_Target = 0.0
  Sum_Squared_Target = 0.0
  Sum_Squared_Match = 0.0
  Target_Scene_Variance = 0.0
  Match_Scene_Variance = 0.0
  Diff_In_Size = 0



  ALLOCATE(Target_1D(Total_Points_Target), Search_1D(Total_Points_Search))

  !-----------------------------------------------------------------------------
  ! Reshape 2-D box data into vectors for pattern matching code.
  !-----------------------------------------------------------------------------

  Target_1D = RESHAPE(Box_Data%BrtTemp, (/Total_Points_Target/))
  Search_1D = RESHAPE(Search_BT_Values, (/Total_Points_Search/))

  ! Compute summations for target scene

  summation_loop: DO Element = 1, Total_Points_Target

    Sum_Target = Sum_Target + Target_1D(Element)
    Sum_Squared_Target = Sum_Squared_Target + Target_1D(Element)**2

  END DO summation_loop

  ! ----------------------------------------------------------------------------
  ! Specify "lag" coefficient matrix size. This array contains the SSD
  ! values for all possible lag positions of the template within the
  ! search region. This array is filled regardless of the tracking
  ! method because it is used by both the LP norm and CC methods.
  !-----------------------------------------------------------------------------

  Lag_Element_Size = Search_Element_Size - Target_Element_Size + 1
  Lag_Line_Size = Search_Line_Size - Target_Line_Size + 1
  Lag_Center_Element = (Lag_Element_Size + 1) / 2
  Lag_Center_Line = (Lag_Line_Size + 1) / 2
  Total_Points_Lag = Lag_Element_Size * Lag_Line_Size

  ALLOCATE(Lag_Matrix(Total_Points_Lag))

  ! Call pattern match code

  CALL Fill_Lag_Matrix_1D(Lag_Element_Size, Diff_In_Size, Target_1D, Search_1D, &
                                                         Lag_Table, Lag_Matrix)

  SSD_Matrix = Lag_Matrix

  ! ----------------------------------------------------------------------------
  ! Determine location of match within lag matrix.
  ! ----------------------------------------------------------------------------

  Min_SSD_Value = MINVAL(Lag_Matrix)
  Least_Square_Error = Min_SSD_Value
  Min_SSD_Location = MINLOC(Lag_Matrix, 1)
  Min_SSD_Element = MOD(Min_SSD_Location, Lag_Element_Size)
  IF (MOD(Min_SSD_Location, Lag_Element_Size) .EQ. 0) THEN
    Min_SSD_Element = Lag_Element_Size
    Min_SSD_Line = (Min_SSD_Location / Lag_Element_Size)
  ELSE
    Min_SSD_Line = (Min_SSD_Location / Lag_Element_Size) + 1
  ENDIF

  ! ----------------------------------------------------------------------------
  ! Flag match on boundary. This condition may indicate the true match
  ! is located beyond the domain of the search.
  ! ----------------------------------------------------------------------------

  IF (Min_SSD_Element .EQ. 1 .OR. Min_SSD_Element .EQ. Lag_Element_Size .OR. &
              Min_SSD_Line .EQ. 1 .OR. Min_SSD_Line .EQ. Lag_Line_Size) THEN

    !Status_Flag = 200
    Status_Flag = MATCH_ON_BOUNDARY_FAILURE
    DEALLOCATE(Target_1D, Search_1D, Lag_Matrix)
    RETURN

  ENDIF

  ! ----------------------------------------------------------------------------
  ! Compute displacement relative to center of lag array. The center of
  ! the lag array also corresponds to the center of the search box.
  ! ----------------------------------------------------------------------------

  Element_Disp = REAL(Min_SSD_Element - Lag_Center_Element)
  Line_Disp = REAL(Min_SSD_Line - Lag_Center_Line)

  !-----------------------------------------------------------------------------
  ! Offset for location of match area within search grid.
  !-----------------------------------------------------------------------------

  Match_Offset = (Min_SSD_Line - 1) * Search_Element_Size + Min_SSD_Element - 1
  Element_Counter_Search = - Search_Element_Size

  line_loop: DO Line = 1, Target_Line_Size

    Element_Counter_Search = Element_Counter_Search + Search_Element_Size

    element_loop: DO Element = 1, Target_Element_Size

      Search_Index = Element_Counter_Search + Element + Match_Offset
      Match_Scene_Mean = Match_Scene_Mean + Search_1D(Search_Index)
      Sum_Squared_Match = Sum_Squared_Match + Search_1D(Search_Index)**2

    END DO element_loop

  END DO line_loop

  ! ----------------------------------------------------------------------------
  ! Compute scene statistics.
  ! ----------------------------------------------------------------------------

  Target_Scene_Mean = Sum_Target / REAL(Total_Points_Target)
  Match_Scene_Mean = Match_Scene_Mean / REAL(Total_Points_Target)

  Target_Scene_Variance = Sum_Squared_Target / REAL(Total_Points_Target) - &
                                                      Target_Scene_Mean**2

  Match_Scene_Variance = Sum_Squared_Match / REAL(Total_Points_Target) - &
                                                     Match_Scene_Mean**2

  Target_Scene_StdDev = SQRT(Target_Scene_Variance)
  Match_Scene_StdDev = SQRT(Match_Scene_Variance)

  ! ----------------------------------------------------------------------------
  ! Compute linear correlation coefficient.
  ! ----------------------------------------------------------------------------
  Corr_Coeff_DB = (Sum_Squared_Match + Sum_Squared_Target - Min_SSD_Value) / &
       (2.0 * Total_Points_Target) - Target_Scene_Mean * Match_Scene_Mean

  Corr_Coeff = Corr_Coeff_DB / (Target_Scene_StdDev * Match_Scene_StdDev)


  ! ----------------------------------------------------------------------------
  ! Compute sub-pixel displacement. Interpolate lag matrix values to
  ! get fractional line and element displacements.
  ! ----------------------------------------------------------------------------


  Match_Lag_Element = Min_SSD_Element
  Match_Lag_Line = Min_SSD_Line

  CALL Interpolate_Disp(Match_Lag_Element, Match_Lag_Line, Fractional_Element, &
                                                              Fractional_Line)

  ! Add fractional values to integer displacement.

  Element_Disp = Element_Disp + Fractional_Element
  Line_Disp = Line_Disp + Fractional_Line

  ! convert to absolute displacement

  Element_Disp = Element_Disp + Delta_X_Fcst
  Line_Disp = Line_Disp + Delta_Y_Fcst

  DEALLOCATE(Target_1D, Search_1D, Lag_Matrix)

  IF (Corr_Coeff .LT. 0.) Corr_Coeff = 0.0

END SUBROUTINE Compute_Correlation

!-------------------------------------------------------------------------------
!
! Name:
!   Compute_UV
!
! Function:
!   Computes the u- and v- components of the wind from the beginning and ending
!   earth locations of the cloud feature. Computation is done in spherical
!   coordinates.
!
! Description:
!
! References:
!
! Calling sequence:
!   CALL Compute_UV
!
! Inputs:
!   Lat1                 Initial latitude of cloud feature
!   Lon1                 Initial longitude of cloud feature
!   Lat2                 Final latitude of cloud feature
!   Lon2                 Final longitude of cloud feature
!   Delta_Time           Time interval in fractional hours
!
! Outputs:
!   U                    U-component of wind (positive is west, negative is
!                        east) in meters per second
!   V                    V-component of wind (positive is south, negative is
!                        north) in meters per second
!
! Dependencies:
!   None
!
! Restrictions:
!   None
!
! History:
!   7/2007 - Wayne Bresky - Created
!
!-------------------------------------------------------------------------------
SUBROUTINE  Compute_UV(NavType, Lat1, Lon1, Lat2, Lon2, Delta_Time, U, V)

  REAL(SINGLE), INTENT(IN) :: Lat1
  REAL(SINGLE), INTENT(IN) :: Lon1
  REAL(SINGLE), INTENT(IN) :: Lat2
  REAL(SINGLE), INTENT(IN) :: Lon2
  REAL(SINGLE), INTENT(IN) :: Delta_Time
  Real(SINGLE) :: Delta_Lat
  Real(SINGLE) :: Delta_Lon
  Real(SINGLE) :: Cosine_Of_Lat
  Real(SINGLE) :: Avg_Lat
  REAL(SINGLE) :: Absolute_Delta_Time
  REAL(SINGLE) :: Delta_Time_Sec
  REAL(SINGLE), INTENT(OUT) :: U
  REAL(SINGLE), INTENT(OUT) :: V

  !  Earth equatorial radius (km)
  REAL(DOUBLE), PARAMETER :: R_EQ = 6378.137D0

  CHARACTER(LEN=*), INTENT(IN) :: NavType

  !
  ! Initialize wind components
  !

  U = 0.0
  V = 0.0

  !
  ! Convert hours to seconds
  !

  Delta_Time_Sec = Delta_Time * SEC_IN_A_HOUR
  Absolute_Delta_Time = ABS(Delta_Time) * SEC_IN_A_HOUR

  !
  ! Compute change in latitude and longitude
  !

  Delta_Lat = Lat2 - Lat1
  Delta_Lon = Lon2 - Lon1

  !
  ! Compute average latitude and cosine of average latitude
  !

  Avg_Lat = (Lat1 + Lat2) / 2.0
  Cosine_Of_Lat = COS(DTOR * Avg_Lat)

  !
  ! Convert longitude to range -180/+180 if necessary
  !

  IF (ABS(Delta_Lon) .GT. DEGREE180 .AND. Delta_Lon .GT. 0.0) Delta_Lon = &
                                                    Delta_Lon - DEGREE360
  IF (ABS(Delta_Lon) .GT. DEGREE180 .AND. Delta_Lon .LT. 0.0) Delta_Lon = &
                                                    Delta_Lon + DEGREE360
  !
  ! Convert change in degrees to radians
  !

  Delta_Lon = Delta_Lon * DTOR
  Delta_Lat = Delta_Lat * DTOR

  !
  ! Compute wind components
  !

  !Multiplying by 1000 converts the units from kilometers to meters


  U = R_EQ * KM2M * Cosine_Of_Lat * Delta_Lon / Delta_Time_Sec
  V = R_EQ * KM2M * Delta_Lat / Delta_Time_Sec

  IF (TRIM(NavType) .EQ. 'PS' ) THEN
      U = R_EQ * KM2M * Cosine_Of_Lat * Delta_Lon / Absolute_Delta_Time
      V = R_EQ * KM2M * Delta_Lat / Absolute_Delta_Time
  ENDIF

END SUBROUTINE Compute_UV

!-------------------------------------------------------------------------------
!
! Name:
!   Get_Fcst_Displacement
!
! Function:
!   Compute a (line and element) displacement from a starting position using the
!   input speed and time interval.
!
! Description:
!   This routine computes the expected displacement of a feature given a
!   starting location, a time interval and the forecast u- and v- wind
!   components. Note the time can be negative or positive. The displacement
!   returned by this routine is used to compute the ceter location of the
!   search region.


! Calling sequence:
!   CALL Get_Fcst_Displacement
!
! Inputs:
!   Starting_Lat         Initial latitude of cloud feature
!   Starting_Lon         Initial longitude of cloud feature
!   Delta_Time           Time interval in fractional hours (+ or -)
!   U                    Forecast u-component
!   V                    Forecast v-component
!   Sat_ID               Satellite ID
!   Target_Element       Center element of target box
!   Target_Line          Center line of target box
!
! Outputs:
!   Search_Element       Center element of search box
!   Search_Line          Center line of search box
!   Delta_X_Fcst         Forecast element displacement
!   Delta_Y_Fcst         Forecast line displacement
!
!
! Dependencies:
!   None
!
! Restrictions:
!   None
!
! History:
!  04/2010 - Wayne Bresky - Created from existing "New Position" subroutine
!
!-------------------------------------------------------------------------------
SUBROUTINE Get_Fcst_Displacement(Nav, NavType, Starting_Lat, Starting_Lon, Delta_Time, U, V, &
                                 Sensor_Series, Target_Element, Target_Line, Delta_X_Fcst, Delta_Y_Fcst)
  TYPE(Nav_t), INTENT(IN):: Nav
  CHARACTER(LEN=*), INTENT(IN) :: NavType
  INTEGER(LONG) :: Col
  INTEGER(LONG) :: Row
  INTEGER(LONG), INTENT(IN) :: Sensor_Series

  REAL(SINGLE), INTENT(IN) :: Starting_Lat
  REAL(SINGLE), INTENT(IN) :: Starting_Lon
  REAL(SINGLE), INTENT(IN) :: Delta_Time
  REAL(SINGLE), INTENT(IN) :: U
  REAL(SINGLE), INTENT(IN) :: V
  REAL(SINGLE), INTENT(IN) :: Target_Element
  REAL(SINGLE), INTENT(IN) :: Target_Line
  REAL(SINGLE) :: Ending_Lat
  REAL(SINGLE) :: Ending_Lon
  REAL(SINGLE), INTENT(OUT) :: Delta_X_Fcst
  REAL(SINGLE), INTENT(OUT) :: Delta_Y_Fcst
  REAL(SINGLE) :: Cosine_Of_Lat
  REAL(SINGLE) :: Avg_Lat
  REAL(SINGLE) :: Col_Real
  REAL(SINGLE) :: Row_Real

  !  Earth equatorial radius (km)
  REAL(DOUBLE), PARAMETER :: R_EQ = 6378.137D0



  ! Multiplying by 60**2 converts time from hours to seconds
  ! Multiplying by 1000 converts the units from kilometers to meters
  Ending_Lat = Starting_Lat + (V * Delta_Time * SEC_IN_A_HOUR) &
                        / (R_EQ * KM2M * DTOR)

  Avg_Lat = (Starting_Lat + Ending_Lat) / 2.0
  Cosine_Of_Lat = COS(DTOR * Avg_Lat)

  SELECT CASE (Sensor_Series)

  CASE (SERIES_MSG_SEVIRI)

    ! positive u corresponds with positive change in longitude

    ! Multiplying by 60**2 converts time from hours to seconds
    ! Multiplying by 1000 converts the units from kilometers to meters
    Ending_Lon = Starting_Lon + (U * Delta_Time * SEC_IN_A_HOUR) / &
                (R_EQ * KM2M * Cosine_Of_Lat * DTOR)

    ! Convert earth location to image pixel

    CALL geocoord2pixcoord_dp(Nav, DBLE(Ending_Lat), DBLE(Ending_Lon), Col_Real, Row_Real)

    Col = NINT(Col_Real)
    Row = NINT(Row_Real)

!  CASE (SERIES_GOES_N_IMG)
!
!    ! positive u corresponds with positive change in longitude
!
!    ! Multiplying by 60**2 converts time from hours to seconds
!    ! Multiplying by 1000 converts the units from kilometers to meters
!    Ending_Lon = Starting_Lon + (U * Delta_Time * SEC_IN_A_HOUR) / &
!                (R_EQ * KM2M * Cosine_Of_Lat * DTOR)
!
!    ! Convert earth location to image pixel
!
!    CALL geocoord2pixcoord_gvar(Nav, Ending_Lat, Ending_Lon, 1, Col_Real, Row_Real)
!
!    Col = NINT(Col_Real)
!    Row = NINT(Row_Real)

  CASE (SERIES_GOESR_ABI,SERIES_HIMAWARI_AHI)

    ! Multiplying by 60**2 converts time from hours to seconds
    ! Multiplying by 1000 converts the units from kilometers to meters
    Ending_Lon = Starting_Lon + (U * Delta_Time * SEC_IN_A_HOUR) / &
                (R_EQ * KM2M * Cosine_Of_Lat * DTOR)

    ! Convert earth location to image pixel

    CALL geocoord2pixcoord_abi(Nav,  DBLE(Ending_Lat), DBLE(Ending_Lon), Col, Row)


  END SELECT

  ! polar winds test
  IF (TRIM(NavType) .EQ. 'PS') THEN

    ! positive u corresponds with positive change in longitude

    ! Multiplying by 60**2 converts time from hours to seconds
    ! Multiplying by 1000 converts the units from kilometers to meters
    Ending_Lon = Starting_Lon - (U * Delta_Time * SEC_IN_A_HOUR) / &
                (R_EQ * KM2M * Cosine_Of_Lat * DTOR)

    CALL geocoord2pixcoord_ps(Nav, Ending_Lat, Ending_Lon, Col_Real, Row_Real)

    Col = NINT(Col_Real)
    Row = NINT(Row_Real)

  ENDIF

  Delta_X_Fcst = REAL(Col) - Target_Element
  Delta_Y_Fcst = REAL(Row) - Target_Line

  ! EUMETSAT coordinate system is reversed from GEOCAT coordinate system,
  ! so we need to reverse the sign of the forecast displacement

  IF (Sensor_Series == SERIES_MSG_SEVIRI) THEN
    Delta_X_Fcst = -Delta_X_Fcst
    Delta_Y_Fcst = -Delta_Y_Fcst
  ENDIF

END SUBROUTINE Get_Fcst_Displacement

!-------------------------------------------------------------------------------
!
! Name:
!   Interpolate_Disp
!
! Function:
!   Compute sub-pixel displacement through interpolation.
!
! Description:
!   This routine computes the fractional displacement through interpolation
!   of the 4 points surrounding the match location.

! Calling sequence:
!   CALL Interpolate_Disp
!
! Inputs:
!   Match_Lag_Element    Element coordinate of match within lag matrix
!   Match_Lag_Line       Line coordinate of match within lag matrix
!
! Outputs:
!   Fractional_Element   Fractional element displacement
!   Fractional_Line      Fractional line displacement
!
! Dependencies:
!   Requires the lag matrix to be filled with values.
!
! Restrictions:
!   None
!
! History:
!   7/2007 - Wayne Bresky - Created
!
!-------------------------------------------------------------------------------
SUBROUTINE Interpolate_Disp(Match_Lag_Element, Match_Lag_Line, &
                          Fractional_Element, Fractional_Line)

  INTEGER(LONG), INTENT(IN) :: Match_Lag_Element
  INTEGER(LONG), INTENT(IN) :: Match_Lag_Line
  REAL(SINGLE), INTENT(OUT) :: Fractional_Element
  REAL(SINGLE), INTENT(OUT) :: Fractional_Line
  INTEGER(LONG) :: First_Index
  INTEGER(LONG) :: Middle_Index
  INTEGER(LONG) :: Third_Index
  REAL(SINGLE) :: Denominator
  REAL(SINGLE) :: Middle_Point
  REAL(SINGLE) :: First_Point
  REAL(SINGLE) :: Third_Point

  Fractional_Element = 0.0
  Fractional_Line = 0.0

  ! Check if match is on boundary. If so, do not interpolate.

  IF (Match_Lag_Element .EQ. 1 .OR. Match_Lag_Element .EQ. Lag_Element_Size &
  .OR. Match_Lag_Line .EQ. 1 .OR. Match_Lag_Line .EQ. Lag_Line_Size) RETURN

  ! Line interpolation

  Middle_Index = Lag_Element_Size * (Match_Lag_Line - 1) + Match_Lag_Element
  First_Index = Middle_Index - Lag_Element_Size
  Third_Index = Middle_Index + Lag_Element_Size

  First_Point = Lag_Matrix(First_Index)
  Middle_Point = Lag_Matrix(Middle_Index)
  Third_Point = Lag_Matrix(Third_Index)

  ! Linear interpolation equation in 1D
  Denominator = 2.0 * (First_Point + Third_Point - 2.0 * Middle_Point)

  IF (Denominator .NE. 0.0) Fractional_Line = (First_Point - Third_Point) / &
                                                                Denominator

  ! Element interpolation

  First_Index = Middle_Index - 1
  Third_Index = Middle_Index +  1

  First_Point = Lag_Matrix(First_Index)
  Third_Point = Lag_Matrix(Third_Index)

  ! Linear interpolation equation in 1D
  Denominator = 2.0 * (First_Point + Third_Point - 2.0 * Middle_Point)

  IF (Denominator .NE. 0.0) Fractional_Element = (First_Point - Third_Point) / &
                                                                   Denominator

END SUBROUTINE Interpolate_Disp

!-------------------------------------------------------------------------------
!
! Name:
!   Generate_Spiral_Table
!
! Function:
!   Produces a table of positions that spirals out from from the search
!   center point.
!
! Description:
!   A simple routine for generating a prioritized list of positions to search.
!   The list of positions describes a clockwise spiral starting at the center
!   point of the search region. By using the spiral table, the search for
!   the match begins at the location predicted by the forecast instead of
!   beginning at the top left corner as is the usual case. This list,
!   when used with the strategy of terminating the SSD summation early
!   once a minimum has been exceeded, speeds up the computational performance
!   of the search process by setting the SSD minimum to a low initial value.
!
! Calling sequence:
!   Generate_Spiral_Table
!
! Inputs:
!   Search_Size          Size of Search Box
!   Lag_Size             Size of lag matrix
!   Size_Diff            Size difference in pixels between the nested box and
!                        the outer target box.
!
! Outputs:
!   Lag_Table2           List of positions in spiral
!
! Dependencies:
!   Assumes SSD similarity measure is being used for tracking.
!
! Restrictions:
!   None
!
! History:
!   06/01/2009 - Wayne Bresky - Created
!
!-------------------------------------------------------------------------------
SUBROUTINE Generate_Spiral_Table(Search_Size, Lag_Size, Size_Diff, Lag_Table2)

  INTEGER(BYTE) Sign_Pixel
  INTEGER(LONG) I
  INTEGER(LONG) J
  INTEGER(LONG) Point
  INTEGER(LONG) Element
  INTEGER(LONG) Line
  INTEGER(LONG) Lag_Index
  INTEGER(LONG) Search_Index
  INTEGER(LONG) Small_Search_Element_Size
  INTEGER(LONG) Lag_Center_Element
  INTEGER(LONG) Lag_Center_Line
  INTEGER(LONG) Total_Points_Lag
  INTEGER(LONG), INTENT(IN) :: Search_Size
  INTEGER(LONG), INTENT(IN) :: Lag_Size
  INTEGER(LONG), INTENT(IN) :: Size_Diff
  INTEGER(LONG), INTENT(INOUT), DIMENSION(:,:) :: Lag_Table2

  Small_Search_Element_Size = Search_Size - Size_Diff
  Lag_Center_Element = (Lag_Size + 1) / 2
  Lag_Center_Line = Lag_Center_Element
  Total_Points_Lag = Lag_Size**2

  Point = 1
  Sign_Pixel = -1
  Element = Lag_Center_Element
  Line = Lag_Center_Line
  Lag_Table2(1,1) = Lag_Center_Element
  Lag_Table2(1,2) = Lag_Center_Line
  Lag_Table2(1,3) = (Total_Points_Lag) / 2 + 1
  Lag_Table2(1,4) = (Lag_Center_Line - 1) * Small_Search_Element_Size &
                                                + Lag_Center_Element

  DO I = 1, Total_Points_Lag

    Sign_Pixel = Sign_Pixel * (-1)

    DO J = 1,I

      Point = Point + 1

      IF (Point .GT. Total_Points_Lag) RETURN

      Element = Element + Sign_Pixel

      IF (Element .GT. 0 .AND. Line .GT. 0 .AND. Element .LE. &
         Lag_Size .AND. Line .LE. Lag_Size) THEN

        Lag_Index = (Line - 1) * Lag_Size + Element
        Search_Index = (Line - 1) * Small_Search_Element_Size + Element
        Lag_Table2(Point,1) = Element
        Lag_Table2(Point,2) = Line
        Lag_Table2(Point,3) = Lag_Index
        Lag_Table2(Point,4) = Search_Index

      ELSE

        Point = Point - 1

      ENDIF

    ENDDO

    DO J = 1,I

      Point = Point + 1

      IF (Point .GT. Total_Points_Lag) RETURN

      Line = Line + Sign_Pixel

      IF (Element .GT. 0 .AND. Line .GT. 0 .AND. Element .LE. &
         Lag_Size .AND. Line .LE. Lag_Size) THEN

        Lag_Index = (Line - 1) * Lag_Size + Element
        Search_Index = (Line - 1) * Small_Search_Element_Size + Element
        Lag_Table2(Point,1) = Element
        Lag_Table2(Point,2) = Line
        Lag_Table2(Point,3) = Lag_Index
        Lag_Table2(Point,4) = Search_Index

      ELSE

        Point = Point - 1

      ENDIF

    ENDDO

  ENDDO

END SUBROUTINE Generate_Spiral_Table

!-------------------------------------------------------------------------------
!
! Name:
!   Nested_Tracking
!
! Function:
!   Version of Compute_Correlation designed to compute multiple displacement
!   estimates for small sub-regions (5x5 pixel box) of larger target box.
!   Essentially, the smaller box is "nested" within the larger box and shifted
!   one pixel at a time in order to compute the local motion for all interior
!   pixel locations.
!
! Description:
!   This is a modified version of Compute_Correlation that computes multiple
!   displacement estimates for small sub-regions of the larger target box.
!   A cluster analysis algorithm called DBSCAN is then used to find the
!   largest cluster in line/element space. The displacements associated with
!   the points in the largest cluster are then averaged to yield a final motion
!   estimate for the larger box. Likewise, the cloud top pressure values (or BT
!   when processing the WV) associated with the points in the largest cluster
!   are retained so that they can be used by target_selection to assign a median
!   pressure for the wind.
!
! References:
!   Daniels and Bresky (2010), "A New Nested Tracking Approach for Reducing the
!   Slow Speed Bias Associated with Atmospheric Motion Vectors (AMVs)."
!   Proceedings of the Tenth International Winds Workshop (IWW10).
!
! Calling sequence:
!   Call Nested_Tracking
!
! Input:
!   Vector               Vector number (1=reverse, 2=forward)
!   CSWV_Flag            Clear-sky WV flag (0=no, 1=yes)
!   Box_Data             Target box data structure
!   Search_BT_Values     Brightness temperature values for search region
!   Delta_X_Sat          Distance between target center and search center
!   Delta_Y_Sat          Distance between target center and search center
!   Band                 Satellite band
!   Lag_Table            List of positions in spiral search
!   Factor               pixel factor (ratio of E-W distance to N-S distance)
!   Output               output variables data structure of target
!
! Input/Output:
!   DBSCAN_Out           DBSCAN output structure
!   Status_Flag          Success value:
!                            0   - Match found
!                            300 - Missing data
!                            400 - Zero good sample
!
! Output:
!   Line_Disp            Line displacement of match relative to center of search
!   Element_Disp         Element displacement of match relative to center
!                        of search
!   Least_Square_Error   Minimum sum of squared differences value
!   Target_Scene_Mean    Mean brightness temperature value of target
!   Match_Scene_Mean     Mean brightness temperature value of match
!   Target_Scene_StdDev  Standard deviation of target scene brightness
!                        temperature values
!   Match_Scene_StdDev   Standard deviation of match scene brightness
!                        temperature values
!   Corr_Coeff           Linear correlation value of matching scene
!
! Dependencies:
!   None
!
! Restrictions:
!   None
!
! History:
!   04/27/2009 - Wayne Bresky - Created
!   11/01/2009 - Wayne Bresky - DBSCAN cluster analysis added
!   08/10/2010 - Wayne Bresky - DBSCAN output structure created
!   07/27/2011 - Wayne Bresky - output variables data structure included in call
!   09/30/2025 - Wayne Bresky - modified to combine displacements from both time steps 
!                               and only call DBSCAN once 
!
!-------------------------------------------------------------------------------
SUBROUTINE Nested_Tracking(NavType, Vector, CSWV_Flag, Box_Data, Search_BT_Values, &
                                           Delta_X_Sat, Delta_Y_Sat, Band, Lag_Table2, &
                                          Line_Disp, Element_Disp, TandemTriplet, Least_Square_Error, & !<-- aab Tandem mod
                                          Factor, Target_Scene_Mean, Match_Scene_Mean, &
                                  Target_Scene_StdDev, Match_Scene_StdDev, Corr_Coeff, &
                                    Status_Flag, DBSCAN_Out, SetOfPoints_Init)
  CHARACTER(LEN=*), PARAMETER :: FUNC ="Nested_Tracking"
  CHARACTER(LEN=*), INTENT(IN) :: NavType
  ! Vector number (1=reverse, 2=forward)
  INTEGER(LONG), INTENT(IN) :: Vector
  ! clear sky flag
  INTEGER(LONG), INTENT(IN) :: CSWV_Flag
  TYPE(Target_Box_Data), INTENT(IN) :: Box_Data
  REAL(SINGLE), INTENT(IN), DIMENSION(:,:) :: Search_BT_Values !< Brightness Temperature for target and match scenes
  REAL(SINGLE), INTENT(IN) :: Delta_X_Sat !< Distance in pixels between target center and search center
  REAL(SINGLE), INTENT(IN) :: Delta_Y_Sat !< Distance in pixels between target center and search center
  INTEGER(LONG), INTENT(IN) :: Band !< Satellite band
  INTEGER(LONG), DIMENSION(:, :), INTENT(IN) :: Lag_Table2
  REAL(SINGLE), INTENT(OUT) :: Line_Disp !< Vector displcement in satellite coordinates
  REAL(SINGLE), INTENT(OUT) :: Element_Disp !< Vector displcement in satellite coordinates
  CHARACTER(LEN=*), INTENT(IN) :: TandemTriplet   !<-- aab Tandem mod
  INTEGER(LONG), INTENT(OUT) :: Least_Square_Error!< Least square error associated match
  REAL(SINGLE), INTENT(IN) :: Factor !< Normalization factor
  REAL(DOUBLE), INTENT(OUT) :: Target_Scene_Mean
  REAL(DOUBLE), INTENT(OUT) :: Match_Scene_Mean
  REAL(DOUBLE), INTENT(OUT) :: Target_Scene_StdDev
  REAL(DOUBLE), INTENT(OUT) :: Match_Scene_StdDev
  REAL(SINGLE), INTENT(OUT) :: Corr_Coeff !< linear correlation coefficient associated match
  INTEGER(LONG), INTENT(INOUT) :: Status_Flag !< Flag to indicate success or failure of correlation matching
  TYPE(DBSCAN_Output), INTENT(INOUT) :: DBSCAN_Out
  REAL(SINGLE), DIMENSION(:,:), INTENT(INOUT) :: SetOfPoints_Init


  INTEGER(LONG) :: Lag_Center_Element !< Lag matrix center point
  INTEGER(LONG) :: Lag_Center_Line!< Lag matrix center point
  INTEGER(LONG) :: Total_Points_Lag



  ! DBSCAN variables
  INTEGER(LONG) MinPts
  INTEGER(LONG) :: NumberOfClusters
  INTEGER(LONG) :: MaxCluster
  INTEGER(LONG) :: MaxClusterSize
  REAL(SINGLE) :: Eps
  REAL(SINGLE), ALLOCATABLE, DIMENSION(:,:) :: SetOfPoints

  ! Minimum SSD value and location
  REAL(DOUBLE) :: Min_SSD_Value
  INTEGER(LONG) :: Min_SSD_Location
  INTEGER(LONG) :: Min_SSD_Element
  INTEGER(LONG) :: Min_SSD_Line

  INTEGER(LONG) :: Match_Lag_Element
  INTEGER(LONG) :: Match_Lag_Line

  ! Offset for location of match area within search grid
  INTEGER(LONG) :: Match_Offset

  INTEGER(LONG) :: Element_Counter_Target
  INTEGER(LONG) :: Target_Index
  INTEGER(LONG) :: Element_Counter_Search
  INTEGER(LONG) :: Element
  INTEGER(LONG) :: Line
  INTEGER(LONG) :: Search_Index


  REAL(DOUBLE) :: Sum_Target
  REAL(DOUBLE) :: Sum_Squared_Target
  REAL(DOUBLE) :: Sum_Squared_Match
  REAL(DOUBLE) :: Target_Scene_Variance
  REAL(DOUBLE) :: Match_Scene_Variance
  INTEGER(LONG) :: Total_Points_Search

  ! statistics for 5x5 target and match scenes
  REAL(DOUBLE) :: Sum_Product
  REAL(DOUBLE) :: Sum_Diff_Squared_Target
  REAL(DOUBLE) :: Sum_Diff_Squared_Match
  REAL(DOUBLE) :: Small_Target_Mean
  REAL(DOUBLE) :: Small_Match_Mean
  REAL(DOUBLE) :: Small_Target_StdDev
  REAL(DOUBLE) :: Small_Match_StdDev
  REAL(DOUBLE) :: Corr_Coeff_5x5

  REAL(DOUBLE) :: Corr_Coeff_5x5_Thresh

  REAL(SINGLE) Relative_Ele_Disp
  REAL(SINGLE) Relative_Line_Disp
  REAL(SINGLE) :: Fractional_Element
  REAL(SINGLE) :: Fractional_Line


  INTEGER(LONG) :: Total_Points_Target
  INTEGER(LONG) Small_Target_Element_Size
  INTEGER(LONG) Small_Target_Line_Size
  INTEGER(LONG) Number_Of_Loops
  INTEGER(LONG) Small_Search_Element_Size
  INTEGER(LONG) Small_Search_Line_Size
  INTEGER(LONG) Points_Small_Target
  INTEGER(LONG) Points_Small_Search
  INTEGER(LONG) Counter
  INTEGER(LONG) Good_Sample, good_sample_rev, good_sample_x2, idx1, idx2, mxsize_rev, mxsize_for  ! aab Tandem (dbscan)
  INTEGER(LONG) Initial_Sample
  INTEGER(LONG) Good_CTP_Sample
  INTEGER(LONG) sample_size_rev, sample_size_for  ! aab Tandem (dbscan) 
  INTEGER(LONG) Good_BT_Sample
  INTEGER(LONG) Center_Element
  INTEGER(LONG) Center_Line
  INTEGER(LONG) Center_Element_FS
  INTEGER(LONG) Center_Line_FS
  INTEGER(LONG) Center_Element_SS
  INTEGER(LONG) Center_Line_SS
  INTEGER(LONG) Point
  INTEGER(LONG) Diff_In_Size
  INTEGER(LONG) Pixel_Offset
  INTEGER(LONG) Pixel_Offset_Search
  ! Offset between small search center and large search center
  INTEGER(LONG) Ele_Shift_Search
  INTEGER(LONG) Line_Shift_Search


  INTEGER(LONG) I_Upper, I1, I2, I3, I4, L1

  ! Array holding the phase type counts of largest cluster
  ! (0=clear, 1=liquid, 2=supercooled, 3=mixed, 4=ice)

  INTEGER phase_counts(4), dominant_phase

  ! Add variables for initial sample
  REAL(DOUBLE) Sum_Delta_X_Initial
  REAL(DOUBLE) Sum_Delta_Y_Initial
  REAL(DOUBLE) Avg_Delta_X_Initial
  REAL(DOUBLE) Avg_Delta_Y_Initial

  REAL(DOUBLE), DIMENSION(:), ALLOCATABLE :: Delta_X
  REAL(DOUBLE), DIMENSION(:), ALLOCATABLE :: Delta_Y
  REAL(DOUBLE), DIMENSION(:), ALLOCATABLE :: Delta_X_Final
  REAL(DOUBLE), DIMENSION(:), ALLOCATABLE :: Delta_Y_Final
  REAL(DOUBLE), DIMENSION(:), ALLOCATABLE :: Dist
  REAL(SINGLE), DIMENSION(:), ALLOCATABLE :: Small_Target
  REAL(SINGLE), DIMENSION(:), ALLOCATABLE :: Small_Search
  REAL(DOUBLE), DIMENSION(:), ALLOCATABLE :: Small_Match

  REAL(DOUBLE) Sum_Delta_X
  REAL(DOUBLE) Sum_Delta_Y
  REAL(DOUBLE) Sum_Dist
  REAL(DOUBLE) Sum_Dist_Squared
  REAL(DOUBLE) Avg_Delta_X
  REAL(DOUBLE) Avg_Delta_Y
  REAL(DOUBLE) Avg_Dist
  REAL(DOUBLE) StdDev_Delta_X
  REAL(DOUBLE) StdDev_Delta_Y
  REAL(DOUBLE) StdDev
  REAL(DOUBLE) PctOfAvg
  REAL(DOUBLE) Mean_Abs_Dev
  REAL(DOUBLE) Cutoff_1SD
  REAL(DOUBLE) Median_Delta_X
  REAL(DOUBLE) Median_Delta_Y

  REAL(DOUBLE) :: Corr_Coeff_DB

  integer i,j



  ! Make sure search array is larger than target array. Return control if
  ! it isn't.

  Target_Element_Size = SIZE(Box_Data%BrtTemp, 1)
  Target_Line_Size = SIZE(Box_Data%BrtTemp, 2)
  Total_Points_Target = Target_Element_Size * Target_Line_Size
  Search_Element_Size = SIZE(Search_BT_Values, 1)
  Search_Line_Size = SIZE(Search_BT_Values, 2)
  Total_Points_Search = Search_Element_Size * Search_Line_Size


  !-----------------------------------------------------------------------------
  ! Initialize variables
  !-----------------------------------------------------------------------------

  Line_Disp = 0.0
  Element_Disp = 0.0
  Least_Square_Error = 0
  Corr_Coeff = 0.0
  Target_Scene_Mean = 0.0
  Target_Scene_StdDev = 0.0
  Match_Scene_Mean = 0.0
  Match_Scene_StdDev = 0.0
  Sum_Target = 0.0
  Sum_Squared_Target = 0.0
  Sum_Squared_Match = 0.0
  Sum_Delta_X_Initial = 0.0_DOUBLE
  Sum_Delta_Y_Initial = 0.0_DOUBLE
  Sum_Delta_X = 0.0
  Sum_Delta_Y = 0.0
  Avg_Delta_X = 0.0
  Avg_Delta_Y = 0.0
  Median_Delta_X = 0.0
  Median_Delta_Y = 0.0
  StdDev_Delta_X = 0.
  StdDev_Delta_Y = 0.
  Target_Scene_Variance = 0.0
  Match_Scene_Variance = 0.0
  Small_Target_Element_Size = 5
  Small_Target_Line_Size = 5
  Points_Small_Target = Small_Target_Element_Size * Small_Target_Line_Size
  Counter = 0
  Good_Sample = 0
  good_sample_x2 = 0
  
  ! aab Tandem (dbscan): keep track of combined sample if processing forward time step
  if (vector .eq. 2) then
          good_sample_rev = DBSCAN_Out%Initial_Sample  ! number of initial points from reverse time step
          good_sample_x2 = DBSCAN_Out%Initial_Sample   ! cumulative total from both time steps
  endif
  if (vector .eq. 1) Status_Flag = ZERO_INITIAL_SAMPLE

  StdDev = 0.
  PctOfAvg = 0.
  Sum_Dist = 0.
  Sum_Dist_Squared = 0.
  Avg_Dist = 0.
  Mean_Abs_Dev = 0.
  Cutoff_1SD = 0.
  Center_Element = (Target_Element_Size + 1) / 2
  Center_Line = (Target_Line_Size + 1) / 2
  Pixel_Offset = Small_Target_Element_Size / 2
  Center_Element_FS = (Search_Element_Size + 1) / 2
  Center_Line_FS = (Search_Line_Size + 1) / 2

  ALLOCATE(Target_1D(Total_Points_Target), Search_1D(Total_Points_Search))

  !-----------------------------------------------------------------------------
  ! Reshape 2-D box data into vectors for pattern matching code.
  !-----------------------------------------------------------------------------

  Target_1D = RESHAPE(Box_Data%BrtTemp, (/Total_Points_Target/))
  Search_1D = RESHAPE(Search_BT_Values, (/Total_Points_Search/))

  ! ----------------------------------------------------------------------------
  ! Specify "lag" coefficient matrix size. This array contains the SSD
  ! values for all possible lag positions of the template within the
  ! search region. This array is filled regardless of the tracking
  ! method because it is used by both the LP norm and CC methods.
  !
  ! Note: The lag size is the same whether or not nested tracking is used.
  !-----------------------------------------------------------------------------

  Lag_Element_Size = Search_Element_Size - Target_Element_Size + 1
  Lag_Line_Size = Search_Line_Size - Target_Line_Size + 1
  Lag_Center_Element = (Lag_Element_Size + 1) / 2
  Lag_Center_Line = (Lag_Line_Size + 1) / 2
  Total_Points_Lag = Lag_Element_Size * Lag_Line_Size

  Small_Search_Element_Size = Small_Target_Element_Size + Lag_Element_Size - 1
  Small_Search_Line_Size = Small_Target_Line_Size + Lag_Line_Size - 1
  Points_Small_Search = Small_Search_Element_Size * Small_Search_Line_Size
  Number_Of_Loops = (Target_Element_Size - 2*Pixel_Offset) * (Target_Line_Size - 2*Pixel_Offset)
  Pixel_Offset_Search = Small_Search_Element_Size / 2

  ! ----------------------------------------------------------------------------
  ! Need to compute difference in size between the large target box and the
  ! small target box. This is also the difference in size between the large
  ! search region and the small search region.
  ! ----------------------------------------------------------------------------

  Diff_In_Size = Target_Element_Size - Small_Target_Element_Size

  ALLOCATE(Lag_Matrix(Total_Points_Lag))
  ALLOCATE(Small_Target(Points_Small_Target))
  ALLOCATE(Small_Search(Points_Small_Search))
  ALLOCATE(Small_Match(Points_Small_Target), source=MISSING_VALUE_DOUBLE)
  ALLOCATE(Delta_X(Number_Of_Loops), Delta_Y(Number_Of_Loops))
  !ALLOCATE(SetOfPoints(Number_Of_Loops, DBSCAN_Output_Variables))
  ALLOCATE(SetOfPoints(size(SetOfPoints_Init, dim=1), size(SetOfPoints_Init, dim=2)), source=MISSING_VALUE_SINGLE)

  ! For each interior pixel of the larger target box, find the local motion
  ! associated with a smaller 5x5 scene. In effect, we are "nesting" a 5x5
  ! box within the larger box containing the entire target scene. This
  ! produces a sample of local motion vectors.

  DO  Line = Pixel_Offset + 1, Target_Line_Size - Pixel_Offset

    DO Element = Pixel_Offset + 1, Target_Element_Size - Pixel_Offset

      Counter = Counter + 1
      Delta_X(Counter) = MISSING_VALUE_REAL4
      Delta_Y(Counter) = MISSING_VALUE_REAL4
      Sum_Product = 0.0
      Small_Target_Mean = 0.0
      Small_Match_Mean = 0.0
      Small_Target_StdDev = 0.0
      Small_Match_StdDev = 0.0
      Corr_Coeff_5x5 = 0.0

      ! compute center element of small search box
      Center_Element_SS = Element + ((Small_Search_Element_Size + 1)/2) - 3
      ! center line of small search box
      Center_Line_SS = Line + ((Small_Search_Line_Size + 1)/2) - 3

      Ele_Shift_Search = Center_Element_SS - Center_Element_FS
      Line_Shift_Search = Center_Line_SS - Center_Line_FS

      ! wcb 11/19/13
      ! filter out missing values
      ! wcb 11/19/15
      ! modified check to filter out values exceeding 1100
      ! associated with negative heights
      ! wcb - 1/25/16
      ! only apply check if processing cloudy targets

      IF (CSWV_Flag .EQ. sym%NO) THEN

        IF (Box_Data%Cld_Top_Press(Element, Line) .EQ. MISSING_VALUE_REAL4 .OR. &
            Box_Data%Cld_Top_Press(Element, Line) .GT. CTP_MAX) CYCLE

        ! WCB - also check cloud height quality flag
        ! AAB - Now skipping this check. Allow AMVs from the below QF values through.

        !IF (Box_Data%CldHgtQF(Element, Line) .EQ. MISSING_VALUE_INT1 .OR. &

        !    Box_Data%CldHgtQF(Element, Line) .EQ. CTH_DQF_MARGINAL_RETREVIAL .OR.  &

        !    Box_Data%CldHgtQF(Element, Line) .EQ. CTH_DQF_RETREVIAL_ATTEMPTED .OR.  &

        !    Box_Data%CldHgtQF(Element, Line) .EQ. CTH_DQF_BAD_RETREVIAL) CYCLE

      ENDIF

      ! fill small target

      I_Upper = Small_Target_Element_Size - 1
      DO I = 0, I_Upper

        I1 = I*Small_Target_Element_Size+1
        I2 = I1 + Small_Target_Element_Size - 1
        I3 = Element-Pixel_Offset
        I4 = Element+Pixel_Offset
        L1 = Line-Pixel_Offset+I
        Small_Target(I1:I2) = Box_Data%BrtTemp(I3:I4, L1)

      ENDDO

      ! Subsample the large search region to fill small search region.

      I_Upper = Small_Search_Element_Size - 1
      DO I = 0, I_Upper

        I1 = I*Small_Search_Element_Size+1
        I2 = I1 + Small_Search_Element_Size - 1
        I3 = Center_Element_SS-Pixel_Offset_Search
        I4 = Center_Element_SS+Pixel_Offset_Search
        L1 = Center_Line_SS-Pixel_Offset_Search+I
        Small_Search(I1:I2) = Search_BT_Values(I3:I4, L1)

      ENDDO

      CALL Fill_Lag_Matrix_1D(Lag_Element_Size, Diff_In_Size, Small_Target, &
                                      Small_Search, Lag_Table2, Lag_Matrix)

      ! ----------------------------------------------------------------------------
      ! Determine location of match within lag matrix.
      ! ----------------------------------------------------------------------------

      Min_SSD_Value = MINVAL(Lag_Matrix)
      Least_Square_Error = Min_SSD_Value
      Min_SSD_Location = MINLOC(Lag_Matrix, 1)
      Min_SSD_Element = MOD(Min_SSD_Location, Lag_Element_Size)

      IF (MOD(Min_SSD_Location, Lag_Element_Size) .EQ. 0) THEN
        Min_SSD_Element = Lag_Element_Size
        Min_SSD_Line = (Min_SSD_Location / Lag_Element_Size)
      ELSE
        Min_SSD_Line = (Min_SSD_Location / Lag_Element_Size) + 1
      ENDIF

      ! ----------------------------------------------------------------------------
      ! Do not accept match if located on boundary. This condition may indicate the
      ! true match is located beyond the domain of the search.
      ! ----------------------------------------------------------------------------

      IF (Min_SSD_Element .EQ. 1 .OR. Min_SSD_Element .EQ. Lag_Element_Size .OR. &
                 Min_SSD_Line .EQ. 1 .OR. Min_SSD_Line .EQ. Lag_Line_Size) CYCLE

      ! Fill small match array and compute correlation

      Match_Offset = (Min_SSD_Line - 1) * Small_Search_Element_Size &
                                                  + Min_SSD_Element

      I_Upper = Small_Target_Element_Size - 1
      DO I = 0, I_Upper

        I1 = I*Small_Target_Element_Size + 1 !row1,column1
        I2 = I1 + Small_Target_Element_Size - 1 !row2,column2
        I3 = Match_Offset
        I4 = I3 + Small_Target_Element_Size - 1
        Small_Match(I1:I2) = Small_Search(I3:I4)

        Match_Offset = Match_Offset + Small_Search_Element_Size

      ENDDO

      ! discard match if missing values are present

      IF (ANY(Small_Match == MISSING_VALUE_REAL4)) CYCLE

      Small_Target_Mean = SUM(Small_Target) / REAL(Points_Small_Target)
      Small_Match_Mean = SUM(Small_Match) / REAL(Points_Small_Target)

      Sum_Product = 0.0
      Sum_Diff_Squared_Target = 0.0
      Sum_Diff_Squared_Match = 0.0

      DO Point=1,Points_Small_Target

        Sum_Product = Sum_Product + (Small_Target(Point) - Small_Target_Mean) &
                                    * (Small_Match(Point) - Small_Match_Mean)

        Sum_Diff_Squared_Target = Sum_Diff_Squared_Target &
           + (Small_Target(Point) - Small_Target_Mean)**2

        Sum_Diff_Squared_Match = Sum_Diff_Squared_Match &
           + (Small_Match(Point) - Small_Match_Mean)**2

      ENDDO

      Small_Target_StdDev = SQRT(Sum_Diff_Squared_Target)
      Small_Match_StdDev = SQRT(Sum_Diff_Squared_Match)

      Corr_Coeff_5x5= Sum_Product / (Small_Target_StdDev * Small_Match_StdDev)

      ! use appropriate correlation threshold - 1/25/16

      IF (TRIM(NavType) .EQ. 'PS' .AND. CSWV_Flag .EQ. sym%YES) THEN

        Corr_Coeff_5x5_Thresh = CORR_COEFF_5X5_POLAR_CSWV

      ELSE IF (TRIM(NavType) .EQ. 'PS' .AND. CSWV_Flag .EQ. sym%NO) THEN

        ! aab Tandem mod
        !Corr_Coeff_5x5_Thresh = CORR_COEFF_5X5_POLAR_CLD

        ! Tandem VIIRS Polar winds Corr Coeff is set based on triplet configuration.
        SELECT CASE(TandemTriplet)
           CASE ('S') ! Single-Sat (default)
              Corr_Coeff_5x5_Thresh = CORR_COEFF_5X5_POLAR_CLD_S
           CASE ('D') ! Dual-Sat
              Corr_Coeff_5x5_Thresh = CORR_COEFF_5X5_POLAR_CLD_D
           CASE ('T') ! Three-Sat
              Corr_Coeff_5x5_Thresh = CORR_COEFF_5X5_POLAR_CLD_T
           CASE DEFAULT
              Corr_Coeff_5x5_Thresh = CORR_COEFF_5X5_POLAR_CLD_S
        END SELECT

      ELSE

        Corr_Coeff_5x5_Thresh = CORR_COEFF_5X5_GEO

      ENDIF

      ! filter out matches having low correlation scores
      ! introduced Corr_Coeff_5x5_Thresh - 1/25/16

      IF (Corr_Coeff_5x5 .LT. Corr_Coeff_5x5_Thresh)   CYCLE

      Good_Sample = Good_Sample + 1
      ! aab Tandem (dbscan): increment combined sample at the same time
      good_sample_x2 = good_sample_x2 + 1

      ! Compute displacement of match relative to lag center point

      Element_Disp = REAL(Min_SSD_Element - Lag_Center_Element)
      Line_Disp = REAL(Min_SSD_Line - Lag_Center_Line)
      Match_Lag_Element = Min_SSD_Element
      Match_Lag_Line = Min_SSD_Line

      CALL Interpolate_Disp(Match_Lag_Element, Match_Lag_Line, &
                          Fractional_Element, Fractional_Line)

      ! Add fractional values to integer displacement.

      Element_Disp = Element_Disp + Fractional_Element
      Line_Disp = Line_Disp + Fractional_Line

      ! Compute absolute displacement taking into account the displacement of
      ! the small target box relative to the center of the larger box. The
      ! absolute displacement is needed for the DBSCAN analysis.

      Delta_X(Counter) = REAL(Center_Element) + Delta_X_Sat &
                           + Element_Disp - Element

      Delta_Y(Counter) = REAL(Center_Line) + Delta_Y_Sat &
                              + Line_Disp - Line

      ! account for offset between small search and large search

      Delta_X(Counter) = Delta_X(Counter) + Ele_Shift_Search
      Delta_Y(Counter) = Delta_Y(Counter) + Line_Shift_Search

      ! ------------------------------------------------------------------------
      ! Array of points for DBSCAN
      ! This is the initial set of points that is analyzed for motion clusters
      ! ------------------------------------------------------------------------

      !SetOfPoints(Good_Sample, 1) = Delta_X(Counter)

      ! Multiply element displacement by normalization factor

      SetOfPoints(Good_Sample, 1) = Delta_X(Counter) * Factor
      SetOfPoints(Good_Sample, 2) = Delta_Y(Counter)
      SetOfPoints(Good_Sample, 5) = REAL(Element)
      SetOfPoints(Good_Sample, 6) = REAL(Line)
      SetOfPoints(Good_Sample, 7) = Box_Data%Cld_Top_Press(Element, Line)
      SetOfPoints(Good_Sample, 8) = Box_Data%Cld_Hgt(Element, Line)
      SetOfPoints(Good_Sample, 9) = Box_Data%Press_Error(Element, Line)
      SetOfPoints(Good_Sample, 10) = Box_Data%Temp_Error(Element, Line)
      SetOfPoints(Good_Sample, 11) = Box_Data%Cld_Top_Temp(Element, Line)
      SetOfPoints(Good_Sample, 12) = Corr_Coeff_5x5
      SetOfPoints(Good_Sample, 13) = Box_Data%Cloud_Phase(Element, Line)
      SetOfPoints(Good_Sample, 14) = Box_Data%Cloud_Type(Element, Line)
      SetOfPoints(Good_Sample, 15) = Box_Data%Cld_OD(Element, Line)
      SetOfPoints(Good_Sample, 16) = Box_Data%ACHA_Cost(Element, Line)
      SetOfPoints(Good_Sample, 17) = vector  ! aab Tandem (dbscan)

      ! fill 2-D arrays for plotting

      DBSCAN_Out%Delta_X_Init(Element, Line) = Delta_X(Counter)
      DBSCAN_Out%Delta_Y_Init(Element, Line) = Delta_Y(Counter)

    END DO        ! element loop

  END DO          ! line loop

  ! Call DBSCAN algorithm

  MinPts = 4       ! minimum number of points in a cluster

  ! aab Tandem (dbscan)
  ! Specify neighborhood radius parameter (epsilon), use larger value for ABI visible winds
  IF (Band .EQ. NATIVE_ABI_CHN2) THEN
    Eps = EPS_GEO_VZ
  ELSE 
    Eps = EPS_GEO    ! neighborhood radius
  ENDIF

  ! use larger radius with polar winds
  ! EPS is the neighborhood radius parameter in pixels
  ! A larger value (3.3) is used in polar winds
  ! processing because of the larger time interval involved

  IF (TRIM(NavType) .EQ. 'PS') Eps = EPS_POLAR

  if (vector .eq. 1 .and. good_sample .gt. 1) then  ! aab Tandem (dbscan)
          status_flag = sym%SUCCESS 
          setofpoints_init = setofpoints
          dbscan_out%initial_sample = good_sample
  endif

  ! aab Tandem (dbscan): Only call DBSCAN after forward time step is processed (i.e., when vector=2)

  if (vector .eq. 2) then  ! aab Tandem (dbscan)
    idx1 = good_sample + 1
    idx2 = good_sample_x2

    ! aab Tandem (dbscan): reverse line/ele displacements to account for reverse time step
    setofpoints_init(1:good_sample_rev,1) = -setofpoints_init(1:good_sample_rev,1)
    setofpoints_init(1:good_sample_rev,2) = -setofpoints_init(1:good_sample_rev,2)

    ! aab Tandem (dbscan): combine reverse time step sample with forward time step sample before calling DBSCAN
    setofpoints(idx1:idx2,:) = setofpoints_init(1:good_sample_rev,:)
    good_sample = good_sample_x2

    CALL DBSCAN(Good_Sample, SetOfPoints, MinPts, Eps, &
           NumberOfClusters, MaxCluster, MaxClusterSize)

    ! save initial sample of points

    IF ( SIZE(SetOfPoints_Init, 1) .NE. SIZE(SetOfPoints, 1) .OR. &
         SIZE(SetOfPoints_Init, 2) .NE. SIZE(SetOfPoints, 2) ) THEN
       CALL fw_log_error(FUNC, 'Shape of SetOfPoints_Init does not match SetOfPoints')
    ENDIF

    SetOfPoints_Init = SetOfPoints

    IF (Good_Sample .GT. 1) THEN

      Avg_Delta_X = 0.0
      Avg_Delta_Y = 0.0
      Sum_Delta_X = 0.0
      Sum_Delta_Y = 0.0
      Initial_Sample = Good_Sample
      DBSCAN_Out%Initial_Sample = Good_Sample

      Good_Sample = 0
      Good_CTP_Sample = 0
      Good_BT_Sample = 0
      sample_size_rev = 0
      sample_size_for = 0

      ! Allocate memory for arrays to hold final sample
  
      !ALLOCATE(Delta_X_Final(Number_Of_Loops), Delta_Y_Final(Number_Of_Loops))  ! aab Tandem (dbscan)
      !ALLOCATE(Dist(Number_Of_Loops))  ! aab Tandem (dbscan)
      ! aab Tandem (dbscan): double size for combined sample processing
      ALLOCATE(Delta_X_Final(Number_Of_Loops*2), Delta_Y_Final(Number_Of_Loops*2))
      ALLOCATE(Dist(Number_Of_Loops*2))

      ! determine dominant phase of largest cluster
      phase_counts(1) = COUNT(SetOfPoints(:,13) == 1. .AND. SetOfPoints(:,4) == REAL(MaxCluster))
      phase_counts(2) = COUNT(SetOfPoints(:,13) == 2. .AND. SetOfPoints(:,4) == REAL(MaxCluster))
      phase_counts(3) = COUNT(SetOfPoints(:,13) == 3. .AND. SetOfPoints(:,4) == REAL(MaxCluster))
      phase_counts(4) = COUNT(SetOfPoints(:,13) == 4. .AND. SetOfPoints(:,4) == REAL(MaxCluster))
      dominant_phase = MAXLOC(phase_counts, DIM=1)

      ! aab Tandem (dbscan): count the number of samples for each vector
      mxsize_rev = COUNT(SetOfPoints(:,17) == 1. .AND. SetOfPoints(:,4) == REAL(MaxCluster))
      mxsize_for = COUNT(SetOfPoints(:,17) == 2. .AND. SetOfPoints(:,4) == REAL(MaxCluster))

      ! use output of DBSCAN analysis to determine final sample

      DO Point = 1, Initial_Sample

        ! Add initial sample variables
        Sum_Delta_X_Initial = Sum_Delta_X_Initial + SetOfPoints(Point,1) / Factor
        Sum_Delta_Y_Initial = Sum_Delta_Y_Initial + SetOfPoints(Point,2)

        ! if point is not part of largest cluster or is missing BT or CTP, skip it

        IF (CSWV_Flag .EQ. sym%YES) THEN

          ! do not check CTP value for CSWV winds only max cluster - 1/25/16

          IF (SetOfPoints(Point,4) .NE. REAL(MaxCluster)) CYCLE

        ELSE

          ! check CTP value for all cloudy winds and max cluster - 1/25/16

          IF (SetOfPoints(Point,4) .NE. REAL(MaxCluster) .OR. &
                SetOfPoints(Point,7) .EQ. MISSING_VALUE_REAL4) CYCLE

        ENDIF

        ! if channel is long-wave IR and cloud top height is the surface, skip it

        IF (Band .EQ. 14 .AND. SetOfPoints(Point,8) .EQ. 0.0) CYCLE

        ! check phase of SWIR, WV and LWIR bands

        IF (Band .GE. 7) THEN

          ! if dominant phase is ice, exclude liquid pixels and vice versa

          IF (dominant_phase .EQ. sym%ICE_PHASE .AND. INT(SetOfPoints(Point,13)) .EQ. sym%WATER_PHASE) CYCLE
          IF (dominant_phase .EQ. sym%WATER_PHASE .AND. INT(SetOfPoints(Point,13)) .EQ. sym%ICE_PHASE) CYCLE

        ENDIF

        Good_Sample = Good_Sample + 1

        ! Remove pixel factor before computing final solution

        Sum_Delta_X = Sum_Delta_X + SetOfPoints(Point,1) / Factor
        Sum_Delta_Y = Sum_Delta_Y + SetOfPoints(Point,2)
        Delta_X_Final(Good_Sample) = SetOfPoints(Point,1) / Factor
        Delta_Y_Final(Good_Sample) = SetOfPoints(Point,2)

        ! Fill output structure

        Good_CTP_Sample = Good_CTP_Sample + 1   ! now represents total from both time steps 

        ! Save final sample of points in output structure

        !IF (Vector .EQ. REVERSE) THEN  ! aab Tandem (dbscan)
        if(setofpoints(point,17) == 1.0) then

          sample_size_rev = sample_size_rev + 1
          DBSCAN_Out%Number_CTP_Sample1 = sample_size_rev 
          DBSCAN_Out%CTP_5x5_Sample1(sample_size_rev) = SetOfPoints(Point,7)
          DBSCAN_Out%CldTemp_5x5_Sample1(sample_size_rev) = SetOfPoints(Point,11)
          DBSCAN_Out%Cld_Hgt_5x5_Sample1(sample_size_rev) = SetOfPoints(Point,8)
          DBSCAN_Out%Press_Error_Sample1(sample_size_rev) = SetOfPoints(Point,9)
          DBSCAN_Out%Temp_Error_Sample1(sample_size_rev) = SetOfPoints(Point,10)
          DBSCAN_Out%CORR_5x5_Sample1(sample_size_rev) = SetOfPoints(Point,12)
          DBSCAN_Out%Cld_OD_Sample1(sample_size_rev) = SetOfPoints(Point,15)
          DBSCAN_Out%ACHA_Cost_Sample1(sample_size_rev) = SetOfPoints(Point,16)
          DBSCAN_Out%Delta_X_Reverse(sample_size_rev) = SetOfPoints(Point,1) / Factor
          DBSCAN_Out%Delta_Y_Reverse(sample_size_rev) = SetOfPoints(Point,2)

          DBSCAN_Out%Phase_Sample1(sample_size_rev) = SetOfPoints(Point, 13)
          DBSCAN_Out%Type_Sample1(sample_size_rev) = SetOfPoints(Point, 14)

        !ELSE IF (Vector .EQ. FORWARD) THEN  ! aab Tandem (dbscan)
        else if(setofpoints(point,17) == 2.0) then

          sample_size_for = sample_size_for + 1
          DBSCAN_Out%Number_CTP_Sample2 = sample_size_for 
          DBSCAN_Out%CTP_5x5_Sample2(sample_size_for) = SetOfPoints(Point,7)
          DBSCAN_Out%CldTemp_5x5_Sample2(sample_size_for) = SetOfPoints(Point,11)
          DBSCAN_Out%Cld_Hgt_5x5_Sample2(sample_size_for) = SetOfPoints(Point,8)
          DBSCAN_Out%Press_Error_Sample2(sample_size_for) = SetOfPoints(Point,9)
          DBSCAN_Out%Temp_Error_Sample2(sample_size_for) = SetOfPoints(Point,10)
          DBSCAN_Out%CORR_5x5_Sample2(sample_size_for) = SetOfPoints(Point,12)
          DBSCAN_Out%Cld_OD_Sample2(sample_size_for) = SetOfPoints(Point,15)
          DBSCAN_Out%ACHA_Cost_Sample2(sample_size_for) = SetOfPoints(Point,16)
          DBSCAN_Out%Delta_X_Forward(sample_size_for) = SetOfPoints(Point,1) / Factor
          DBSCAN_Out%Delta_Y_Forward(sample_size_for) = SetOfPoints(Point,2)

          DBSCAN_Out%Phase_Sample2(sample_size_for) = SetOfPoints(Point, 13)
          DBSCAN_Out%Type_Sample2(sample_size_for) = SetOfPoints(Point, 14)

        ENDIF

        ! keep track of sub-vector number
        DBSCAN_Out%vector(good_ctp_sample) = SetOfPoints(Point, 17)

        ! fill 2D arrays for plotting

        I = INT(SetOfPoints(Point,5))
        J = INT(SetOfPoints(Point,6))

        DBSCAN_Out%Delta_X_Final(I,J) = SetOfPoints(Point,1) / Factor
        DBSCAN_Out%Delta_Y_Final(I,J) = SetOfPoints(Point,2)

        ! sum up CTP sample for statistics

! aab Tandem (dbscan)
!        Mean_CTP = Mean_CTP + SetOfPoints(Point,7)
!        Mean_CTP2 = Mean_CTP2 + SetOfPoints(Point,7)**2

      ENDDO ! Loop over initial sample

      ! Check final sample size. Fail if zero, otherwise compute
      ! average displacement.

      IF (Good_Sample .GT. 0) THEN

        Avg_Delta_X = Sum_Delta_X / REAL(Good_Sample)
        Avg_Delta_Y = Sum_Delta_Y / REAL(Good_Sample)

        ! Add initial sample variables
        Avg_Delta_X_Initial = Sum_Delta_X_Initial / REAL(Initial_Sample)
        Avg_Delta_Y_Initial = Sum_Delta_Y_Initial / REAL(Initial_Sample)

! aab Tandem (dbscan) 
!        Mean_CTP =  Mean_CTP / Good_CTP_Sample
!        Mean_CTP2 =  Mean_CTP2 / Good_CTP_Sample
!        SD_CTP = SQRT(Mean_CTP2 - Mean_CTP**2)

        Status_Flag = sym%SUCCESS

        ! Compute spread about mean solution

        DO Point = 1, Good_Sample

          Dist(Point) = SQRT((Delta_X_Final(Point) - Avg_Delta_X)**2 &
                          + (Delta_Y_Final(Point) - Avg_Delta_Y)**2)

          Sum_Dist = Sum_Dist + Dist(Point)

        ENDDO

        Avg_Dist = Sum_Dist / REAL(Good_Sample)

        DO Point = 1, Good_Sample

          Sum_Dist_Squared = Sum_Dist_Squared + (Dist(Point) - Avg_Dist)**2

        ENDDO

        StdDev = SQRT(Sum_Dist_Squared / REAL(Good_Sample))
        PctOfAvg = StdDev / SQRT(Avg_Delta_X**2 + Avg_Delta_Y**2)
        ! keep original code -- wcb 04/19/13
        ! save ratio of final sample to initial sample instead
        !PctOfAvg = REAL(Good_Sample) / REAL(Box_Data%CloudyPixels)

        ! Fill scalar values of output structure

        !IF (Vector .EQ. REVERSE) THEN  ! aab Tandem (dbscan)

          !DBSCAN_Out%StdDev_MVD1 = StdDev  ! aab Tandem (dbscan)
          !DBSCAN_Out%PctOfAvg1 = PctOfAvg  ! aab Tandem (dbscan)
          DBSCAN_Out%NumberOfClusters1 = NumberOfClusters
          DBSCAN_Out%MaxCluster1 = MaxCluster
          DBSCAN_Out%MaxClusterSize1 = MaxClusterSize
          !DBSCAN_Out%Max1_PctOfSample = REAL(MaxClusterSize) / REAL(Initial_Sample)  ! aab Tandem (dbscan)


        !ELSE IF (Vector .EQ. FORWARD) THEN  ! aab Tandem (dbscan)

          !DBSCAN_Out%StdDev_MVD2 = StdDev  ! aab Tandem (dbscan)
          !DBSCAN_Out%PctOfAvg2 = PctOfAvg  ! aab Tandem (dbscan)
          DBSCAN_Out%NumberOfClusters2 = NumberOfClusters
          DBSCAN_Out%MaxCluster2 = MaxCluster
          DBSCAN_Out%MaxClusterSize2 = MaxClusterSize
          !DBSCAN_Out%Max2_PctOfSample = REAL(MaxClusterSize) / REAL(Initial_Sample)  ! aab Tandem (dbscan)

        !ENDIF  ! aab Tandem (dbscan)

        ! deallocate arrays holding final sample of points

        DEALLOCATE(Delta_X_Final, Delta_Y_Final, Dist)

      ELSE  ! If final sample is zero flag target as failure

        Status_Flag = ZERO_FINAL_SAMPLE
        DEALLOCATE(Delta_X_Final, Delta_Y_Final, Dist)

      ENDIF

    ELSE  ! If initial sample is zero flag target as failure

      Status_Flag = ZERO_INITIAL_SAMPLE

    ENDIF
  endif ! combined sample testing

  ! Convert absolute displacement back to relative displacement from center.

  Element_Disp = Avg_Delta_X
  Line_Disp = Avg_Delta_Y
  Relative_Ele_Disp = Avg_Delta_X - Delta_X_Sat
  Relative_Line_Disp = Avg_Delta_Y - Delta_Y_Sat

  !-----------------------------------------------------------------------------
  ! Offset for location of match area within search grid.
  !-----------------------------------------------------------------------------

  Min_SSD_Line = Lag_Center_Line + NINT(Relative_Line_Disp)
  Min_SSD_Element = Lag_Center_Element + NINT(Relative_Ele_Disp)

  ! guard against exceeding bounds of search region
  IF (Min_SSD_Line .LT. 1) Min_SSD_Line = 1
  IF (Min_SSD_Element .LT. 1) Min_SSD_Element = 1
  IF (Min_SSD_Line .GT. Lag_Line_Size) Min_SSD_Line = Lag_Line_Size
  IF (Min_SSD_Element .GT. Lag_Element_Size) Min_SSD_Element = Lag_Element_Size

  Match_Offset = (Min_SSD_Line - 1) * Search_Element_Size + Min_SSD_Element - 1
  Min_SSD_Value = SSD_1D2(0, Target_1D, Search_1D, 1, Match_Offset, INT(1,BYTE))

  Element_Counter_Search = - Search_Element_Size
  Element_Counter_Target = - Target_Element_Size

  line_loop: DO Line = 1, Target_Line_Size

    Element_Counter_Search = Element_Counter_Search + Search_Element_Size
    Element_Counter_Target = Element_Counter_Target + Target_Element_Size

    element_loop: DO Element = 1, Target_Element_Size

      Search_Index = Element_Counter_Search + Element + Match_Offset
      Target_Index = Element_Counter_Target + Element
      Sum_Target = Sum_Target + Target_1D(Target_Index)
      Sum_Squared_Target = Sum_Squared_Target + Target_1D(Target_Index)**2
      Match_Scene_Mean = Match_Scene_Mean + Search_1D(Search_Index)
      Sum_Squared_Match = Sum_Squared_Match + Search_1D(Search_Index)**2

    END DO element_loop

  END DO line_loop

  ! ----------------------------------------------------------------------------
  ! Compute scene statistics.
  ! ----------------------------------------------------------------------------

  Target_Scene_Mean = Sum_Target / REAL(Total_Points_Target)
  Match_Scene_Mean = Match_Scene_Mean / REAL(Total_Points_Target)

  Target_Scene_Variance = Sum_Squared_Target / REAL(Total_Points_Target) - &
                                                      Target_Scene_Mean**2

  Match_Scene_Variance = Sum_Squared_Match / REAL(Total_Points_Target) - &
                                                     Match_Scene_Mean**2

  Target_Scene_StdDev = SQRT(Target_Scene_Variance)
  Match_Scene_StdDev = SQRT(Match_Scene_Variance)

  ! ----------------------------------------------------------------------------
  ! Compute linear correlation coefficient.
  ! ----------------------------------------------------------------------------
  Corr_Coeff_DB = (Sum_Squared_Match + Sum_Squared_Target - Min_SSD_Value) / &
       (2.0 * Total_Points_Target) - Target_Scene_Mean * Match_Scene_Mean

  Corr_Coeff = Corr_Coeff_DB / (Target_Scene_StdDev * Match_Scene_StdDev)


  IF (Corr_Coeff .LT. 0.) Corr_Coeff = 0.0

  ! Deallocate arrays used by nested tracking and DBSCAN

  DEALLOCATE(Target_1D, Search_1D, Lag_Matrix)
  DEALLOCATE(Small_Target, Small_Search, Small_Match)
  DEALLOCATE(Delta_X, Delta_Y)
  DEALLOCATE(SetOfPoints)

END SUBROUTINE Nested_Tracking

!-------------------------------------------------------------------------------
!
! Name:
!   Fill_Lag_Matrix_1D
!
! Function:
!   Coputes the sum of squared difference values for all target-sized
!   scenes in search region.
!
! Description:
!   This subroutine fills the lag matrix, the array of SSD values of all
!   potential matching scenes in the search region.
!
! Calling sequence:
!   CALL Fill_Lag_Matrix_1D
!
! Inputs:
!   Size_Diff            Size difference in pixels between the nested box and
!                        the outer target box.
!   Target_1D            One-dimensional array of target box values
!   Search_1D            One-dimensional array of search box values
!   Lag_Table2           prioritized list of positions to search (a spiral
!                        centered on the middle of the search region)
!
! Outputs:
!   Lag_Matrix           SSD values of potential matching scenes
!
! Dependencies:
!   Assumes SSD similarity measure is being used for tracking.
!
! Restrictions:
!   None
!
! History:
!   06/01/2009 - Wayne Bresky - Created
!
!-------------------------------------------------------------------------------
SUBROUTINE Fill_Lag_Matrix_1D(Lag_Size, Size_Diff, Target_1D, Search_1D, &
                                                 Lag_Table2, Lag_Matrix)

  INTEGER(BYTE) Flag

  INTEGER(LONG) :: Point
  INTEGER(LONG) :: Lag_Index
  INTEGER(LONG) :: Search_Index
  INTEGER(LONG) :: Min_SSD_Location
  INTEGER(LONG) :: Min_SSD_Element
  INTEGER(LONG) :: Min_SSD_Line
  INTEGER(LONG) :: Small_Search_Element_Size
  INTEGER(LONG) :: Total_Points_Lag
  INTEGER(LONG), INTENT(IN) :: Size_Diff
  INTEGER(LONG), INTENT(IN) :: Lag_Size

  ! List of positions to use in spiral search for minimum SSD
  INTEGER(LONG), DIMENSION(:,:), INTENT(IN) :: Lag_Table2

  REAL(SINGLE), DIMENSION(:), INTENT(INOUT) :: Lag_Matrix
  REAL(SINGLE), DIMENSION(:), INTENT(IN) :: Target_1D
  REAL(SINGLE), DIMENSION(:), INTENT(IN) :: Search_1D

  ! ----------------------------------------------------------------------------
  ! Initialize all values to -1
  ! ----------------------------------------------------------------------------

  Lag_Matrix(:) = -1.0
  Small_Search_Element_Size = Search_Element_Size - Size_Diff
  Total_Points_Lag = Lag_Size**2

  ! Initialize flag to terminate SSD early if current minimum is exceeded

  Flag = 0

  lag_point_loop: DO Point = 1, Total_Points_Lag

    Lag_Index = Lag_Table2(Point, 3)
    Search_Index = Lag_Table2(Point, 4)
    Lag_Matrix(Lag_Index) = SSD_1D2(Size_Diff, Target_1D, Search_1D, Point, &
                                                        Search_Index, Flag)

  END DO lag_point_loop

  ! ----------------------------------------------------------------------------
  ! Compute SSD value for 4 pts surrounding minimum. These values are necessary
  ! for the sub-pixel interpolation.
  ! ----------------------------------------------------------------------------

  Flag = 1
  Point = 1
  Min_SSD_Location = MINLOC(Lag_Matrix, 1)

  Min_SSD_Element = MOD(Min_SSD_Location, Lag_Element_Size)
  IF (MOD(Min_SSD_Location, Lag_Element_Size) .EQ. 0) THEN
    Min_SSD_Element = Lag_Element_Size
    Min_SSD_Line = (Min_SSD_Location / Lag_Element_Size)
  ELSE
    Min_SSD_Line = (Min_SSD_Location / Lag_Element_Size) + 1
  ENDIF

  IF (Min_SSD_Element .EQ. 1 .OR. Min_SSD_Element .EQ. Lag_Element_Size .OR. &
            Min_SSD_Line .EQ. 1 .OR. Min_SSD_Line .EQ. Lag_Line_Size) RETURN

  ! Top point

  Lag_Index = Min_SSD_Location - Lag_Element_Size
  Search_Index = (Min_SSD_Line - 2) * Small_Search_Element_Size + Min_SSD_Element
  Lag_Matrix(Lag_Index) = SSD_1D2(Size_Diff, Target_1D, Search_1D, Point, &
                                                      Search_Index, Flag)

  ! Left point

  Lag_Index = Min_SSD_Location - 1
  Search_Index = (Min_SSD_Line - 1) * Small_Search_Element_Size + Min_SSD_Element - 1
  Lag_Matrix(Lag_Index) = SSD_1D2(Size_Diff, Target_1D, Search_1D, Point, &
                                                      Search_Index, Flag)

  ! Right point

  Lag_Index = Min_SSD_Location + 1
  Search_Index = (Min_SSD_Line - 1) * Small_Search_Element_Size + Min_SSD_Element + 1
  Lag_Matrix(Lag_Index) = SSD_1D2(Size_Diff, Target_1D, Search_1D, Point, &
                                                      Search_Index, Flag)

  ! Bottom point

  Lag_Index = Min_SSD_Location + Lag_Element_Size
  Search_Index = Min_SSD_Line * Small_Search_Element_Size + Min_SSD_Element
  Lag_Matrix(Lag_Index) = SSD_1D2(Size_Diff, Target_1D, Search_1D, Point, &
                                                      Search_Index, Flag)

END SUBROUTINE Fill_Lag_Matrix_1D

!-------------------------------------------------------------------------------
!
! Name:
!   SSD_1D2
!
! Function:
!   Coputes the sum of squared difference value at a single location of
!   the lag matrix.
!
! Description:
!   This function computes the SSD value at a single location of the lag
!   matrix, the array of SSD values of all potential matching scenes in
!   the search region.
!
! Calling sequence:
!   SSD_1D2
!
! Inputs:
!   Size_Diff            Size difference in pixels between the nested box and
!                        the outer target box.
!   Target_1D            One-dimensional array of target box values
!   Search_1D            One-dimensional array of search box values
!   Point                Location in lag matrix
!   Search_Index         Starting pixel in search region
!   Flag                 Flag for terminating the SSD calculation if the
!                        current minimum has been exceeded
!
! Outputs/Result:
!   Sum_Of_Squared_Differences
!
! Dependencies:
!   Assumes SSD similarity measure is being used for tracking.
!
! Restrictions:
!   None
!
! History:
!   06/01/2009 - Wayne Bresky - Created
!
!-------------------------------------------------------------------------------
FUNCTION SSD_1D2(Size_Diff, Target_1D, Search_1D, Point, Search_Index, Flag) &
                                         RESULT (Sum_Of_Squared_Differences)

  INTEGER(BYTE), INTENT(IN) :: Flag
  INTEGER(LONG), INTENT(IN) :: Point
  INTEGER(LONG), INTENT(IN) :: Search_Index
  INTEGER(LONG) :: Search_Index2
  INTEGER(LONG) :: Target_Index
  INTEGER(LONG) :: Element
  INTEGER(LONG) :: Line
  INTEGER(LONG) :: Element_Counter_Target
  INTEGER(LONG) :: Element_Counter_Search
  INTEGER(LONG) :: Small_Target_Element_Size
  INTEGER(LONG) :: Small_Target_Line_Size
  INTEGER(LONG) :: Small_Search_Element_Size
  INTEGER(LONG), INTENT(IN) :: Size_Diff
  REAL(SINGLE), DIMENSION(:), INTENT(IN) :: Target_1D
  REAL(SINGLE), DIMENSION(:), INTENT(IN) :: Search_1D
  REAL(SINGLE) :: Sum_Of_Squared_Differences
  REAL(SINGLE), SAVE :: Current_Minimum

  Sum_Of_Squared_Differences = 0.0
  Small_Target_Element_Size = 5
  Small_Target_Line_Size = 5

  ! If size difference is zero this indicates that nested tracking is not being
  ! used so we need to set the small target values to the larger size

  IF (Size_Diff .EQ. 0) THEN
    Small_Target_Element_Size = Target_Element_Size
    Small_Target_Line_Size = Target_Line_Size
  ENDIF

  Small_Search_Element_Size = Search_Element_Size - Size_Diff
  Element_Counter_Target = - Small_Target_Element_Size
  Element_Counter_Search = Search_Index - Small_Search_Element_Size - 1

  IF (Point .EQ. 1) Current_Minimum = HUGE(REAL(SHORT))

  line_loop: DO Line = 1, Small_Target_Line_Size

    Element_Counter_Target = Element_Counter_Target + Small_Target_Element_Size
    Element_Counter_Search = Element_Counter_Search + Small_Search_Element_Size

    element_loop: DO Element = 1, Small_Target_Element_Size

      Target_Index = Element_Counter_Target + Element
      Search_Index2 = Element_Counter_Search + Element

      ! perform this check to avoid a zero index
      ! wcb 2/28/12

      IF (Search_Index2 .EQ. 0) Search_Index2 = 1

      Sum_Of_Squared_Differences = Sum_Of_Squared_Differences + &
         (Target_1D(Target_Index) - Search_1D(Search_Index2))**2

      ! ------------------------------------------------------------------------
      ! Terminate summation if current value exceeds minimum
      ! ------------------------------------------------------------------------

      IF (Sum_Of_Squared_Differences .GT. Current_Minimum &
                                .AND. Flag .EQ. 0) RETURN

    END DO element_loop

  END DO line_loop

  ! ----------------------------------------------------------------------------
  ! Reset current minimum for new minimum
  ! ----------------------------------------------------------------------------

  IF (Sum_Of_Squared_Differences .LT. Current_Minimum) Current_Minimum = &
                                              Sum_Of_Squared_Differences

END FUNCTION SSD_1D2

! ------------------------------------------------------------------------------
!
! Name:
!   Sort_Shell_NP
!
! Function:
!  Sort array of values into ascending order and find median. Differs from
!  original version in that it accepts as one of the arguments the number
!  of points to sort. This is useful if the user does not wish to sort the
!  entire array which may have missing elements.
!
! Description:
!   - Uses Shell's method
!
! Reference:
!   Numerical Recipes
!
! Calling sequence:
!   CALL Sort_Shell
!
! Inputs:
!   Number_Of_Points     Number of points to be sorted.
!   Array                1-D array of values to be sorted.
!
! Outputs:
!   Median               Median of array values.
!
! Dependencies:
!
! Restrictions:
!
! History:
!   8/2008 - Wayne Bresky - Created
!
!-------------------------------------------------------------------------------
SUBROUTINE Sort_Shell_NP(Number_Of_Points, Array, Median)

  INTEGER(LONG) :: I
  INTEGER(LONG) :: J
  INTEGER(LONG) :: Increment
  INTEGER(LONG), INTENT(IN) :: Number_Of_Points
  INTEGER(LONG) :: Mid_Point
  REAL(SINGLE) :: Value
  REAL(SINGLE), DIMENSION(:), INTENT(INOUT) :: Array
  REAL(SINGLE), INTENT(OUT) :: Median
  REAL(SINGLE) Mean

  Increment = 1

  IF (Number_Of_Points .EQ. 1) THEN

    Median = Array(1)
    RETURN

  ENDIF

  DO
    Increment = 3 * Increment + 1
    IF (Increment > Number_Of_Points) EXIT
  END DO

  DO
    Increment = Increment / 3
    DO I = Increment + 1, Number_Of_Points
      Value = Array(I)
      J = I
      DO
        IF (Array(J-Increment) <= Value) EXIT
        Array(J) = Array(J-Increment)
        J = J - Increment
        IF (J <= Increment) EXIT
      END DO

      Array(J) = Value

    END DO

    IF (Increment <= 1) EXIT

  END DO


  Mid_Point = Number_Of_Points / 2

  IF (MOD(Number_Of_Points, 2) .EQ. 0) THEN
    Median = 0.5*(Array(Mid_Point) + Array(Mid_Point + 1))
  ELSE
    Median = Array(Mid_Point + 1)
  ENDIF

! Test computing average instead of median

  Mean = SUM(Array, MASK = Array > 0.0) / REAL(COUNT(Array > 0.0))

END SUBROUTINE Sort_Shell_NP

!-------------------------------------------------------------------------------
!
! Name:
!   DBSCAN
!
! Function:
!   Identifies clusters in the presence of noise.
!
! Description:
!   An efficient cluster analysis algorithm that separates areas of higher
!   density from areas of lower density. The algorithm is very effective at
!   discriminating between coherent clusters and noise.
!
! References:
!   Ester et al (1996), "A Density-Based Algorithm for Discovering Clusters in
!   Large Spatial Databases with Noise." Proceedings of 2nd International
!   Conference on Knowledge Discovery and Data Mining (KDD-96), Portland,
!   Oregon, USA, 226-231.
!
! Calling sequence:
!   CALL DBSCAN
!
! Inputs:
!   GoodSample           Number of points in initial sample
!   SetOfPoints          Set of x and y displacements
!   MinPts               Minimum number of points for cluster
!   Eps                  Radius around point to search for cluster
!   Median_Press         Median pressure of cold sample
!
! Outputs:
!   NumberOfClusters     Number of clusters identified
!   MaxCluster           Cluster ID of largest cluster
!   MaxClusterSize       Number of points in largest cluster
!
! Dependencies:
!   None
!
! Restrictions:
!   None
!
! History:
!   11/2009 - Wayne Bresky - Created
!
!-------------------------------------------------------------------------------
SUBROUTINE DBSCAN(GoodSample, SetOfPoints, MinPts, Eps, &
          NumberOfClusters, MaxCluster, MaxClusterSize)

  INTEGER(LONG), INTENT(IN) :: GoodSample
  INTEGER(LONG), INTENT(IN) :: MinPts
  INTEGER(LONG) ClusterID
  INTEGER(LONG) Point
  INTEGER(LONG) ClusterSize
  INTEGER(LONG), INTENT(OUT) :: NumberOfClusters
  INTEGER(LONG), INTENT(OUT) :: MaxClusterSize
  INTEGER(LONG), INTENT(OUT) :: MaxCluster
  INTEGER(LONG) Dim1
  INTEGER(LONG) Dim2
  INTEGER(LONG) I
  INTEGER(LONG) J
  INTEGER(LONG), ALLOCATABLE, DIMENSION(:) :: SeedList
  INTEGER(LONG), ALLOCATABLE, DIMENSION(:) :: ResultList

  REAL(SINGLE), INTENT(IN) :: Eps
  REAL(SINGLE), DIMENSION(:,:), INTENT(INOUT) :: SetOfPoints

! Initialize variables

  ClusterID = 0
  Dim1 = SIZE(SetOfPoints, 1)
  Dim2 = SIZE(SetOfPoints, 2)
  SetOfPoints(1:Dim1,3) = UNCLASSIFIED
  SetOfPoints(1:Dim1,4) = MISSING_VALUE_REAL4
  NumberOfClusters = 0
  MaxClusterSize = 0
  MaxCluster = 0

  ALLOCATE(SeedList(Dim1))
  ALLOCATE(ResultList(Dim1))


  DO I = 1,GoodSample

    Point = I

    ! Check if point has been classified already. If it has not already been
    ! classsified, then check to see if it is part of a cluster.

    IF (SetOfPoints(Point, 3) .EQ. UNCLASSIFIED) THEN

      IF (ExpandCluster(GoodSample, SetOfPoints, Point, &
          SeedList, ResultList, ClusterID, MinPts, Eps)) THEN

        ! If the point is part of a cluster, increment the ID counter

        ClusterID = ClusterID + 1

      ENDIF

    ENDIF

  ENDDO

  ! All points have been classified at this stage.

  MaxClusterSize = 0
  ClusterSize = 0

  ! If at least one cluster exists, go back and count the number of points
  ! in each cluster.

  IF(ClusterID .GT. 0) THEN

    DO J = 1, ClusterID

      DO I = 1, GoodSample

        IF (SetOfPoints(I,4) .EQ. REAL(J-1)) THEN

          ClusterSize = ClusterSize + 1

        ENDIF

      ENDDO

      IF (ClusterSize .GT. MaxClusterSize) THEN

        MaxClusterSize = ClusterSize
        MaxCluster = J - 1

      ENDIF

      ! reset counter for next cluster

      ClusterSize = 0

    ENDDO

  ENDIF

   ! Return the number of clusters found

   NumberOfClusters = ClusterID

  DEALLOCATE(SeedList, ResultList)

END SUBROUTINE DBSCAN

!-------------------------------------------------------------------------------
!
! Name:
!   ExpandCluster
!
! Function:
!   Function used to classify a given point as either noise or part of a cluster.
!
! Description:
!   Most important function in DBSCAN algorithm. It determines if the current
!   point is part of a cluster or noise.
!
! References:
!   Ester et al (1996), "A Density-Based Algorithm for Discovering Clusters in
!   Large Spatial Databases with Noise." Proceedings of 2nd International
!   Conference on Knowledge Discovery and Data Mining (KDD-96), Portland,
!   Oregon, USA, 226-231.
!
! Calling sequence:
!   ExpandCluster
!
! Inputs:
!   SampleSize           Number of points in initial sample
!   Point                Point being classified
!   Median_Press         Median pressure of cold sample
!   ClusterID            ID of current cluster
!   MinPts               Minimum number of points for cluster
!   Eps                  Radius around point to search for cluster
!
! Input/Output
!   SetOfPoints          Set of x and y displacements
!   SeedList             List of points within 1-Eps radius of current point
!   ResultList           List of points within 1-Eps radius of a seed point
!
! Outputs:
!   TRUE or FALSE        TRUE if point is located within cluster, FALSE if not
!
! Note:   A point can have one of 3 status values:
!
!         UNCLASSIFIED - point has not been classified yet
!         NOISE - point that doesn't belong to any cluster
!         CLASSIFIED - point has been classified previously
!
! Dependencies:
!   None
!
! Restrictions:
!   None
!
! History:
!   11/2009 - Wayne Bresky - Created
!
!-------------------------------------------------------------------------------
LOGICAL FUNCTION ExpandCluster(SampleSize, SetOfPoints, Point, SeedList, &
                                         ResultList, ClusterID, MinPts, Eps)

  INTEGER(LONG), INTENT(IN) :: SampleSize
  INTEGER(LONG), INTENT(IN) :: MinPts
  INTEGER(LONG), INTENT(IN) :: ClusterID
  INTEGER(LONG) NumberOfSeeds
  INTEGER(LONG), INTENT(IN) ::  Point
  INTEGER(LONG) CurrentP
  INTEGER(LONG) ResultP
  INTEGER(LONG) NumberOfResults
  INTEGER(LONG) I
  INTEGER(LONG) J
  INTEGER(LONG), INTENT(INOUT), DIMENSION(:) :: SeedList
  INTEGER(LONG), INTENT(INOUT), DIMENSION(:) :: ResultList

  REAL(SINGLE), INTENT(IN) :: Eps

  ! set of points being analyzed - these are actually displacements in
  ! line/element space
  REAL(SINGLE), DIMENSION(:,:), INTENT(INOUT) :: SetOfPoints

  ! set default value of function to false
  ExpandCluster = .FALSE.

  ! get list of points within 1 epsilon (Eps) of point under consideration

  CALL GetSeedList(SampleSize, SetOfPoints, Point, Eps, &
                               NumberOfSeeds, SeedList)

  ! if the number of points in the neighborhood is less than the minimum
  ! number for a cluster, then classify the point as noise

  IF (NumberOfSeeds .LT. MinPts) THEN

    SetOfPoints(Point, 3) = NOISE
    RETURN

  ELSE

    ! core point found

    SetOfPoints(Point, 3) = CLASSIFIED
    SetOfPoints(Point, 4) = ClusterID

    ! add the list of points to the current cluster and
    ! set the status of each to classified

    DO I = 1,NumberOfSeeds

      SetOfPoints(SeedList(I), 3) = CLASSIFIED
      SetOfPoints(SeedList(I), 4) = ClusterID

    ENDDO

    ! now check the neighborhood of each point in the seed list
    ! to see if it is "connected" to the current cluster

    DO WHILE (NumberOfSeeds .GT. 0)

      CurrentP = SeedList(1)

      CALL GetSeedList(SampleSize, SetOfPoints, CurrentP, Eps, &
                                  NumberOfResults, ResultList)

      IF (NumberOfResults .GE. MinPts) THEN

        DO J = 1,NumberOfResults

          ResultP = ResultList(J)

          IF (SetOfPoints(ResultP, 3) .EQ. UNCLASSIFIED .OR. &
                    SetOfPoints(ResultP, 3) .EQ. NOISE) THEN

            IF (SetOfPoints(ResultP, 3) .EQ. UNCLASSIFIED) THEN

!             Add point to list of seeds
              CALL UpdateSeedList(APPEND_PT, ResultP, NumberOfSeeds, SeedList)

            ENDIF

            SetOfPoints(ResultP, 3) = CLASSIFIED
            SetOfPoints(ResultP, 4) = ClusterID

          ENDIF

        ENDDO

      ENDIF

!     Delete point from list of seeds
      CALL UpdateSeedList(DELETE_PT, CurrentP, NumberOfSeeds, SeedList)

    ENDDO

    ExpandCluster = .TRUE.

  ENDIF

END FUNCTION ExpandCluster

!-------------------------------------------------------------------------------
!
! Name:
!   GetSeedList
!
! Function:
!   Returns a list of points within 1 Eps radius of current point.
!
! Description:
!   A routine for returning a list of points within 1 Eps of a given point.
!   The entire sample of points is searched.
!
!
! References:
!   Ester et al (1996), "A Density-Based Algorithm for Discovering Clusters in
!   Large Spatial Databases with Noise." Proceedings of 2nd International
!   Conference on Knowledge Discovery and Data Mining (KDD-96), Portland,
!   Oregon, USA, 226-231.
!
! Calling sequence:
!   CALL GetSeedList
!
! Inputs:
!   SampleSize           Number of points in initial sample
!   Points               Original sample of points
!   Point                Point being searched
!   Eps                  Radius around point to search for neighbors
!   Median_Press         Median pressure of cold sample
!
! Outputs:
!   NumberOfSeeds        Number of points within 1-Eps radius of current point
!   SeedList             List of points within 1-Eps radius of current point
!
! Dependencies:
!   None
!
! Restrictions:
!   None
!
! History:
!   11/2009 - Wayne Bresky - Created
!
!-------------------------------------------------------------------------------
SUBROUTINE GetSeedList(SampleSize, Points, Point, Eps, NumberOfSeeds, SeedList)

  INTEGER(LONG), INTENT(IN) :: SampleSize
  INTEGER(LONG), INTENT(IN) :: Point
  INTEGER(LONG), INTENT(OUT) :: NumberOfSeeds
  INTEGER(LONG) I
  INTEGER(LONG), INTENT(INOUT), DIMENSION(:) :: SeedList

  REAL(SINGLE), INTENT(IN) :: Eps
  REAL(SINGLE) Distance
  REAL(SINGLE), DIMENSION(:,:), INTENT(IN) :: Points
  REAL(SINGLE) X1
  REAL(SINGLE) Y1
  REAL(SINGLE) X2
  REAL(SINGLE) Y2
  ! test adding third dimension
  REAL(SINGLE) Z1
  REAL(SINGLE) Z2
  REAL(SINGLE) ZDIFF

  ! Find all points within 1 epsilon of point under consideration.

  NumberOfSeeds = 0
  X1 = Points(Point,1)
  Y1 = Points(Point,2)
  ! add vertical dimension (height in km)
  ! Division by 1000 converts units from meters to kilometers
  Z1 = Points(Point,8)/KM2M

  DO I = 1,SampleSize

    IF (I .NE. Point) THEN

      X2 = Points(I,1)
      Y2 = Points(I,2)
      ! add vertical dimension (height in km)
      ! Division by 1000 converts units from meters to kilometers
      Z2 = Points(I,8)/KM2M

      ZDIFF = Z2-Z1

      Distance = SQRT((X2-X1)**2 + (Y2-Y1)**2 )

      IF (Distance .LE. Eps) THEN

        NumberOfSeeds = NumberOfSeeds + 1
        SeedList(NumberOfSeeds) = I

      ENDIF

    ENDIF

  ENDDO

END SUBROUTINE GetSeedList

!-------------------------------------------------------------------------------
!
! Name:
!   UpdateSeedList
!
! Function:
!   Update the list of seed points.
!
! Description:
!   This routine adds or removes a point from the list of seeds.
!
! References:
!   Ester et al (1996), "A Density-Based Algorithm for Discovering Clusters in
!   Large Spatial Databases with Noise." Proceedings of 2nd International
!   Conference on Knowledge Discovery and Data Mining (KDD-96), Portland,
!   Oregon, USA, 226-231.
!
! Calling sequence:
!   CALL UpdateSeedList
!
! Inputs:
!   Operation            The operation to perform on the list
!   CurrentP             Point to operate on
!   NumberOfSeeds        Number of points in seed list
!
! Input/Output:
!   SeedList             List of seed points to be updated
!
! Dependencies:
!   None
!
! Restrictions:
!   None
!
! History:
!   11/2009 - Wayne Bresky - Created
!
!-------------------------------------------------------------------------------
SUBROUTINE UpdateSeedList(Operation, CurrentP, NumberOfSeeds, SeedList)

  INTEGER(LONG), INTENT (INOUT) :: NumberOfSeeds
  INTEGER(LONG), INTENT(IN) :: CurrentP
  INTEGER(LONG) I
  INTEGER(BYTE), INTENT(IN) :: Operation
  INTEGER(LONG), INTENT(INOUT), DIMENSION(:) :: SeedList

  IF (Operation .EQ. DELETE_PT) THEN

    NumberOfSeeds = NumberOfSeeds - 1

    IF (NumberOfSeeds .GT. 0) THEN

      DO I = 1,NumberOfSeeds
         SeedList(I) = SeedList(I+1)
      ENDDO

    ENDIF

  ELSE IF(Operation .EQ. APPEND_PT) THEN

    NumberOfSeeds = NumberOfSeeds + 1
    SeedList(NumberOfSeeds) = CurrentP

  ENDIF

END SUBROUTINE UpdateSeedList

END MODULE AMV_EN_FEATURE_TRACKING_UTILS_M

!********************************************************************************
!> @file
!> NAME:         AMV_EN_DBSCAN_M
!>
!> FUNCTION:     DBSCAN routines
!>
!> DESCRIPTION:
!>
!>     Density based spatial clustering variables/routines.
!>
!> REFERENCE:
!
!> CALLING SEQUENCE:
!>
!>     USE AMV_EN_DBSCAN_M
!>
!> DEPENDENCIES:
!>
!> RESTRICTIONS:
!>
!> HISTORY:
!> - 01/2017 - Brian Helgans - Created.
!>
!> @ingroup WINDS_AMV_EN
!********************************************************************************
MODULE AMV_EN_DBSCAN_M

   USE TYPE_KINDS_AIT
   USE GEOCAT_CONSTANTS
   USE fw_log_mod

   IMPLICIT NONE

   PRIVATE

   PUBLIC :: DBSCAN_Output, DBSCAN_Output_Initialize

   !> @brief define DBSCAN_Output structure
   TYPE :: DBSCAN_Output

      INTEGER(LONG) :: Number_CTP_Sample1
      INTEGER(LONG) :: Number_CTP_Sample2
      !INTEGER(LONG) :: Number_CTP_Sample
      INTEGER(LONG) :: Sample1
      INTEGER(LONG) :: Sample2
      INTEGER(LONG) :: Initial_Sample
      INTEGER(LONG) :: Number_BT_Sample1
      INTEGER(LONG) :: Number_BT_Sample2
      !INTEGER(LONG) :: Number_BT_Sample
      INTEGER(LONG) :: NumberOfClusters1
      INTEGER(LONG) :: NumberOfClusters2
      INTEGER(LONG) :: MaxCluster1
      INTEGER(LONG) :: MaxCluster2
      INTEGER(LONG) :: MaxClusterSize1
      INTEGER(LONG) :: MaxClusterSize2
      REAL(SINGLE) :: Max1_PctOfSample
      REAL(SINGLE) :: Max2_PctOfSample
      REAL(SINGLE) :: Avg_Delta_X_Sample1
      REAL(SINGLE) :: Avg_Delta_Y_Sample1
      REAL(SINGLE) :: Avg_Delta_X_Sample2
      REAL(SINGLE) :: Avg_Delta_Y_Sample2
      ! add 2nd and 3rd cluster averages - wcb 9/7/12
      REAL(SINGLE) :: Avg_Delta_X_2ndCluster_Rev
      REAL(SINGLE) :: Avg_Delta_Y_2ndCluster_Rev
      REAL(SINGLE) :: Avg_Delta_X_2ndCluster_For
      REAL(SINGLE) :: Avg_Delta_Y_2ndCluster_For
      REAL(SINGLE) :: Avg_Delta_X_3rdCluster_Rev
      REAL(SINGLE) :: Avg_Delta_Y_3rdCluster_Rev
      REAL(SINGLE) :: Avg_Delta_X_3rdCluster_For
      REAL(SINGLE) :: Avg_Delta_Y_3rdCluster_For
      REAL(SINGLE) :: Median_Press_2ndCluster
      REAL(SINGLE) :: Median_Press_3rdCluster
      INTEGER(LONG) :: PointsIn2ndCluster
      INTEGER(LONG) :: PointsIn3rdCluster
      REAL(SINGLE) :: StdDev_MVD1
      REAL(SINGLE) :: StdDev_MVD2
      REAL(SINGLE) :: PctOfAvg1
      REAL(SINGLE) :: PctOfAvg2
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: CTP_5x5_Sample1
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: CTP_5x5_Sample2
      !REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: CTP_5x5_Sample
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: CORR_5x5_Sample1
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: CORR_5x5_Sample2
      !REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: CORR_5x5_Sample
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: CldTemp_5x5_Sample1
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: CldTemp_5x5_Sample2
      !REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: CldTemp_5x5_Sample
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Cld_Hgt_5x5_Sample1
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Cld_Hgt_5x5_Sample2
      !REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Cld_Hgt_5x5_Sample
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Press_Error_Sample1
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Press_Error_Sample2
      !REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Press_Error_Sample
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Temp_Error_Sample1
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Temp_Error_Sample2
      !REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Temp_Error_Sample
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: BT_5x5_Sample1
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: BT_5x5_Sample2
      !REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: BT_5x5_Sample
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Cld_OD_Sample1
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Cld_OD_Sample2
      !REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Cld_OD_Sample
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: ACHA_Cost_Sample1
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: ACHA_Cost_Sample2
      !REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: ACHA_Cost_Sample
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Phase_Sample1
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Phase_Sample2
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Type_Sample1
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Type_Sample2


      ! save displacements for the reverse and forward vectors
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Delta_X_Reverse
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Delta_Y_Reverse
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Delta_X_Forward
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: Delta_Y_Forward

      ! save 2D fields for plotting
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:,:) :: Delta_X_Init
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:,:) :: Delta_Y_Init
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:,:) :: Delta_X_Final
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:,:) :: Delta_Y_Final
      ! add array to hold sub-vector number (1=reverse time step, 2=forward time step)
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: vector
      CONTAINS
      PROCEDURE :: Create
      FINAL :: Destroy
   END TYPE DBSCAN_Output

   CONTAINS



   !> @brief allocates the structure
   FUNCTION Create(DBSCAN_Out, Box_Size) RESULT(res)
      CHARACTER(LEN=*), PARAMETER :: FUNC = "Create_DBSCAN"
      CLASS(DBSCAN_Output) :: DBSCAN_Out !< structure to be created
      INTEGER(LONG), INTENT(IN) :: Box_Size !< size of the box.
      LOGICAL :: res
      INTEGER(LONG) astatus

      ! aab Tandem (dbscan)   vvvvvvvvvvvvvvvvv
      integer comb_size

      !ALLOCATE(DBSCAN_Out%CTP_5x5_Sample1((Box_Size-4)**2), &
      !   DBSCAN_Out%CTP_5x5_Sample2((Box_Size-4)**2), &
      !   DBSCAN_Out%CORR_5x5_Sample1((Box_Size-4)**2), &
      !   DBSCAN_Out%CORR_5x5_Sample2((Box_Size-4)**2), &
      !   DBSCAN_Out%CldTemp_5x5_Sample1((Box_Size-4)**2), &
      !   DBSCAN_Out%CldTemp_5x5_Sample2((Box_Size-4)**2), &
      !   DBSCAN_Out%Cld_Hgt_5x5_Sample1((Box_Size-4)**2), &
      !   DBSCAN_Out%Cld_Hgt_5x5_Sample2((Box_Size-4)**2), &
      !   DBSCAN_Out%BT_5x5_Sample1((Box_Size-4)**2), &
      !   DBSCAN_Out%BT_5x5_Sample2((Box_Size-4)**2), &
      !   DBSCAN_Out%Press_Error_Sample1((Box_Size-4)**2), &
      !   DBSCAN_Out%Press_Error_Sample2((Box_Size-4)**2), &
      !   DBSCAN_Out%Temp_Error_Sample1((Box_Size-4)**2), &
      !   DBSCAN_Out%Temp_Error_Sample2((Box_Size-4)**2), &
      !   DBSCAN_Out%Cld_OD_Sample1((Box_Size-4)**2), &
      !   DBSCAN_Out%Cld_OD_Sample2((Box_Size-4)**2), &
      !   DBSCAN_Out%ACHA_Cost_Sample1((Box_Size-4)**2), &
      !   DBSCAN_Out%ACHA_Cost_Sample2((Box_Size-4)**2), &
      !   DBSCAN_Out%Phase_Sample1((Box_Size-4)**2), &
      !   DBSCAN_Out%Phase_Sample2((Box_Size-4)**2), &
      !   DBSCAN_Out%Type_Sample1((Box_Size-4)**2), &
      !   DBSCAN_Out%Type_Sample2((Box_Size-4)**2), &
      !   DBSCAN_Out%Delta_X_Reverse((Box_Size-4)**2), &
      !   DBSCAN_Out%Delta_Y_Reverse((Box_Size-4)**2), &
      !   DBSCAN_Out%Delta_X_Forward((Box_Size-4)**2), &
      !   DBSCAN_Out%Delta_Y_Forward((Box_Size-4)**2), &
      !   DBSCAN_Out%Delta_X_Init(Box_Size, Box_Size), &
      !   DBSCAN_Out%Delta_Y_Init(Box_Size, Box_Size), &
      !   DBSCAN_Out%Delta_X_Final(Box_Size, Box_Size), &
      !   DBSCAN_Out%Delta_Y_Final(Box_Size, Box_Size), stat=astatus)

      ! increase by a factor of 2 to hold samples from both time steps
      comb_size = 2*((Box_Size-4)**2) 
      ALLOCATE(DBSCAN_Out%CTP_5x5_Sample1(comb_size), &
         DBSCAN_Out%CTP_5x5_Sample2(comb_size), &
         DBSCAN_Out%CORR_5x5_Sample1(comb_size), &
         DBSCAN_Out%CORR_5x5_Sample2(comb_size), &
         DBSCAN_Out%CldTemp_5x5_Sample1(comb_size), &
         DBSCAN_Out%CldTemp_5x5_Sample2(comb_size), &
         DBSCAN_Out%Cld_Hgt_5x5_Sample1(comb_size), &
         DBSCAN_Out%Cld_Hgt_5x5_Sample2(comb_size), &
         DBSCAN_Out%BT_5x5_Sample1(comb_size), &
         DBSCAN_Out%BT_5x5_Sample2(comb_size), &
         DBSCAN_Out%Press_Error_Sample1(comb_size), &
         DBSCAN_Out%Press_Error_Sample2(comb_size), &
         DBSCAN_Out%Temp_Error_Sample1(comb_size), &
         DBSCAN_Out%Temp_Error_Sample2(comb_size), &
         DBSCAN_Out%Cld_OD_Sample1(comb_size), &
         DBSCAN_Out%Cld_OD_Sample2(comb_size), &
         DBSCAN_Out%ACHA_Cost_Sample1(comb_size), &
         DBSCAN_Out%ACHA_Cost_Sample2(comb_size), &
         DBSCAN_Out%Phase_Sample1(comb_size), &
         DBSCAN_Out%Phase_Sample2(comb_size), &
         DBSCAN_Out%Type_Sample1(comb_size), &
         DBSCAN_Out%Type_Sample2(comb_size), &
         DBSCAN_Out%Delta_X_Reverse(comb_size), &
         DBSCAN_Out%Delta_Y_Reverse(comb_size), &
         DBSCAN_Out%Delta_X_Forward(comb_size), &
         DBSCAN_Out%Delta_Y_Forward(comb_size), &
         DBSCAN_Out%vector(comb_size), &
         DBSCAN_Out%Delta_X_Init(2*Box_Size, 2*Box_Size), &
         DBSCAN_Out%Delta_Y_Init(2*Box_Size, 2*Box_Size), &
         DBSCAN_Out%Delta_X_Final(2*Box_Size, 2*Box_Size), &
         DBSCAN_Out%Delta_Y_Final(2*Box_Size, 2*Box_Size), stat=astatus)
      ! aab Tandem (dbscan)   ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

      IF (astatus /= 0) THEN
         CALL fw_log_error(FUNC, 'failure to allocate')
         res = .FALSE.
      ELSE
         res = .TRUE.
      ENDIF

   END FUNCTION Create


   !> @brief Initialize variable DBSCAN_Out to default values
   SUBROUTINE DBSCAN_Output_Initialize(DBSCAN_Out)
      TYPE(DBSCAN_Output), INTENT(INOUT) :: DBSCAN_Out !< to be initialized

      DBSCAN_Out%Number_CTP_Sample1 = MISSING_VALUE_INT4
      DBSCAN_Out%Number_CTP_Sample2 = MISSING_VALUE_INT4
      DBSCAN_Out%Sample1 = MISSING_VALUE_INT4
      DBSCAN_Out%Sample2 = MISSING_VALUE_INT4
      DBSCAN_Out%Initial_Sample = 0
      DBSCAN_Out%Number_BT_Sample1 = MISSING_VALUE_INT4
      DBSCAN_Out%Number_BT_Sample2 = MISSING_VALUE_INT4
      DBSCAN_Out%NumberOfClusters1 = MISSING_VALUE_INT4
      DBSCAN_Out%NumberOfClusters2 = MISSING_VALUE_INT4
      DBSCAN_Out%MaxCluster1 = MISSING_VALUE_INT4
      DBSCAN_Out%MaxCluster2 = MISSING_VALUE_INT4
      DBSCAN_Out%MaxClusterSize1 = MISSING_VALUE_INT4
      DBSCAN_Out%MaxClusterSize2  = MISSING_VALUE_INT4
      DBSCAN_Out%Max1_PctOfSample  = MISSING_VALUE_REAL4
      DBSCAN_Out%Max2_PctOfSample  = MISSING_VALUE_REAL4
      DBSCAN_Out%StdDev_MVD1 = MISSING_VALUE_REAL4
      DBSCAN_Out%StdDev_MVD2 = MISSING_VALUE_REAL4
      DBSCAN_Out%PctOfAvg1 =MISSING_VALUE_REAL4
      DBSCAN_Out%PctOfAvg2 =MISSING_VALUE_REAL4
      DBSCAN_Out%CTP_5x5_Sample1(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%CTP_5x5_Sample2(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%CORR_5x5_Sample1(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%CORR_5x5_Sample2(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%CldTemp_5x5_Sample1(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%CldTemp_5x5_Sample2(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Cld_Hgt_5x5_Sample1(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Cld_Hgt_5x5_Sample2(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%BT_5x5_Sample1(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%BT_5x5_Sample2(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Press_Error_Sample1(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Press_Error_Sample2(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Temp_Error_Sample1(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Temp_Error_Sample2(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Cld_OD_Sample1(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Cld_OD_Sample2(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%ACHA_Cost_Sample1(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%ACHA_Cost_Sample2(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Phase_Sample1(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Phase_Sample2(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Type_Sample1(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Type_Sample2(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Delta_X_Reverse(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Delta_Y_Reverse(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Delta_X_Forward(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Delta_Y_Forward(:) = MISSING_VALUE_REAL4
      ! aab Tandem (dbscan)
      DBSCAN_Out%vector(:) = MISSING_VALUE_REAL4
      DBSCAN_Out%Delta_X_Init = 0.0
      DBSCAN_Out%Delta_Y_Init = 0.0
      DBSCAN_Out%Delta_X_Final = 0.0
      DBSCAN_Out%Delta_Y_Final = 0.0
      DBSCAN_Out%Avg_Delta_X_Sample1 = MISSING_VALUE_REAL4
      DBSCAN_Out%Avg_Delta_Y_Sample1 = MISSING_VALUE_REAL4
      DBSCAN_Out%Avg_Delta_X_Sample2 = MISSING_VALUE_REAL4
      DBSCAN_Out%Avg_Delta_Y_Sample2 = MISSING_VALUE_REAL4
      DBSCAN_Out%Avg_Delta_X_2ndCluster_Rev = MISSING_VALUE_REAL4
      DBSCAN_Out%Avg_Delta_Y_2ndCluster_Rev = MISSING_VALUE_REAL4
      DBSCAN_Out%Avg_Delta_X_2ndCluster_For = MISSING_VALUE_REAL4
      DBSCAN_Out%Avg_Delta_Y_2ndCluster_For = MISSING_VALUE_REAL4
      DBSCAN_Out%Avg_Delta_X_3rdCluster_Rev = MISSING_VALUE_REAL4
      DBSCAN_Out%Avg_Delta_Y_3rdCluster_Rev = MISSING_VALUE_REAL4
      DBSCAN_Out%Avg_Delta_X_3rdCluster_For = MISSING_VALUE_REAL4
      DBSCAN_Out%Avg_Delta_Y_3rdCluster_For = MISSING_VALUE_REAL4
      DBSCAN_Out%Median_Press_2ndCluster = MISSING_VALUE_REAL4
      DBSCAN_Out%Median_Press_3rdCluster = MISSING_VALUE_REAL4
      DBSCAN_Out%PointsIn2ndCluster = MISSING_VALUE_INT4
      DBSCAN_Out%PointsIn3rdCluster = MISSING_VALUE_INT4



   END SUBROUTINE DBSCAN_Output_Initialize

   !> @brief deallocate space for variable DBSCAN_Out
   !>      Should be called automatically as the structures FINAL method.
   SUBROUTINE Destroy(DBSCAN_Out)
      TYPE(DBSCAN_Output) :: DBSCAN_Out !< to be destroyed.

      IF(ALLOCATED(DBSCAN_Out%CTP_5x5_Sample1)) THEN
         DEALLOCATE(DBSCAN_Out%CTP_5x5_Sample1, &
         DBSCAN_Out%CTP_5x5_Sample2, &
         DBSCAN_Out%CORR_5x5_Sample1, &
         DBSCAN_Out%CORR_5x5_Sample2, &
         DBSCAN_Out%CldTemp_5x5_Sample1, &
         DBSCAN_Out%CldTemp_5x5_Sample2, &
         DBSCAN_Out%Cld_Hgt_5x5_Sample1, &
         DBSCAN_Out%Cld_Hgt_5x5_Sample2, &
         DBSCAN_Out%BT_5x5_Sample1, &
         DBSCAN_Out%BT_5x5_Sample2, &
         DBSCAN_Out%Press_Error_Sample1, &
         DBSCAN_Out%Press_Error_Sample2, &
         DBSCAN_Out%Temp_Error_Sample1, &
         DBSCAN_Out%Temp_Error_Sample2, &
         DBSCAN_Out%Cld_OD_Sample1, &
         DBSCAN_Out%Cld_OD_Sample2, &
         DBSCAN_Out%ACHA_Cost_Sample1, &
         DBSCAN_Out%ACHA_Cost_Sample2, &
         DBSCAN_Out%Phase_Sample1, &
         DBSCAN_Out%Phase_Sample2, &
         DBSCAN_Out%Type_Sample1, &
         DBSCAN_Out%Type_Sample2, &
         DBSCAN_Out%Delta_X_Reverse, &
         DBSCAN_Out%Delta_Y_Reverse, &
         DBSCAN_Out%Delta_X_Forward, &
         DBSCAN_Out%Delta_Y_Forward, &
         ! aab Tandem (dbscan)
         DBSCAN_Out%vector, &
         DBSCAN_Out%Delta_X_Init, &
         DBSCAN_Out%Delta_Y_Init, &
         DBSCAN_Out%Delta_X_Final, &
         DBSCAN_Out%Delta_Y_Final)
      ENDIF

   END SUBROUTINE Destroy

END MODULE AMV_EN_DBSCAN_M

! ------------------------------------------------------------------------------
!
! Name:
!   Target_Selection
!
! Function:
!   Select targets to be used for deriving atmospheric motion vectors (AMVs).
!
! Description:
!   The purpose of this module is to select image features that will
!   subsequently be tracked to derive atmospheric motion. The image data is
!   provided by the main GEOCAT program in the form of line segments. The
!   line segment data is subdivided into smaller regions (typically 15 lines
!   by 15 elements) called target scenes and a variety of tests are performed
!   on each scene. Tests include:
!
!               contrast (max BrtTemp - min BrtTemp)
!               earth edge (space)
!               cloud amount
!                 - cloud tracers; at least 10 percent cloud coverage
!                 - clear sky tracer; 100 percent clear coverage
!  Target QC    bad data (reasonable data values)
!               spatial coherence
!               multi-layer check
!               day/night terminator check (visible and 3.9 channel only)
!               valid height assignment (at least 2 percent of pixels)
!               pressure thresholds (band specific)
!   ----------------------------------------------------------------------------
!                max correlation on boundary of search
!                minimum correlation check (current threshold is 0.6)
!   Tracking QC  acceleration check + gross error checks
!                EUMETSAT Quality Indicator (QI)
!                Expected Error (EE)
!
!   Additonal checks have been introduced with the advent of nested tracking,
!   these include:
!
!               zero sample of local motion vectors
!               change in median pressure between sample 1 (reverse vector)
!               and sample 2 (forward vector) exceeds 100 mb
!
!   Notes:
!
!   1. This routine uses a buffer (nominally 105 lines) to hold image data
!   (brightness temperatures, reflectances and radiances) as well as output
!   from the cloud mask and cloud height algorithms, which must run prior to
!   this routine being called. No AMVs are generated until the data buffer
!   is full.
!
!   2. Only the middle portion of the buffer is processed. This is to allow
!   cloud features to move outside the strip being processed for targets.
!
!
!   3. The target box is positioned over the maximum BrtTemp gradient within
!   the original target scene. This requires that the box data be re-sampled
!   because the initial target box may or may not be centered on the maximum
!   gradient. The above tests are applied to the scene centered on the max
!   gradient.
!
!   4. The spatial coherence analysis is used to filter out scenes which are too
!   coherent (and thus difficult to track by correlation methods) or that
!   contain more than two layers (height assignment of multi-layered target
!   scenes is not attempetd).
!
! References:
!
!   Daniels and Bresky (2010), "A New Nested Tracking Approach for Reducing the
!   Slow Speed Bias Associated with Atmospheric Motion Vectors (AMVs)."
!   Proceedings of the Tenth International Winds Workshop (IWW10).
!
!   Velden et al (2005), "Recent Innovations in Deriving Tropospheric Winds From
!   Meteorological Satellites." Bulletin of the American Meteorological Society,
!   February 2005.
!
!   Nieman et al (1997), "Fully Automated Cloud-Drift Winds in NESDIS
!   Operations." Bulletin of the American Meteorological Society, June 1997.
!
! Calling sequence:
!   Use GEOCAT command line with cloud mask, cloud type, cloud height and the
!   AMV algorithms all specified.
!
!   (e.g., geocat -akey baseline_cmask_seviri baseline_ctype_seviri
!                       baseline_cld_hght_seviri winds ....)
!
! Inputs:
!   All input data is passed through GEOCAT structures (satellite data, cloud
!   mask, space mask, cloud top pressure). The file "geocat.default" should be
!   used to specify default configuration values. Most importantly, the number
!   of scan lines processed at one time should be set (usually 15 lines).
!
!   The include file "winds.inc" is used to specify certain parameters specific
!   to the AMV algorithm.
!
! Outputs:
!   1. ASCII file - to be replaced with netCDF file.
!
! Dependencies:
!   GEOCAT satellite data structure must be populated for this segment as well
!   as the cloud height error from the out2 data structure. The configutration
!   file "winds.config" controls several processing configuration settings
!   including the size of the target box, the satellite band to process, the
!   loop time interval and whether or not to attempt nested tracking. The
!   include file "winds.inc" is also required.
!
!   The cloud mask, cloud type and cloud height algorithms must run prior
!   to calling this routine.
!
! Restrictions:
!
! History:
!  04/2007 - Wayne Bresky - Created.
!  11/2008 - Wayne Bresky - New bands added. Removed constraint that line
!                           segment had to be multiple of target box size.
!  02/2009 - Wayne Bresky - Gross error checks introduced with input from
!                           Chris Velden and Steve Wanzong at CIMSS.
!  03/2009 - Wayne Bresky - Low level inversion flag, output from Cloud
!                           height algorithm, added to buffer.
!  03/2010 - Wayne Bresky - Nested tracking introduced.
!  04/2010 - Wayne Bresky - Code Unit Test Review (CUTR) issues addressed.
!  08/2010 - Wayne Bresky / Steve Wanzong - Weighting function-derived heights
!                           added for clear-sky WV winds, additional diagnostic
!                           output variables added.
!
!-------------------------------------------------------------------------------
MODULE AMV_EN_TARGET_SELECTION_M
      USE ds_data_mod
      USE cf_data_mod
      USE fw_log_mod
      USE fw_scene_mod
      USE fw_str_util_mod
      USE URIHelper_mod

      USE AMV_EN_input_m
      USE AMV_EN_Quality_m
      USE AMV_EN_BestFitPress_m
      USE AMV_EN_Wind_Data_m
      USE AMV_EN_Error_Counts_m
      USE AMV_EN_XPATH_M
      USE AMV_EN_TARGET_SELECTION_UTILS_M
      USE AMV_EN_FEATURE_TRACKING_UTILS_M
      USE AMV_EN_WINDS_INC
   IMPLICIT NONE

   PRIVATE
   PUBLIC :: Target_Selection_Main


CONTAINS

   FUNCTION get_instrument_parameters(Nav, SatName, IntrumentName, resolution, ChannelName, &
                                      ImageStartElem_native, ImageStartLine_native, SatLat, SatLon) RESULT(ret)
      CHARACTER(len=*), PARAMETER :: FUNC = "get_instrument_parameters"
      TYPE(Nav_t), INTENT(OUT) :: Nav !< contains everything needed for pixcoord2geocoord and geocoord2pixcoord.
      CHARACTER(LEN=:), ALLOCATABLE, INTENT(OUT) :: SatName !< GOES16, GOES17, NPP, NOAA20, etc.
      CHARACTER(LEN=:), ALLOCATABLE, INTENT(OUT) :: IntrumentName !< ABI, VIIRS, etc.
      CHARACTER(LEN=:), ALLOCATABLE, INTENT(OUT) :: resolution !< ABI_2KM, ABI_500M, VIIRS_750, etc.
      CHARACTER(LEN=:), ALLOCATABLE, INTENT(OUT) :: ChannelName !< AMV Channel
      type(fw_data_context) :: ctx_line  !< context. Describes location within the larger picture
      type(fw_data_context):: ctx_elem !< context. Describes location within the larger picture
      INTEGER(DLONG), INTENT(OUT) :: ImageStartElem_native !< segment start x (element)
                                                           !< in the native image coordinates (0 or 1 at origin)
      INTEGER(DLONG), INTENT(OUT) :: ImageStartLine_native !< segment start y (line)
                                                           !< in the native image coordinates (0 or 1 at origin)
      REAL(SINGLE), INTENT(OUT)  :: SatLat !< satellite latitude subpoint used in computing wind azimuth/zenith angle
      REAL(SINGLE), INTENT(OUT)  :: SatLon !< satellite longitude subpoint used in computing wind azimuth/zenith angle
      INTEGER(LONG):: Sat_ID

      LOGICAL :: ret

      !TYPE(Nav_t) :: Nav
      INTEGER(SHORT), DIMENSION(:), POINTER :: X !< indicates the navigation x/y. used to determine first x/y (0 or 1 origin)
      INTEGER(SHORT), DIMENSION(:), POINTER :: Y !< indicates the navigation x/y. used to determine first x/y (0 or 1 origin)
      LOGICAL :: has_INPUT_X !< certain sensors might not store x and y
      type(fw_data_id) :: radiometricID !< describes the input BT/Radiance
      ret = .FALSE.



      NULLIFY(X,Y)


      !
      ! Get a descriptor for the incoming BT or Radiance.
      !
      IF(.NOT. cf_get(INPUT_MIDDLE_RADIOMETRIC_DATA_LBL, radiometricID, FUNC)) RETURN
      SatName = radiometricID%satellite_id
      IntrumentName = radiometricID%instrument_id
      resolution = radiometricID%resolution_id
      ChannelName = radiometricID%channel_id
      IF(.NOT. ds_get(INPUT_SENSOR_SERIES_LBL, Sensor_Series, FUNC)) RETURN


      IF(.NOT. cf_get(PAR_NAV_TYPE_LBL, Nav%NavType, FUNC)) RETURN
      IF(.NOT. ds_get(INPUT_PROJECTED_LAT_LBL, SatLat, FUNC)) RETURN ! inaccurate to use projection origin
                                                                     ! we should injest both projection and nadir.
      IF(.NOT. ds_get(INPUT_PROJECTED_LON_LBL, SatLon, FUNC)) RETURN ! inaccurate to use projection origin
                                                                     ! we should injest both projection and nadir.
      IF(.NOT. ds_get(INPUT_MCIDAS_ID_LBL, Sat_ID, FUNC)) RETURN
      Nav%Sat_ID = Sat_ID
      Nav%Sensor_Series = Sensor_Series ! this is a global right now.




      IF(IntrumentName == "SEVIRI") THEN
         IF(.NOT.ds_get(INPUT_ORBITAL_RADIUS_LBL, Nav%SEVIRI%SAT_HEIGHT_MSG, FUNC)) RETURN
         IF(.NOT.ds_get(INPUT_COLUMN_FACTOR_LBL, Nav%SEVIRI%CFAC, FUNC)) RETURN
         IF(.NOT.ds_get(INPUT_LINE_FACTOR_LBL, Nav%SEVIRI%LFAC, FUNC)) RETURN
         IF(.NOT.ds_get(INPUT_COLUMN_OFFSET_LBL, Nav%SEVIRI%COFF, FUNC)) RETURN
         IF(.NOT.ds_get(INPUT_LINE_OFFSET_LBL, Nav%SEVIRI%LOFF, FUNC)) RETURN
         Nav%SEVIRI%SubSatLonRad = REAL(SatLon/DTOR, DOUBLE)
      ELSEIF(IntrumentName == "IMAGER") THEN
         !BH CALL Build_GVAR_Nav_Struct(Ctxt)
         CALL fw_log_error(FUNC, "Not yet supported.")
         RETURN
      ELSEIF (TRIM(Nav%NavType) .EQ. 'PS' ) THEN
         IF(.NOT.FillNav_Polar(Nav)) RETURN
      ELSE
         Nav%ABI%SubSatLon = SatLon
         Nav%ABI%SubSatLat = SatLat
         IF(.NOT.ds_get(INPUT_X_SCALE_LBL, Nav%ABI%XScale, FUNC)) RETURN
         IF(.NOT.ds_get(INPUT_Y_SCALE_LBL, Nav%ABI%YScale, FUNC)) RETURN
         IF(.NOT.ds_get(INPUT_X_OFFSET_LBL, Nav%ABI%XOffset, FUNC)) RETURN
         IF(.NOT.ds_get(INPUT_Y_OFFSET_LBL, Nav%ABI%YOffset, FUNC)) RETURN
      ENDIF


      IF(.NOT. fw_uri_segment_ctx(INPUT_MIDDLE_RADIOMETRIC_DATA_LBL, FW_DIM_ROW, ctx_line, FUNC)) RETURN
      IF(.NOT. fw_uri_segment_ctx(INPUT_MIDDLE_RADIOMETRIC_DATA_LBL, FW_DIM_COLUMN, ctx_elem, FUNC)) RETURN
      IF (.NOT.cf_has(INPUT_X_LBL, has_INPUT_X, FUNC)) RETURN
      IF( has_INPUT_X ) THEN
         IF(.NOT.ds_get(INPUT_X_LBL, X, FUNC)) RETURN
         IF(.NOT.ds_get(INPUT_Y_LBL, Y, FUNC)) RETURN
         ImageStartElem_native = INT(X(1), KIND=DLONG)
         ImageStartLine_native = INT(Y(1), KIND=DLONG)
      ELSE
         ImageStartElem_native = ctx_elem%position%start_pos
         ImageStartLine_native = ctx_line%position%start_pos
      ENDIF


      ret = .TRUE.
   END FUNCTION get_instrument_parameters


   !> this is the main subroutine to perform wind retrieval
   SUBROUTINE Target_Selection_Main(Stat)


      IMPLICIT NONE
      CHARACTER(LEN=*), PARAMETER :: FUNC = "Target_Selection_NOP_Main"

      TYPE(Nav_t) :: Nav !< stores all the needed navigation parameters for any given sensor/projection
      INTEGER(DLONG) :: ImageStartElem_native !< segment start x (element) in the native image coordinates (0 or 1 at origin)
      INTEGER(DLONG) :: ImageStartLine_native !< segment start y (line) in the native image coordinates (0 or 1 at origin)
      CHARACTER(LEN=:), ALLOCATABLE :: SatName !< GOES16, GOES17, METOPC, etc.
      CHARACTER(LEN=:), ALLOCATABLE :: IntrumentName !< ABI, SEVIRI, AVHRR, etc.
      CHARACTER(LEN=:), ALLOCATABLE :: resolution !< ABI_2KM, ABI_500M, etc.
      CHARACTER(LEN=:), ALLOCATABLE :: ChannelName !< The AMV Channel, before potential degrading
      INTEGER(LONG) :: Stat

      !input descriptions
      CHARACTER(len=128) :: string
      TYPE(fw_time_stamp) :: middle_time_stamp !< nominal timestamp of the middle image
      INTEGER(LONG), DIMENSION(NUMBER_TIMESTEPS) :: EpochImageTimes !< granule times of 3 images [seconds since 1/1/1970]
      REAL(SINGLE)  :: Time_Interval  !< average time between images [min]
      REAL(SINGLE)  :: Time_Interval_minus !< time between middle and first image [min]
      REAL(SINGLE)  :: Time_Interval_plus !< time between middle and last image [min]


      !Navigation inputs
      REAL(SINGLE) :: SatLat  !< satellite latitude subpoint used in computing wind azimuth/zenith angle
      REAL(SINGLE) :: SatLon  !< satellite longitude subpoint used in computing wind azimuth/zenith angle
      type(fw_data_context):: ctx_line !< context. Describes location within the larger picture
      type(fw_data_context):: ctx_elem !< context. Describes location within the larger picture
      type(fw_data_range):: lineROI !< the region of interest within the padded segment
      type(fw_data_range):: elemROI !< the region of interest within the padded segment


      !
       !inputs
      !
      TYPE(input_t) :: input !< stores all the inputs
      INTEGER(BYTE), DIMENSION(:,:), POINTER :: Space_Mask !< space mask of the middle granule
      TYPE(ForecastProfilesGrid_t) :: forecastProfiles !< gfs grid/profiles for the middle granule

      INTEGER(SHORT) :: BUFFER_SEGMENTS !< the original winds implementation had this.
                                        !!  Tracking starts at the center line of a buffer.
                                        !!  The buffer is roughly BUFFER_SEGMENTS times the nominal box size.
                                        !!  The buffer is then incremented towards the bottom of the image
                                        !!  until there is no more padding remaining in the segment.
                                        !!  All it's doing now is preventing tracking from starting
                                        !!  at the beginning and ending of an image
                                        !!  and that isn't especially desirable anyway.

      CHARACTER(len=:), ALLOCATABLE :: targetType  !< Cloud Top ('CT') or Clear Sky ('CS')
      INTEGER(LONG) :: Lag_Size !< Lag Size used in the search
      INTEGER(LONG) :: Nested_Tracking_Flag !< flag indicating nested tracking is enabled (sym%YES or sym%NO)

      ! aab Tandem mod
      CHARACTER(len=:), ALLOCATABLE :: TandemTriplet  !< Tandem-VPW Triplet Configuration 

      !
      ! Outputs
      !
      INTEGER(LONG), DIMENSION(41) :: Error_Counts(-10:30)
      REAL(SINGLE), DIMENSION(:, :), ALLOCATABLE :: Wind_Data !< per target data storage
                                                              !! where the second index is used to store different variables.
      TYPE(TargetData_t) :: TargetData !< per target data storage. can replace Wind_data.
      INTEGER(LONG) :: Target_Number !< number of targets
      INTEGER(LONG) :: Good_Targets !< number of targets with no errors

      INTEGER(LONG) :: MAX_WIND_RECORDS !< must be above the maximum number of targets otherwise wind_data runs out of room to store results.
      REAL(SINGLE)   :: CORR_MIN  !< correlation must be greater than this value.


      LOGICAL :: isTrackingSkipped !<  tracking can be skipped when inputs are insufficient quality

      Stat = RETURN_FAIL

      Target_Number = 0
      Good_Targets = 0
      Good_Winds = 0
      Error_Counts(-10:30) = 0


      IF(.NOT. cf_get(PAR_AMV_IDX_LBL, Channel, FUNC)) RETURN

      IF(.NOT. get_instrument_parameters(Nav, SatName, IntrumentName, resolution, ChannelName, &
                                         ImageStartElem_native, ImageStartLine_native, SatLat, SatLon)) RETURN

      !
      ! Obtain the position and region of interest within the BT/Radiance image.
      ! The image has padding and the region of interest is the part we wish to keep.
      IF(.NOT. fw_uri_segment_ctx(INPUT_MIDDLE_RADIOMETRIC_DATA_LBL, FW_DIM_ROW, ctx_line, FUNC)) RETURN
      IF(.NOT. fw_uri_segment_ctx(INPUT_MIDDLE_RADIOMETRIC_DATA_LBL, FW_DIM_COLUMN, ctx_elem, FUNC)) RETURN
      lineROI = fw_roi_in_ctx(ctx_line)
      elemROI = fw_roi_in_ctx(ctx_elem)


      IF(.NOT. ds_get(INPUT_SPACE_MSK_LBL, Space_Mask, FUNC)) RETURN


      IF(.NOT. ds_get(INPUT_MIDDLE_TIME_STAMP_LBL, middle_time_stamp, FUNC)) RETURN



      IF(.NOT. cf_get(PAR_BOX_SIZE_LBL, Box_Size, FUNC)) RETURN
      IF(.NOT. cf_get(PAR_LAG_SIZE_LBL, Lag_Size, FUNC)) RETURN !< this is a function of time delta
      IF(.NOT. cf_get(PAR_NESTED_TRACKING_FLAG_LBL, Nested_Tracking_Flag, FUNC)) RETURN
      IF(.NOT. cf_get(PAR_TARGET_TYPE_LBL, targetType, FUNC)) RETURN

      ! aab Tandem mod
      IF(.NOT. cf_get(PAR_TANDEM_TRIPLET_LBL, TandemTriplet, FUNC)) RETURN

      IF(.NOT. cf_get(PAR_MAX_WINDS_PER_SEGMENT_LBL, MAX_WIND_RECORDS, FUNC)) RETURN


      IF(.NOT. ds_get(FIRST_GMT_EPOCH1970_LBL, EpochImageTimes(FIRST), FUNC)) RETURN
      IF(.NOT. ds_get(MIDDLE_GMT_EPOCH1970_LBL,EpochImageTimes(MIDDLE), FUNC)) RETURN
      IF(.NOT. ds_get(LAST_GMT_EPOCH1970_LBL, EpochImageTimes(LAST), FUNC)) RETURN

      IF(.NOT. ds_get(TIME_INTERVAL_MINUS_LBL, Time_Interval_minus, FUNC)) RETURN
      IF(.NOT. ds_get(TIME_INTERVAL_PLUS_LBL, Time_Interval_plus, FUNC)) RETURN
      IF(.NOT. ds_get(TIME_INTERVAL_AVERAGE_LBL, Time_Interval,FUNC)) RETURN
      !---------------------------------------
      ! set parameters according to instrument
      !---------------------------------------
      IF (TRIM(Nav%NavType) .EQ. 'PS' ) THEN
         BUFFER_SEGMENTS = BUFFER_SEGMENTS_POLAR
         MIN_PERCENT_PRESS_VALUES = MIN_PERCENT_PRESS_VALUES_POLAR
         IR_GRADIENT_THRESHOLD = IR_GRADIENT_THRESHOLD_POLAR
         CORR_MIN = CORR_MIN_POLAR
      ELSE
         BUFFER_SEGMENTS = BUFFER_SEGMENTS_GEO
         MIN_PERCENT_PRESS_VALUES = MIN_PERCENT_PRESS_VALUES_GEO
         IR_GRADIENT_THRESHOLD = IR_GRADIENT_THRESHOLD_GEO
         CORR_MIN = CORR_MIN_GEO
      ENDIF





      IF (targetType == TARGET_CLEAR) CALL fw_log_info(FUNC, 'Clear sky processing active')
      ! This check was added to prevent nested tracking from being used with the clear-sky WV winds
      ! but, allow nested tracking to be used for polar CSWV processing
      IF ((targetType == TARGET_CLEAR) .AND. Nested_Tracking_Flag .EQ. sym%YES  .AND. TRIM(Nav%NavType) .NE. 'PS') THEN

         CALL fw_log_error(FUNC, 'Nested tracking should be off when processing clear-sky WV winds')
         RETURN

      ENDIF


      CALL fw_log_debug(FUNC, 'satellite: '//SatName)
      CALL fw_log_debug(FUNC, 'year: '//fw_to_str(middle_time_stamp%Year))
      CALL fw_log_debug(FUNC, 'day: '//fw_to_str(middle_time_stamp%julian_day))
      CALL fw_log_debug(FUNC, 'hour: '//fw_to_str(middle_time_stamp%Hour))
      CALL fw_log_debug(FUNC, 'minute: '//fw_to_str(middle_time_stamp%Minute))
      CALL fw_log_debug(FUNC, 'AMV Channel Index: '//fw_to_str(Channel))
      CALL fw_log_info(FUNC, 'Instrument Channel: '//ChannelName)
      WRITE(string,'(f10.2)') Time_Interval_minus
      CALL fw_log_info(FUNC, 'time interval backward (min): '//string)
      WRITE(string,'(f10.2)') Time_Interval_plus
      CALL fw_log_info(FUNC, 'time interval forward (min): '//string)
      WRITE(string,'(f10.2)') Time_Interval
      CALL fw_log_info(FUNC, 'Time_Interval: '//string)
      CALL fw_log_info(FUNC, 'target box size: '//fw_to_str(Box_Size))
      CALL fw_log_debug(FUNC, 'lag size: '//fw_to_str(Lag_Size))
      CALL fw_log_info(FUNC, 'Nested tracking flag: '//fw_to_str(Nested_Tracking_Flag))
      CALL fw_log_info(FUNC, "Product Resolution: "//resolution)
      ! aab Tandem mod
      IF (TRIM(Nav%NavType) .EQ. 'PS' ) THEN
         CALL fw_log_info(FUNC, "Tandem Triplet Configuration: "//TandemTriplet)
      ENDIF
      !CALL fw_log_debug(FUNC, 'Flag to read cloud file: '//fw_to_str(Temporal_Cloud_Flag))


      IF(.NOT.ds_get(INPUT_NWP_PRESSURE_LEVELS_LBL,forecastProfiles%PressureProfiles,FUNC)) RETURN
      forecastProfiles%Pressure => forecastProfiles%PressureProfiles(1,1,:)
      IF(.NOT.ds_get(INPUT_NWP_WND_U_PROF_LBL,forecastProfiles%U_Wind,FUNC)) RETURN
      IF(.NOT.ds_get(INPUT_NWP_WND_V_PROF_LBL,forecastProfiles%V_Wind,FUNC)) RETURN
      IF(.NOT.ds_get(INPUT_NWP_TEMPERATURE_PROF_LBL,forecastProfiles%Temperature,FUNC)) RETURN

      IF(.NOT. input%Load(isTrackingSkipped)) RETURN



      IF(.NOT. isTrackingSkipped) THEN
         ALLOCATE(Wind_Data(MAX_WIND_RECORDS, MAX_PARAMETERS))
         Wind_Data = MISSING_VALUE_REAL4
         IF(.NOT. TargetData%Create(MAX_WIND_RECORDS)) RETURN

         IF(.NOT. Target_Selection_Loop(&
                                    CORR_MIN, BUFFER_SEGMENTS, MAX_WIND_RECORDS, &
                                    Nested_Tracking_Flag,targetType, Lag_Size, TandemTriplet, &  !<--- aab Tandem mod
                                    ctx_line, &
                                    elemROI, lineROI, & !inputs
                                    ImageStartElem_native, ImageStartLine_native, & !inputs
                                    EpochImageTimes,Time_Interval_minus,Time_Interval_plus,&
                                    Nav, input, forecastProfiles, & !inputs
                                    SatLat, SatLon, Space_Mask, & !inputs
                                    Target_Number, Good_Targets,& !outputs ! Good_Winds is a global
                                    TargetData, Error_Counts, Wind_Data)& ! outputs
                                    &) RETURN
      ELSE
         CALL fw_log_warning(FUNC, 'Expected error encountered: skipping processing of channel .')
      ENDIF




      
      ! Put the values into cache
      
      IF(.NOT.ds_put(makeSegmentURI(ADHOC_URI_SCHEME, ERROR_COUNTS_ADHOC), Error_Counts,FUNC)) RETURN

      IF(Target_Number > 0) THEN
         IF(.NOT.ds_put(makeSegmentURI(ADHOC_URI_SCHEME, WIND_DATA_ADHOC), Wind_Data(1:Target_Number,:),FUNC)) RETURN
         IF(.NOT.ds_put(makeSegmentURI(ADHOC_URI_SCHEME, FIRST_TARGET_EPOCH_LBL),&
                                       TargetData%EpochTimes(1:Target_Number,FIRST),FUNC)) RETURN
         IF(.NOT.ds_put(makeSegmentURI(ADHOC_URI_SCHEME, MIDDLE_TARGET_EPOCH_LBL),&
                                       TargetData%EpochTimes(1:Target_Number,MIDDLE),FUNC)) RETURN
         IF(.NOT.ds_put(makeSegmentURI(ADHOC_URI_SCHEME, LAST_TARGET_EPOCH_LBL),&
                                       TargetData%EpochTimes(1:Target_Number,LAST),FUNC)) RETURN
      ENDIF

      IF(.NOT.ds_put(makeSegmentURI(ADHOC_URI_SCHEME, STAT_NUM_TARGETS_LBL), Target_Number,FUNC)) RETURN
      IF(.NOT.ds_put(makeSegmentURI(ADHOC_URI_SCHEME, STAT_NUM_GOOD_WINDS_LBL), Good_Winds,FUNC)) RETURN
      IF(.NOT.ds_put(makeSegmentURI(ADHOC_URI_SCHEME, STAT_NUM_GOOD_TARGETS_LBL), Good_Targets, FUNC)) RETURN

      CALL ErrorCountsLog(Error_Counts,Target_Number,Good_Targets,Good_Winds)


      IF(ALLOCATED(Wind_Data)) DEALLOCATE(Wind_Data)


      Stat=RETURN_SUCCESS

   END SUBROUTINE Target_Selection_Main

   !> targeting loop that will step through the segment. targeting will not be recorded if the start is outside the region of interest
   FUNCTION Target_Selection_Loop(&
   CORR_MIN, BUFFER_SEGMENTS, MAX_WIND_RECORDS, &
   Nested_Tracking_Flag,targetType, Lag_Size, TandemTriplet, &  !<-- aab Tandem mod
   ctx_line, &
   elemROI, lineROI, & !inputs
   ImageStartElem_native, ImageStartLine_native, & !inputs
   EpochImageTimes,Time_Interval_minus,Time_Interval_plus,&
   Nav, input, forecastProfiles, & !inputs
   SatLat, SatLon, Space_Mask, & !inputs
   Target_Number, Good_Targets,& !outputs ! Good_Winds is a global
   TargetData, Error_Counts, Wind_Data) RESULT(ret) ! outputs
      CHARACTER(len=*), PARAMETER :: FUNC = "Target_Selection_Loop"
      !Navigation inputs
      REAL(SINGLE), INTENT(IN)   :: CORR_MIN !< correlation must be greater than this value.
      INTEGER(SHORT), INTENT(IN) :: BUFFER_SEGMENTS !< the original winds implementation had this.
                                                    !  Tracking starts at the center line of a buffer.
                                                    !  The buffer is roughly BUFFER_SEGMENTS times the nominal box size.
                                                    !  The buffer is then incremented towards the bottom of the image
                                                    !  until there is no more padding remaining in the segment.
                                                    !  All it's doing now is preventing tracking from starting
                                                    ! at the beginning and ending of an image
                                                    !  and that isn't especially desirable anyway.
      INTEGER(LONG), INTENT(IN) :: MAX_WIND_RECORDS !< The winds record has a buffer size equal to this
      INTEGER(LONG), INTENT(IN) :: Nested_Tracking_Flag !< flag indicating nested tracking is enabled
      CHARACTER(len=*), INTENT(IN) :: targetType !< Cloud Top ('CT') or Clear Sky ('CS')
      INTEGER(LONG), INTENT(IN) :: Lag_Size !< Lag Size used in the search
      !aab Tandem mod
      CHARACTER(len=*), INTENT(IN) :: TandemTriplet !< Tandem-VPW Triplet Configuration
      type(fw_data_range), INTENT(IN):: elemROI !< the region of interest within the padded segment
      type(fw_data_range), INTENT(IN):: lineROI !< the region of interest within the padded segment
      type(fw_data_context), INTENT(IN):: ctx_line !< context. Describes location within the larger picture
      INTEGER(DLONG), INTENT(IN) :: ImageStartElem_native !< segment start x (element)
                                                          !< in the native image coordinates (0 or 1 at origin)
      INTEGER(DLONG), INTENT(IN) :: ImageStartLine_native !< segment start y (line)
                                                          !< in the native image coordinates (0 or 1 at origin)
      TYPE(Nav_t), INTENT(IN) :: Nav !< saves all the navigation parameters needed to map between x/y and lat/lon
      TYPE(input_t), INTENT(IN) :: input !< stores all the inputs
      REAL(SINGLE), INTENT(IN) :: SatLat !< satellite latitude subpoint
      REAL(SINGLE), INTENT(IN) :: SatLon !< satellite longitude subpoint
      INTEGER(BYTE), DIMENSION(:,:), INTENT(IN) :: Space_Mask !< space mask of the middle granule
      TYPE(ForecastProfilesGrid_t), INTENT(IN) :: forecastProfiles
      INTEGER(LONG), DIMENSION(NUMBER_TIMESTEPS), INTENT(IN) :: EpochImageTimes !< granule image times.
      REAL(SINGLE), INTENT(IN)  :: Time_Interval_minus !< granule image time interval minus (units: seconds)
      REAL(SINGLE), INTENT(IN)  :: Time_Interval_plus !< granule image time interval plus (units: seconds)

      ! Outputs Arrays
      INTEGER(LONG), INTENT(OUT) :: Target_Number
      INTEGER(LONG), INTENT(OUT) :: Good_Targets
      !INTEGER(LONG), INTENT(OUT) :: Good_winds ! global currently.
      INTEGER(LONG), INTENT(INOUT) :: Error_Counts(-10:30)
      REAL(SINGLE), INTENT(INOUT) :: Wind_Data(:, :)
      TYPE(TargetData_t), INTENT(INOUT) :: TargetData
      LOGICAL :: ret

      INTEGER(LONG) :: Elems
      INTEGER(LONG) :: Lines


      INTEGER(LONG):: Press_Levels
      INTEGER(LONG) :: X_NWP_Target
      INTEGER(LONG) :: Y_NWP_Target
      INTEGER(BYTE) :: LL_Inver_Flag !< low-level inversion flag


      TYPE(DBSCAN_Output) :: DBSCAN_Out


      ! position variables
      INTEGER(LONG) :: gradientLine !< line within the gradient loop
      INTEGER(LONG) :: gradientElem !< element within the gradient loop
      INTEGER(LONG) :: targetingLines !< lines available in the scene for targeting
      INTEGER(LONG) :: cutoff !< the lines to cut off before targetSceneStartLine
      INTEGER(LONG) :: targetSceneStartLine !< Line at the start of the "buffer" scene
      INTEGER(LONG) :: targetSceneEndLine !< Line at the end of the "buffer" scene
      INTEGER(LONG) :: gradientTrackingCenterLine !< line center of the "buffer" scene
      INTEGER(LONG) :: gradientTrackingCenterElem !< element center of the "buffer" scene
      INTEGER(LONG) :: gradientTrackingStartLine !< start of the gradient tracking
      INTEGER(LONG) :: gradientTrackingEndLine !< end of the the gradient tracking
      INTEGER(LONG) :: gradientTrackingStartElem !< start of the gradient tracking
      INTEGER(LONG) :: gradientTrackingEndElem !< end of the the gradient tracking
      INTEGER(LONG) :: Target_Center_Elem !< target center element relative to the segment
      INTEGER(LONG) :: Target_Center_Line !< target center line relative to the segment
      INTEGER(LONG), DIMENSION(Location_Dimensions) :: Max_Location !< location of maximum gradient magnitude in target box
      REAL(SINGLE) :: Target_Elem_native !< target x in the native image coordinates (0 or 1 based)
      REAL(SINGLE) :: Target_Line_native !< target y in the native image coordinates (0 or 1 based)


      TYPE(Output_Variables) :: Output


      REAL(SINGLE) :: Delta_Time_minus
      REAL(SINGLE) :: Delta_Time_plus
      INTEGER(LONG), DIMENSION(NUMBER_TIMESTEPS) :: EpochScanTimes


      ! image coordinates
      INTEGER(LONG) :: Target_Half_Width
      INTEGER(LONG) :: Search_Half_Width_Element
      INTEGER(LONG) :: Search_Half_Width_Line

      INTEGER(LONG) :: Diff_In_Size


      INTEGER(LONG) :: QC_Flag !< target quality control flag


      ! BrtTemp gradient information
      INTEGER(LONG) :: Gradient_Offset
      REAL(SINGLE) :: Gradient_X
      REAL(SINGLE) :: Gradient_Y
      REAL(SINGLE) :: Gradient_Max
      REAL(SINGLE) :: Gradient_Magnitude


      ! displacement of search box center from target box center
      REAL(SINGLE) :: Delta_X_Fcst
      REAL(SINGLE) :: Delta_Y_Fcst


      ! pixel factor
      REAL(SINGLE) :: Factor

      ! earth coordinates of target, search and match regions
      REAL(DOUBLE) :: Latitude  !< Lat_Target in double precision
      REAL(DOUBLE) :: Longitude !< Lon_Target in double precision
      REAL(SINGLE) :: Lat_Target
      REAL(SINGLE) :: Lon_Target
      REAL(SINGLE) :: Lat_Match
      REAL(SINGLE) :: Lon_Match
      REAL(SINGLE) :: Lat_Match2
      REAL(SINGLE) :: Lon_Match2

      ! end points for nested tracking estimate
      REAL(SINGLE) :: Lat_Match3
      REAL(SINGLE) :: Lon_Match3
      REAL(SINGLE) :: Lat_Match4
      REAL(SINGLE) :: Lon_Match4


      ! tracking variables
      INTEGER(LONG) :: Status_Flag1
      INTEGER(LONG) :: Status_Flag2
      INTEGER(LONG) :: Least_Square_Error
      REAL(SINGLE) :: Line_Disp
      REAL(SINGLE) :: Element_Disp
      REAL(SINGLE) :: Line_Disp2
      REAL(SINGLE) :: Element_Disp2

      REAL(DOUBLE) :: Target_Scene_Mean
      REAL(DOUBLE) :: Target_Scene_StdDev
      REAL(DOUBLE) :: Match_Scene_Mean
      REAL(DOUBLE) :: Match_Scene_StdDev


      REAL(SINGLE) :: U_Avg
      REAL(SINGLE) :: V_Avg
      REAL(SINGLE) :: U_Component !< u wind of reverse vector (negative time interval)
      REAL(SINGLE) :: V_Component !< v wind of reverse vector (negative time interval)
      REAL(SINGLE) :: U_Component2 !< u wind of forward vector (positive time interval)
      REAL(SINGLE) :: V_Component2 !< v wind of forward vector (positive time interval)

      ! Data from largest clusters found through DBSCAN analysis
      ! First sample is for reverse vector, second sample is for forward vector
      REAL(SINGLE) :: Median_CTP_Sample1
      REAL(SINGLE) :: Median_CTP_Sample2
      REAL(SINGLE) :: Combined_Median
      REAL(SINGLE) :: Combined_Median_Hgt


      ! height assignment variables
      REAL(SINGLE) :: Median_Press2
      REAL(SINGLE) :: Median_BrtTemp


      INTEGER(LONG), DIMENSION(:,:), ALLOCATABLE :: Lag_Table
      INTEGER(LONG), DIMENSION(:,:), ALLOCATABLE :: Lag_Table2
      REAL(SINGLE), DIMENSION(:,:), ALLOCATABLE :: Search_BrtTemp_Values
      REAL(SINGLE), DIMENSION(:,:), ALLOCATABLE :: Search_BrtTemp_Values2
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:,:) :: SetOfPoints
      REAL(SINGLE), ALLOCATABLE, DIMENSION(:) :: SSD_Matrix

      TYPE(Forecast_Profiles) :: Fcst_Prof
      TYPE(Target_Box_Data) :: Box_Data
      INTEGER(LONG) :: Box_Element_Start
      INTEGER(LONG) :: Box_Element_End
      INTEGER(LONG) :: Box_Line_Start
      INTEGER(LONG) :: Box_Line_End

      INTEGER(LONG) :: Search_Size
      INTEGER(LONG) :: Lag_Array_Size
      INTEGER(LONG) :: Start_Element
      INTEGER(LONG) :: End_Element
      INTEGER(LONG) :: Level
      TYPE(Uniformity_t) :: Unif

      REAL(SINGLE) LD_Test  !< avg line displacement of pts in largest cluster (reverse vector)
      REAL(SINGLE) ED_Test  !< avg ele displacement of pts in largest cluster (reverse vector)
      REAL(SINGLE) CC_Test  !< linear correlation of matching scene (reverse vector)
      INTEGER(LONG) SF_Test  !< quality flag (reverse vector)

      REAL(SINGLE) LD_Test2  !< avg line displacement of pts in largest cluster (forward vector)
      REAL(SINGLE) ED_Test2  !< avg ele displacement of pts in largest cluster (forward vector)
      REAL(SINGLE) CC_Test2  !< linear correlation of matching scene (forward vector)
      INTEGER(LONG) SF_Test2  !< quality flag (forward vector)

      ! aab Tandem (dbscan)
      INTEGER(LONG) comb_size
      REAL(SINGLE) Sum_DX1, Sum_DY1, Avg_DX1, Avg_DY1, Sum_DX2, Sum_DY2, Avg_DX2, Avg_DY2

      ret = .FALSE.

      Target_Number = 0
      Good_Targets = 0



      SELECT CASE(targetType)
         CASE (TARGET_CLEAR)
            CSWV_Flag = CSWV_CLEAR
         CASE (TARGET_CLOUD)
            CSWV_Flag = CSWV_CLOUD
         CASE DEFAULT
            CALL fw_log_error(FUNC, "Target Type is not properly assigned")
            RETURN
      END SELECT


      !For most satellites the scan time of target is assumed constant
      Delta_Time_minus = Time_Interval_minus / MIN_IN_A_HOUR
      Delta_Time_plus = Time_Interval_plus / MIN_IN_A_HOUR

      Lines = SIZE(Space_Mask,2)
      Elems = SIZE(Space_Mask,1)

      !-----------------------------------------------------------------------------
      ! Initialize variables
      !-----------------------------------------------------------------------------

      Press_Levels = size(forecastProfiles%Pressure)

      Total_Points = Box_Size**2
      Target_Half_Width = Box_Size / 2

      ! the lag array has one additional element to account for center position (lag position zero)
      Lag_Array_Size = Lag_Size + MOD(Lag_Size+1,2)
      Search_Size = Box_Size + (Lag_Size / 2) * 2
      Search_Half_Width_Element = (Search_Size - 1) / 2
      Search_Half_Width_Line = Search_Half_Width_Element



      CALL fw_log_info(FUNC, 'Lag Array Size: '//fw_to_str(Lag_Array_Size))
      CALL fw_log_info(FUNC, 'Search Size: '//fw_to_str(Search_Size))
      CALL fw_log_info(FUNC, 'Search Half Width Element: '//fw_to_str(Search_Half_Width_Element))
      CALL fw_log_info(FUNC, 'Dimensions of search (elements x lines): '//&
                             fw_to_str(2 * Search_Half_Width_Element + 1)//&
                             " x "//fw_to_str(2 * Search_Half_Width_Line + 1))




      ! Allocate memory for the target box data structure
      IF(.NOT. Box_Data%Create(Box_Size)) RETURN



      ! Allocate memory for the forecast profiles data structure
      IF(.NOT. Fcst_Prof%Create(Press_Levels)) RETURN

      ! Allocate memory for the arrays holding the search image data
      ! (previous time and later time)
      ALLOCATE(Search_BrtTemp_Values(Search_Size, Search_Size))
      ALLOCATE(Search_BrtTemp_Values2(Search_Size, Search_Size))
      IF (SIZE(Search_BrtTemp_Values) .LE. Total_Points) THEN
            CALL fw_log_error(FUNC, 'Search box must be larger than target scene')
         RETURN
      ENDIF

      IF(.NOT. DBSCAN_Out%Create(Box_Size)) RETURN

      ! aab Tandem (dbscan)
      !ALLOCATE(SetOfPoints((Box_Size-4)**2, DBSCAN_Output_Variables))
      ! Double size of first dimension of SetOfPoints array for combined sample testing
      comb_size = ((Box_Size-4)**2) * 2
      ALLOCATE(SetOfPoints(comb_size, DBSCAN_Output_Variables))
      
      SetOfPoints = MISSING_VALUE_REAL4

      IF (.NOT. ALLOCATED(SSD_Matrix)) ALLOCATE(SSD_Matrix(Lag_Array_Size**2))
      SSD_Matrix = MISSING_VALUE_REAL4

      ! --------------------------------------------------------------------------
      ! Generate tables of positions to conduct a "spiral" search beginning at the
      ! center of the lag matrix (which corresponds to the forecast position) and
      ! spiraling outward. This is a more efficient search for the SSD minimum.
      ! --------------------------------------------------------------------------
      ALLOCATE(Lag_Table(Lag_Array_Size**2, 4))
      ALLOCATE(Lag_Table2(Lag_Array_Size**2, 4))

      Diff_In_Size = 0
      CALL Generate_Spiral_Table(Search_Size, Lag_Array_Size, Diff_In_Size, Lag_Table)

      !the difference between the target box size and the size of the nested tracking box
      !(5 pixels)
      Diff_In_Size = Box_Size - 5
      CALL Generate_Spiral_Table(Search_Size, Lag_Array_Size, Diff_In_Size, Lag_Table2)

      !---------------------------------------------------------------------------
      ! Call GEOCAT routine to compute 3x3 mean values for entire buffer.
      ! Although only computing the gradient for the middle segment, we will
      ! need the extra data when the target box is re-centered on the max
      ! gradient.
      !---------------------------------------------------------------------------
      CALL Compute_Spatial_Uniformity(1, 1, input%Space%d, input%Radiance%d, &
         Unif%mean, Unif%max, Unif%min, Unif%uni)



      ! Begin processing segment data
      ! the segment loop
      !More targets can be found if it is just BUFFER_SEGMENTS*NOMINAL_BOX_SIZE
      targetingLines = (BUFFER_SEGMENTS - 1)*NOMINAL_BOX_SIZE + Box_Size
      !we want to cut off the beginning if its not a multiple of NOMINAL_BOX_SIZE
      cutoff = NOMINAL_BOX_SIZE - MOD(ctx_line%position%start_pos - 1, NOMINAL_BOX_SIZE)
      IF(cutoff == NOMINAL_BOX_SIZE) cutoff = 0
      targetSceneStartLine = 1 + cutoff
      targetSceneEndLine = targetSceneStartLine + targetingLines - 1
      IF(targetSceneEndLine > lines) THEN
         CALL fw_log_error(FUNC, "Framework Segmentation is insufficient for targeting")
      ENDIF




      !Initialize the scan line times with the nominal image time.
      !Some satellites just use the image time as the scan line time.
      EpochScanTimes(FIRST) = EpochImageTimes(FIRST)
      EpochScanTimes(MIDDLE) = EpochImageTimes(MIDDLE)
      EpochScanTimes(LAST) = EpochImageTimes(LAST)



      ! pixel offset for gradient calculation loop
      IF (Box_Size .GE. NOMINAL_BOX_SIZE) THEN
         Gradient_Offset = (Box_Size - NOMINAL_BOX_SIZE) / 2
      ELSE
         Gradient_Offset = 0
      ENDIF
      Gradient_X = 0.0
      Gradient_Y = 0.0

      ! The segment loop (line loop)
      DO WHILE(targetSceneEndLine <= lines)

         ! Initialize target box element bounds
         Start_Element = 1 + PIXEL_OFFSET
         !---------------------------------------------------------------------------
         ! Beginning of main target selection loop. The middle portion of
         ! the buffer is essentially divided into small sub-regions, the size
         ! of which is controlled by the Box_Size variable. At each pixel
         ! of each box the brightness temperature gradient is computed using a
         ! 4-pt centered difference convolution kernel. The box is then
         ! recentered on the maximum gradient location. Once this is done a
         ! variety of tests are performed to determine if the target is a
         ! suitable tracer. The loop is terminated when the edge of the data
         ! is reached.
         !---------------------------------------------------------------------------

         ! The main loop (element loop)
         DO

            !-------------------------------------------------------------------------
            ! Initialize data structures and target box variables
            !-------------------------------------------------------------------------
            CALL Output_Initialize(Output)
            CALL DBSCAN_Output_Initialize(DBSCAN_Out)
            CALL Box_Data_Initialize(Box_Data)

            Output%Channel = Channel
            Gradient_Max = 0.0
            Max_Location(1) = 0
            Max_Location(2) = 0

            QC_Flag = sym%SUCCESS
            Lat_Target = MISSING_VALUE_REAL4
            Lon_Target = MISSING_VALUE_REAL4
            Lat_Match = MISSING_VALUE_REAL4
            Lon_Match = MISSING_VALUE_REAL4
            Lat_Match2 = MISSING_VALUE_REAL4
            Lon_Match2 = MISSING_VALUE_REAL4
            Lat_Match3 = MISSING_VALUE_REAL4
            Lon_Match3 = MISSING_VALUE_REAL4
            Lat_Match4 = MISSING_VALUE_REAL4
            Lon_Match4 = MISSING_VALUE_REAL4
            U_Avg = MISSING_VALUE_REAL4
            V_Avg = MISSING_VALUE_REAL4
            U_Component = MISSING_VALUE_REAL4
            V_Component = MISSING_VALUE_REAL4
            U_Component2 = MISSING_VALUE_REAL4
            V_Component2 = MISSING_VALUE_REAL4
            Median_Press2 = MISSING_VALUE_REAL4
            Median_BrtTemp = MISSING_VALUE_REAL4
            X_NWP_Target = MISSING_VALUE_INT4
            Y_NWP_Target = MISSING_VALUE_INT4
            Delta_X_Fcst = MISSING_VALUE_REAL4
            Delta_Y_Fcst = MISSING_VALUE_REAL4
            Median_CTP_Sample1 = MISSING_VALUE_REAL4
            Median_CTP_Sample2 = MISSING_VALUE_REAL4
            Combined_Median = MISSING_VALUE_REAL4
            Combined_Median_Hgt = MISSING_VALUE_REAL4
            Output%Flag_5x5 = Nested_Tracking_Flag
            SF_Test = sym%FAILURE
            SF_Test2 = sym%FAILURE


            !-------------------------------------------------------------------------
            ! Determine the end element for the current target box. Exit loop
            ! if beyond the edge of the image.
            !-------------------------------------------------------------------------
            End_Element = Start_Element + Box_Size - 1

            !-------------------------------------------------------------------------
            ! Loop over every pixel in target scene and compute gradient.
            !-------------------------------------------------------------------------

            gradientTrackingCenterLine = (targetSceneEndLine - targetSceneStartLine) / 2 + targetSceneStartLine
            gradientTrackingStartLine = gradientTrackingCenterLine - Target_Half_Width + Gradient_Offset
            gradientTrackingEndLine = gradientTrackingStartLine + (Box_Size - Gradient_Offset*2) - 1
            gradientTrackingStartElem = Start_Element + Gradient_Offset
            gradientTrackingEndElem = End_Element - Gradient_Offset
            gradientTrackingCenterElem = &
		(gradientTrackingEndElem - gradientTrackingStartElem) / 2 + gradientTrackingStartElem


            IF (gradientTrackingEndElem .GT. (Elems - PIXEL_OFFSET)) EXIT !This one is needed to prevent a possible segfault.
            IF (End_Element .GT. (Elems - PIXEL_OFFSET)) EXIT  !FIXME:  put check before convolve like the line check.

            !if the tracking starts after the ROI then a later segment will pick it up.
            IF( gradientTrackingStartElem < elemROI%start_pos .OR. gradientTrackingStartElem > elemROI%end_pos .OR. &
                gradientTrackingStartLine < lineROI%start_pos .OR. gradientTrackingStartLine > lineROI%end_pos ) THEN
                !increment as if successful. a bit faster to just exit the element loop in the event of a line boundary issue.
                CALL IncrementElement(sym%SUCCESS, Start_Element)
                CYCLE
            ENDIF


            DO gradientLine = gradientTrackingStartLine, gradientTrackingEndLine
               DO gradientElem = gradientTrackingStartElem, gradientTrackingEndElem

                  ! Initialize gradient magnitude to zero at each pixel.
                  Gradient_Magnitude = 0.0

                  ! Only proceed if pixel is non-space look.
                  IF (Space_Mask(gradientElem,gradientLine) == SYM%NO_SPACE) THEN

                     !-----------------------------------------------------------------
                     ! Calculate the IR brightness temperature gradient.
                     ! Using buffer data will allow us to compute a 4-pt centered
                     ! difference for every pixel in the target box.
                     !-----------------------------------------------------------------

                     IF ( (gradientLine + PIXEL_OFFSET) > lines ) CYCLE !alternatively alter the convolve
                     Gradient_X = Convolve_X(Kernel,gradientElem,gradientLine, input%BrtTemp%d, INT(PIXEL_OFFSET,LONG))

                     Gradient_Y = Convolve_Y(Kernel,gradientElem,gradientLine, input%BrtTemp%d, INT(PIXEL_OFFSET,LONG))

                     Gradient_Magnitude = SQRT(Gradient_X**2 + Gradient_Y**2)

                     IF (Gradient_Max < Gradient_Magnitude) THEN
                        Gradient_Max = Gradient_Magnitude
                        Max_Location(1) = gradientElem
                        Max_Location(2) = gradientLine
                     ENDIF

                  ENDIF

               END DO
            END DO
            ! If gradient max is zero, go to next target.
            IF (Gradient_Max .EQ. 0.0) THEN

               !We already checked if the start of the tracking is within the ROI so we can store this as a failure.
               QC_Flag = ZERO_GRADIENT_FAILURE
               !Update_Wind_Data is here in case we want to start storing ZERO_GRADIENT_FAILURE failures.
               !right now it does not even enter the missing value lat/lon if block inside Update_Wind_data.
               CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,& 
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
               CALL IncrementElement(QC_Flag, Start_Element)
               CYCLE
            ENDIF

            ! ------------------------------------------------------------------------
            ! Center the target on the maximum gradiant
            ! ------------------------------------------------------------------------
            Target_Center_Elem = Max_Location(1)
            Target_Center_Line = Max_Location(2)


            ! Convert to the native coordinates needed for output and pixcoord2geocoord (e.g. ABI is 0 indexed.)
            Target_Elem_native = REAL(ImageStartElem_native + Target_Center_Elem - 1)
            Target_Line_native = REAL(ImageStartLine_native + Target_Center_Line - 1)

            ! Recompute boundaries. Do not exceed image limits.
            Box_Element_Start = MAX(1, Target_Center_Elem - Target_Half_Width)
            Box_Element_End = MIN(Elems, Target_Center_Elem + Target_Half_Width)
            Box_Line_Start = MAX(1, Target_Center_Line - Target_Half_Width)
            Box_Line_End = MIN(Lines, Target_Center_Line + Target_Half_Width)



            ! Call navigation to get the earth location of target center pixel.
            IF (TRIM(Nav%NavType) .EQ. 'PS' ) THEN

               CALL pixcoord2geocoord_ps(Nav, Target_Elem_native, Target_Line_native, Lat_Target, Lon_Target)

               Lon_Target = -Lon_Target
               Output%Lon_Target = Lon_Target

            ELSE

               SELECT CASE (Sensor_Series)

                  CASE (SERIES_MSG_SEVIRI)

                     ! Convert to EUMETSAT coord
                     ! 3713 is the number of lines  (or elements) in a SEVIRI full disk image plus 1.
                     !Target_Elem_native = REAL(3713 - (ImageStartElem_native + Target_Center_Elem))
                     !Target_Line_native = REAL(3713 - (Center_Of_Buffer + Lines_From_Center))

                     ! compute earth coordinates of target center
                     CALL pixcoord2geocoord_dp(Nav, Target_Elem_native, Target_Line_native, Latitude, Longitude)

                     Lat_Target = REAL(Latitude)
                     Lon_Target = REAL(Longitude)

                     Output%Lon_Target = Lon_Target

                  !      CASE (SERIES_GOES_N_IMG)
                  !
                  !        CALL pixcoord2geocoord_gvar(Target_Elem_native, Target_Line_native, &
                  !                            sat_xstride, Lat_Target, Lon_Target)
                  !
                  !        Output%Lon_Target = Lon_Target

                  !        EpochScanTimes(FIRST) = input%Line_Time_Image0(Channel,Max_Location(2))
                  !        EpochScanTimes(MIDDLE) = input%Line_Time_Image1(Channel,Max_Location(2))
                  !        EpochScanTimes(LAST) = input%Line_Time_Image2(Channel,Max_Location(2))
                  !        Delta_Time_minus = seconds_to_hours(EpochScanTimes(MIDDLE) - EpochScanTimes(FIRST))
                  !        Delta_Time_plus  = seconds_to_hours(EpochScanTimes(LAST) - EpochScanTimes(MIDDLE))

                  CASE (SERIES_GOESR_ABI, SERIES_HIMAWARI_AHI)

                     CALL pixcoord2geocoord_abi_real(Nav, Target_Elem_native, Target_Line_native, &
                        Latitude, Longitude)


                     Lat_Target = REAL(Latitude)
                     Lon_Target = REAL(Longitude)

                     Output%Lon_Target = Lon_Target

                     ! Because JMA sets their longitudes from 0 to 360, and
                     ! we want 180 to -180, we need to switch here for longitudes
                     ! that are greater than 180.

                     IF (Lon_Target > 180.0) Lon_Target = Lon_Target - 360.0


               END SELECT
            ENDIF

            ! Compute ratio of 1-pixel element displacement over 1-pixel line
            ! displacement. This ratio will be passed to DBSCAN and used when
            ! computing distance in pixel space.

            CALL Pixel_Factor(Nav, Target_Elem_native, Target_Line_native, Factor)

            Output%Lat_Target = Lat_Target

            ! add image coordinates of target center - wcb 12/2/15
            Output%Target_Element = Target_Elem_native
            Output%Target_Line = Target_Line_native

            ! Check the Land Mask and determine if the target is over land or water.
            ! If it's over land, set output flag to 1.
            ! If it's over water, set output flag to 0.

            IF (input%Land%d(Max_Location(1),Max_Location(2)) == sym%Land .OR. &
               input%Land%d(Max_Location(1),Max_Location(2)) == sym%COASTLINE) THEN

               Output%Land_Flag = LAND_BINARY_MASK

            ELSE

               Output%Land_Flag = WATER_BINARY_MASK

            ENDIF

            IF (TRIM(Nav%NavType) .NE. 'PS' ) THEN

               ! Compute satellite zenith angle (geostationary processing only)
               CALL Compute_Zenith_Angle(SatLon, SatLat, Lon_Target, &
                  Lat_Target, Output%Sat_Zenith_Angle)

               ! WCB
               ! add zenith angle cut off
               IF (Output%Sat_Zenith_Angle .GT. ZENITH_ANGLE_CUTOFF) THEN
                  QC_Flag = EARTH_EDGE_FAILURE
                  CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                    EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,& 
                                    Box_Data) ! aab added Box_Data for CloudyPixels output
                  CALL IncrementElement(QC_Flag, Start_Element)
                  CYCLE
               ENDIF
            ENDIF

            ! Fill target box with data from buffer.
            CALL Fill_Box_Data(Box_Data, Box_Size, Box_Element_Start, Box_Element_End, &
               Box_Line_Start, Box_Line_End, input, unif%mean, unif%uni, QC_Flag)

            IF (QC_Flag .NE. sym%SUCCESS) THEN

               CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
               CALL IncrementElement(QC_Flag, Start_Element)
               CYCLE

            ENDIF

            !-------------------------------------------------------------------------
            ! Apply QC to target box. Keep track of failures.
            !-------------------------------------------------------------------------

            CALL Target_QC(Nav%NavType, Box_Data, QC_Flag)

            IF (QC_Flag .NE. sym%SUCCESS) THEN

               CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
               CALL IncrementElement(QC_Flag, Start_Element)
               CYCLE

            ENDIF

            !-------------------------------------------------------------------------
            ! Beginning of height assignment section. First step is to construct
            ! a 1-D histogram of cloud top temperature values and find the temperature
            ! threshold of the coldest 25 percent. The next step is to loop through
            ! the pixels and save the Cld_Top_Press values of those pixels colder than
            ! the threshold value. The final step is to compute the median pressure
            ! of the cold sample.
            !-------------------------------------------------------------------------

            IF (QC_Flag .EQ. sym%SUCCESS .AND. Gradient_Max > 0.0) THEN

               ! Make histogram of temperature data and return cold sample

               CALL Make_Histogram_Temp(Nav%NavType, Box_Data, Total_Points, Output%Point_Index, &
                  Output%Variance_Press, LL_Inver_Flag)

               ! Copy forecast wind and temperature profiles

               X_NWP_Target = input%X_NWP%d(Max_Location(1), Max_Location(2))
               Y_NWP_Target = input%Y_NWP%d(Max_Location(1), Max_Location(2))
               Output%X_NWP_Target = X_NWP_Target
               Output%Y_NWP_Target = Y_NWP_Target

               ! Set Inversion Flag for output file.

               IF (LL_Inver_Flag .EQ. sym%YES) THEN

                  Output%Inversion_Flag = sym%YES

               ELSE

                  Output%Inversion_Flag = sym%NO

               ENDIF

               ! copy forecast profiles at max gradient location
               CALL Forecast_Profiles_Set(Fcst_Prof, forecastProfiles,Press_Levels, X_NWP_Target, Y_NWP_Target)

               ! Find the dominant cloud phase and cloud type of the target scene.  This
               ! will simply be stored as a diagnostic output variable.

               CALL Dominant_Cloud_Phase(Box_Data, Output%Cloud_Phase)

               CALL Dominant_Cloud_Type(Box_Data, Output%Cloud_Type)

               ! ----------------------------------------------------------------------
               ! Sort pressures from target scene into ascending order and find median.
               ! We need the forecast wind at this pressure level to center the search
               ! box further below. Fail target if height assignment fails. This can
               ! happen if the 1-DVAR cloud height algorithm fails to produce a height.
               ! ----------------------------------------------------------------------

               IF (Output%Point_Index .GT. 0) THEN

                  CALL Assign_Height(Press_Levels, Output, Box_Data, Fcst_Prof, QC_Flag)

                  IF (QC_Flag .NE. sym%SUCCESS) THEN

                     CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
                     CALL IncrementElement(QC_Flag, Start_Element)
                     CYCLE

                  ENDIF

               ENDIF ! Number of points check

               ! Check the AMV height assignment. Skip to next target if a failure
               ! is encountered. The primary role of this subroutine is to apply
               ! channel-specific pressure thresholds.

               CALL Check_Height_Assignment(Output%Point_Index, Output%Median_Press, &
                  Fcst_Prof%Pressure, QC_Flag)

               IF (QC_Flag .NE. sym%SUCCESS) THEN

                  CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
                  CALL IncrementElement(QC_Flag, Start_Element)
                  CYCLE

               ENDIF

               ! ----------------------------------------------------------------------
               ! At this point the target has passed all quality control and is
               ! suitable for tracking.
               ! ----------------------------------------------------------------------

               Good_Targets = Good_Targets + 1

               Box_Data%Target_ID = Target_Number

               ! Interpolate forecast to AMV height.

               CALL Interpolate_To_AMV_Press(Output, Press_Levels, Fcst_Prof)

               ! Compute speed and direction of forecast at original pressure
               ! assignment. The pressure assignment will change if nested
               ! tracking is being used, so save the original value.

               CALL UV2SPD(Output%Spd_Fcst_Original_Press, &
                  Output%Dir_Fcst_Original_Press, &
                  Output%U_Fcst, Output%V_Fcst)

               !-----------------------------------------------------------------------
               ! Begin tracking portion of AMV algorithm. The forecast wind is used as
               ! a "guide" to position the search region in the subsequent image. To
               ! do this we need to compute the displacement predicted by the model.
               !-----------------------------------------------------------------------

               ! Retrieve forecast position of feature in previous image (negative
               ! time step)

               CALL Get_Fcst_Displacement(Nav,Nav%NavType, Lat_Target, Lon_Target, -Delta_Time_minus, &
                  Output%U_Fcst, Output%V_Fcst, Sensor_Series, Target_Elem_native, &
                  Target_Line_native, Delta_X_Fcst, Delta_Y_Fcst)

               !-----------------------------------------------------------------------
               ! Use predicted displacement to center search box and fill with data
               ! from buffer.
               !
               ! This routine starts with the target position (max gradient location)
               ! in buffer coordinates and adds the predicted line and element
               ! displacement to determine where to center the search box in buffer
               ! coordinates. It then fills the search box with data from the buffer.
               !-----------------------------------------------------------------------

               CALL Fill_Search_Box(Elems, Max_Location(1), Max_Location(2), Delta_X_Fcst, &
                  Delta_Y_Fcst, Search_Half_Width_Line, Search_Half_Width_Element, &
                  Lines, input%Search%d, Search_BrtTemp_Values, QC_Flag)
               ! superficially restrict the search boundaries to the "buffer only"
               !CALL Fill_Search_Box(Elems, Max_Location(1), Max_Location(2)-targetSceneStartLine + 1, Delta_X_Fcst, &
               !   Delta_Y_Fcst, Search_Half_Width_Line, Search_Half_Width_Element, &
               !   targetingLines, input%Search%d(:,targetSceneStartLine:targetSceneEndLine), Search_BrtTemp_Values, QC_Flag)


               IF (QC_Flag .NE. sym%SUCCESS) THEN

                  CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
                  CALL IncrementElement(QC_Flag, Start_Element)
                  CYCLE

               ENDIF

               ! check to see if we are tracking with the traditional method

               IF (Nested_Tracking_Flag .EQ. sym%NO) THEN

                  ! Find matching scene.

                  CALL Compute_Correlation(Box_Data, Search_BrtTemp_Values, &
                     Lag_Table, Delta_X_Fcst, Delta_Y_Fcst, &
                     Line_Disp, Element_Disp, &
                     Least_Square_Error, Target_Scene_Mean, &
                     Match_Scene_Mean, Target_Scene_StdDev, &
                     Match_Scene_StdDev, Output%Corr_Coeff, &
                     Status_Flag1, SSD_Matrix)

                  SSD_Matrix = MISSING_VALUE_REAL4

                  ! Check success of tracking

                  IF (Status_Flag1 .NE. sym%SUCCESS) THEN

                     QC_Flag = Status_Flag1
                     CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
                     CALL IncrementElement(QC_Flag, Start_Element)
                     CYCLE

                  ENDIF

                  ! ----------------------------------------------------------------------
                  ! Check for valid correlation value. There is no point in continuing
                  ! if the value for the 1st vector is bad.
                  ! ----------------------------------------------------------------------

                  IF (Output%Corr_Coeff .LT. CORR_MIN .OR. &
                     Output%Corr_Coeff .GT. 1.0) THEN

                     QC_Flag = CORRELATION_FAILURE
                     CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
                     CALL IncrementElement(QC_Flag, Start_Element)
                     CYCLE

                  ENDIF

               ELSE IF (Nested_Tracking_Flag .EQ. sym%YES) THEN

                  ! ----------------------------------------------------------------------
                  ! Attempt nested 5x5 tracking to improve estimate
                  ! ----------------------------------------------------------------------

                  ! pass in clear sky flag - 1/25/16

                  CALL Nested_Tracking(Nav%NavType, REVERSE, CSWV_Flag, Box_Data, Search_BrtTemp_Values,Delta_X_Fcst, &
                     Delta_Y_Fcst, Channel, Lag_Table2, LD_Test, ED_Test, TandemTriplet, & !<-- aab Tandem mod
                     Least_Square_Error, Factor, Target_Scene_Mean, &
                     Match_Scene_Mean, Target_Scene_StdDev, Match_Scene_StdDev, &
                     CC_Test, SF_Test, DBSCAN_Out, SetOfPoints)

                  Output%Corr_Coeff = CC_Test
                  ! aab Tandem (dbscan)
                  ! combined sample test - keep data from reverse
                  !SetOfPoints = MISSING_VALUE_REAL4

                  ! Check success of tracking
                  IF (SF_Test .NE. sym%SUCCESS) THEN

                     QC_Flag = SF_Test
                     CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
                     CALL IncrementElement(QC_Flag, Start_Element)
                     CYCLE

                  ENDIF

                  ! do not use CTP for CSWV - 1/25/16
                  IF (CSWV_Flag .EQ. sym%NO) THEN

                     ! --------------------------------------------------------------------
                     ! Need to find median pressure associated with the cluster of pixels
                     ! returned from the nested tracking process. We need this value
                     ! because we compare it to the value derived from the second sample
                     ! further below. A limit of 100 mb is placed on the difference.
                     ! --------------------------------------------------------------------

                     ! aab Tandem (dbscan)
                     ! DBSCAN is now not called until after the forward time step is processed, so remove this code
                     !CALL Sort_Shell_NP(DBSCAN_Out%Number_CTP_Sample1, &
                     !   DBSCAN_Out%CTP_5x5_Sample1, &
                     !   Median_CTP_Sample1)

                  ENDIF  ! CSWV check - 1/25/16


               ENDIF  ! Nested tracking check (first vector)

               ! ----------------------------------------------------------------------
               ! Beginning of logic to track feature forward in time. This logic
               ! mirrors what is done above for the reverse vector.
               ! ----------------------------------------------------------------------

               ! Retrieve forecast position of feature in next image (+Delta_Time)

               CALL Get_Fcst_Displacement(Nav,Nav%NavType, Lat_Target, Lon_Target, Delta_Time_plus, &
                  Output%U_Fcst, Output%V_Fcst, Sensor_Series, Target_Elem_native, &
                  Target_Line_native, Delta_X_Fcst, Delta_Y_Fcst)

               !-----------------------------------------------------------------------
               ! Fill search box with buffer data
               !-----------------------------------------------------------------------
               CALL Fill_Search_Box(Elems, Max_Location(1), Max_Location(2), Delta_X_Fcst, &
                  Delta_Y_Fcst, Search_Half_Width_Line, Search_Half_Width_Element, &
                  Lines, input%Search2%d, Search_BrtTemp_Values2, QC_Flag)
               ! superficially restrict the search boundaries to the "buffer only"
               !CALL Fill_Search_Box(Elems, Max_Location(1), Max_Location(2)-targetSceneStartLine+1, Delta_X_Fcst, &
               !   Delta_Y_Fcst, Search_Half_Width_Line, Search_Half_Width_Element, &
               !   targetingLines, input%Search2%d(:,targetSceneStartLine:targetSceneEndLine), Search_BrtTemp_Values2, QC_Flag)

               ! Check if search box was filled properly
               IF (QC_Flag .NE. sym%SUCCESS) THEN

                  CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
                  CALL IncrementElement(QC_Flag, Start_Element)
                  CYCLE

               ENDIF

               IF (Nested_Tracking_Flag .EQ. sym%NO) THEN

                  ! Compute correlation for second vector (the forward vector)
                  CALL Compute_Correlation(Box_Data, Search_BrtTemp_Values2, &
                     Lag_Table, Delta_X_Fcst, Delta_Y_Fcst, &
                     Line_Disp2, Element_Disp2, &
                     Least_Square_Error, Target_Scene_Mean, &
                     Match_Scene_Mean, Target_Scene_StdDev, &
                     Match_Scene_StdDev, Output%Corr_Coeff2, &
                     Status_Flag2, SSD_Matrix)

                  ! Check success of tracking
                  IF (Status_Flag2 .NE. sym%SUCCESS) THEN

                     QC_Flag = Status_Flag2
                     CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
                     CALL IncrementElement(QC_Flag, Start_Element)
                     CYCLE

                  ENDIF

                  ! Check for valid correlation value
                  IF (Output%Corr_Coeff2 .LT. CORR_MIN .OR. Output%Corr_Coeff2 .GT. 1.0) THEN

                     QC_Flag = CORRELATION_FAILURE
                     CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
                     CALL IncrementElement(QC_Flag, Start_Element)
                     CYCLE

                  ENDIF

                  ! ----------------------------------------------------------------------
                  ! Compute vector end points for backward and forward vectors
                  ! ----------------------------------------------------------------------

                  CALL Compute_End_Points(Nav, Target_Elem_native, Element_Disp, &
                     Target_Line_native, Line_Disp,  &
                     Lat_Match, Lon_Match)

                  CALL Compute_End_Points(Nav, Target_Elem_native, Element_Disp2, &
                     Target_Line_native, Line_Disp2, &
                     Lat_Match2, Lon_Match2)

                  ! ----------------------------------------------------------------------
                  ! Compute u- and v- wind components. The backward vector is computed
                  ! first and then the forward vector is computed.
                  ! ----------------------------------------------------------------------

                  ! For GOES-NOP save scan time of match locations and update time
                  ! interval

                  !IF (Sensor_Series == SERIES_GOES_N_IMG) THEN

                    !Store in epoch 1970, not hour in day.
                    !EpochScanTimes(FIRST) = input%Line_Time_Image1(Channel, (Max_Location(2)+INT(Line_Disp)))
                    !EpochScanTimes(LAST) = input%Line_Time_Image2(Channel, (Max_Location(2)+INT(Line_Disp2)))

                    !Science:CALL Check_Scan_Times(GOESScanTimeFirst, GOESScanTimeMiddle, GOESScanTimeLast, &
                    !Science:                                      Delta_Time_minus, Delta_Time_plus)
                    !Delta_Time_minus = seconds_to_hours(EpochScanTimes(MIDDLE) - EpochScanTimes(FIRST))
                    !Delta_Time_plus  = seconds_to_hours(EpochScanTimes(LAST) - EpochScanTimes(MIDDLE))
                  !ENDIF

                  CALL Compute_UV(Nav%NavType, Lat_Target, Lon_Target, Lat_Match, Lon_Match, &
                     -Delta_Time_minus, U_Component, V_Component)

                  ! For the reverse vector change sign to account for negative time
                  ! interval. Note, however, that the sign is changed only for the
                  ! v-component. This is because decreasing longitude values are
                  ! associated with positve u-component values (McIDAS convention).

                  IF (TRIM(Nav%NavType) .EQ. 'PS' ) V_Component = -V_Component

                  CALL Compute_UV(Nav%NavType, Lat_Target, Lon_Target, Lat_Match2, Lon_Match2, &
                     Delta_Time_plus, U_Component2, V_Component2)
                  IF (TRIM(Nav%NavType) .EQ. 'PS' ) U_Component2 = -U_Component2

                  ! save data to output structure
                  Output%Lat_Match = Lat_Match
                  Output%Lon_Match = Lon_Match
                  Output%U_Component = U_Component
                  Output%V_Component = V_Component
                  Output%Lat_Match2 = Lat_Match2
                  Output%Lon_Match2 = Lon_Match2
                  Output%U_Component2 = U_Component2
                  Output%V_Component2 = V_Component2


               ! Attempt nested 5x5 tracking to improve estimate
               ELSE IF (Nested_Tracking_Flag .EQ. sym%YES) THEN

                  ! pass in clear sky flag - 1/25/16

                  CALL Nested_Tracking(Nav%NavType, FORWARD, CSWV_Flag, Box_Data,Search_BrtTemp_Values2,Delta_X_Fcst, &
                     Delta_Y_Fcst, Channel, Lag_Table2, LD_Test2, ED_Test2, TandemTriplet, & !<--- aab Tandem mod
                     Least_Square_Error, Factor, Target_Scene_Mean, &
                     Match_Scene_Mean, Target_Scene_StdDev, Match_Scene_StdDev, &
                     CC_Test2, SF_Test2, DBSCAN_Out, SetOfPoints)

                  ! aab Tandem (dbscan)
                  ! new code to compute average displacements from DBSCAN output structure
                  Sum_DX1 = SUM(DBSCAN_Out%Delta_X_Reverse(1:DBSCAN_Out%Number_CTP_Sample1))
                  Sum_DY1 = SUM(DBSCAN_Out%Delta_Y_Reverse(1:DBSCAN_Out%Number_CTP_Sample1))
                  Avg_DX1 = Sum_DX1/DBSCAN_Out%Number_CTP_Sample1
                  Avg_DY1 = Sum_DY1/DBSCAN_Out%Number_CTP_Sample1
                  ED_Test = -Avg_DX1
                  LD_Test = -Avg_DY1
                  Sum_DX2 = SUM(DBSCAN_Out%Delta_X_Forward(1:DBSCAN_Out%Number_CTP_Sample2))
                  Sum_DY2 = SUM(DBSCAN_Out%Delta_Y_Forward(1:DBSCAN_Out%Number_CTP_Sample2))
                  Avg_DX2 = Sum_DX2/DBSCAN_Out%Number_CTP_Sample2
                  Avg_DY2 = Sum_DY2/DBSCAN_Out%Number_CTP_Sample2
                  ED_Test2 = Avg_DX2
                  LD_Test2 = Avg_DY2
                  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

                  Output%Corr_Coeff2 = CC_Test2

                  ! Check success of tracking
                  IF (SF_Test2 .NE. sym%SUCCESS) THEN

                     QC_Flag = SF_Test2
                     CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
                     CALL IncrementElement(QC_Flag, Start_Element)
                     CYCLE

                  ENDIF

                  ! do not use CTP for CSWV - 1/25/16
                  IF (CSWV_Flag .EQ. sym%NO) THEN

                     ! aab Tandem (dbscan) - comment out vvvvvvvvvvvvvvvv
                     !CALL Sort_Shell_NP(DBSCAN_Out%Number_CTP_Sample2, &
                     !   DBSCAN_Out%CTP_5x5_Sample2, &
                     !   Median_CTP_Sample2)

                     ! Check consistency of median CTP samples, fail if difference is 100 mb or greater.
                     !IF (ABS(Median_CTP_Sample2 - Median_CTP_Sample1) .GE. &
                     !   PRESSURE_CONSISTENCY_THRESHOLD) THEN

                     !   QC_Flag = CTP_CONSISTENCY_FAILURE
                     !   CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                     !                EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                     !                Box_Data) ! aab added Box_Data for CloudyPixels output
                     !   CALL IncrementElement(QC_Flag, Start_Element)
                     !   CYCLE

                     !ENDIF
                     ! aab Tandem (dbscan) - comment out ^^^^^^^^^^^^^^^^^^


                     ! Find the median pressure associated with the combined sample
                     ! (sample 1 is from the reverse vector while sample 2 is from
                     ! the forward vector).
                     ! aab Tandem (dbscan) vvvvvvvvvvvvvvvvvvvvv
                     !CALL Find_Combined_Median(DBSCAN_Out, Fcst_Prof, &
                     !                          Output, Combined_Median, Combined_Median_Hgt, QC_Flag) !outputs
                     if (DBSCAN_Out%Number_CTP_Sample1 > 0 .AND. DBSCAN_Out%Number_CTP_Sample2 > 0) then
                       CALL Find_Combined_Median(DBSCAN_Out, Fcst_Prof, &
                                                 Output, Combined_Median, Combined_Median_Hgt, QC_Flag) !outputs
                     else
                       QC_Flag = 17
                     endif
                     ! aab Tandem (dbscan) ^^^^^^^^^^^^^^^^^^^^^^

                     IF (QC_Flag .NE. sym%SUCCESS) THEN

                        CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
                        CALL IncrementElement(QC_Flag, Start_Element)
                        CYCLE

                     ENDIF

                  ENDIF  ! CSWV check - 1/25/16

                  ! Set Inversion Flag for output file.
                  IF (LL_Inver_Flag .EQ. sym%YES) THEN

                     Output%Inversion_Flag = sym%YES

                  ELSE

                     Output%Inversion_Flag = sym%NO

                  ENDIF

                  ! Add absolute displacement to location of target box center
                  ! to get endpoint of motion vector, then return earth location
                  ! of the endpoint.

                  CALL Compute_End_Points(Nav, Target_Elem_native, ED_Test, Target_Line_native, &
                     LD_Test, Lat_Match3, Lon_Match3)

                  CALL Compute_End_Points(Nav, Target_Elem_native, ED_Test2, Target_Line_native, &
                     LD_Test2,  Lat_Match4, Lon_Match4)

                  ! For GOES-NOP save scan time of match locations and update time
                  ! interval
                  !IF (Sensor_Series == SERIES_GOES_N_IMG) THEN
                  !
                  !  EpochScanTimes(FIRST) = input%Line_Time_Image1(Channel, (Max_Location(2)+INT(LD_Test)))
                  !  EpochScanTimes(LAST) = input%Line_Time_Image2(Channel, (Max_Location(2)+INT(LD_Test2)))
                  !
                  !  !Science:CALL Check_Scan_Times(GOESScanTimeFirst, GOESScanTimeMiddle, GOESScanTimeLast, &
                  !  !Science:                                      Delta_Time_minus, Delta_Time_plus)
                  !  Delta_Time_minus = seconds_to_hours(EpochScanTimes(MIDDLE) - EpochScanTimes(FIRST))
                  !  Delta_Time_plus  = seconds_to_hours(EpochScanTimes(LAST) - EpochScanTimes(MIDDLE))
                  !ENDIF

                  ! Compute the U- and V- wind components for the nested tracking
                  ! estimate.

                  CALL Compute_UV(Nav%NavType, Lat_Target, Lon_Target, Lat_Match3, Lon_Match3, &
                     -Delta_Time_minus, U_Component, V_Component)

                  IF (TRIM(Nav%NavType) .EQ. 'PS')  V_Component = -V_Component

                  CALL Compute_UV(Nav%NavType, Lat_Target, Lon_Target, Lat_Match4, Lon_Match4, &
                     Delta_Time_plus, U_Component2, V_Component2)

                  IF (TRIM(Nav%NavType) .EQ. 'PS') U_Component2 = -U_Component2

                  Output%Lat_Match = Lat_Match3
                  Output%Lon_Match = Lon_Match3
                  Output%Lat_Match2 = Lat_Match4
                  Output%Lon_Match2 = Lon_Match4
                  Output%U_Component = U_Component
                  Output%V_Component = V_Component
                  Output%U_Component2 = U_Component2
                  Output%V_Component2 = V_Component2

               ENDIF ! Check for 5x5 tracking

               ! ----------------------------------------------------------------------
               ! Average the u- and v- components to obtain the average vector.
               ! ----------------------------------------------------------------------

               IF (Nested_Tracking_Flag .EQ. sym%NO) THEN

                  U_Avg = (U_Component + U_Component2) / 2.0
                  V_Avg = (V_Component + V_Component2) / 2.0
                  Output%U_Avg = U_Avg
                  Output%V_Avg = V_Avg

                  ! Call routine to check accelerations and apply gross error checks.
                  !
                  CALL Gross_Error_Checks(Nav%NavType, U_Component, U_Component2, V_Component, &
                  ! WCB
                  !   V_Component2, Output%U_Fcst, Output%V_Fcst, &
                     V_Component2, Output%U_Fcst, Output%V_Fcst, Output%Median_Press, Output%Cloud_Type, &
                     QC_Flag)

                  IF (QC_Flag .NE. sym%SUCCESS) THEN

                     CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
                     CALL IncrementElement(QC_Flag, Start_Element)
                     CYCLE

                  ENDIF

               ELSE IF(Nested_Tracking_Flag .EQ. sym%YES) THEN

                  ! If 5x5 tracking is successful we need to update forecast wind
                  ! before checking for gross errors because the pressure has changed.
                  ! Follow same logic as before but with combined median pressure.

                  CALL Locate(Fcst_Prof%Pressure, Press_Levels, Combined_Median, Level)

                  ! Interpolate forecast wind to new median pressure level.
                  IF ( (Level+1) .LE. Press_Levels) THEN

                     Output%U_Fcst = ((Fcst_Prof%Pressure(Level+1) - Combined_Median) * &
                        Fcst_Prof%U_Wind(Level) +  (Combined_Median - &
                        Fcst_Prof%Pressure(Level)) * Fcst_Prof%U_Wind(Level+1)) &
                        / (Fcst_Prof%Pressure(Level+1) - Fcst_Prof%Pressure(Level))

                     Output%V_Fcst = ((Fcst_Prof%Pressure(Level+1) - Combined_Median) * &
                        Fcst_Prof%V_Wind(Level) +  (Combined_Median - &
                        Fcst_Prof%Pressure(Level)) * Fcst_Prof%V_Wind(Level+1)) &
                        / (Fcst_Prof%Pressure(Level+1) - Fcst_Prof%Pressure(Level))

                  ELSE

                     Output%U_Fcst = Fcst_Prof%U_Wind(Level)
                     Output%V_Fcst = Fcst_Prof%V_Wind(Level)

                  ENDIF

                  ! Check 5x5 estimate for gross errors
                  !
                  CALL Gross_Error_Checks(Nav%NavType, U_Component, U_Component2, V_Component, &
                  ! WCB
                  !   V_Component2, Output%U_Fcst, Output%V_Fcst, &
                     V_Component2, Output%U_Fcst, Output%V_Fcst, Output%Median_Press, Output%Cloud_Type, &
                     QC_Flag)

                  Output%QC_Flag = QC_Flag

                  IF (QC_Flag .NE. sym%SUCCESS) THEN

                     CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
                     CALL IncrementElement(QC_Flag, Start_Element)
                     CYCLE

                  ELSE

                     ! If the estimate passes the gross checks compute average value
                     U_Avg = (U_Component + U_Component2) / 2.0
                     V_Avg = (V_Component + V_Component2) / 2.0
                     Output%U_Avg = U_Avg
                     Output%V_Avg = V_Avg

                  ENDIF

               ENDIF  ! done checking 5x5 estimate for gross errors


              ! ----------------------------------------------------------------------
              ! Count number of winds without errors.
              ! ----------------------------------------------------------------------

            ENDIF   ! max gradient check

            ! ------------------------------------------------------------------------
            ! Add target to array of wind data, then process next box
            ! ------------------------------------------------------------------------

            CALL Update_Wind_Data(Wind_Data, TargetData, Error_Counts, Target_Number, Good_Winds,& !updates
                                     EpochScanTimes, QC_Flag, Output, DBSCAN_Out, CSWV_Flag, MAX_WIND_RECORDS,&
                                     Box_Data) ! aab added Box_Data for CloudyPixels output
            CALL IncrementElement(QC_Flag, Start_Element)

         END DO



         targetSceneStartLine = targetSceneStartLine + NOMINAL_BOX_SIZE
         targetSceneEndLine = targetSceneEndLine + NOMINAL_BOX_SIZE
      END DO



      ! --------------------------------------------------------------------------
      ! Deallocate arrays.
      ! --------------------------------------------------------------------------

      !CALL Destroy_Spatial_Uniformity(Mean_Values, Max_Values, Min_Values, StdDev_Values)

      DEALLOCATE(Search_BrtTemp_Values, Search_BrtTemp_Values2)
      DEALLOCATE(Lag_Table, Lag_Table2)
      DEALLOCATE(SetOfPoints)
      DEALLOCATE(SSD_Matrix)


      ret = .TRUE.
   END FUNCTION Target_Selection_Loop





END MODULE AMV_EN_TARGET_SELECTION_M

!-------------------------------------------------------------------------------
! Name:
!   WINDS_INC
!
! Function:
!   This module is converted from AMV include file, it contains variables used in
!   AMV
!
! Description:
!
!
! Reference:
!   None
!
! Calling sequence:
!   None
!
! Inputs:
!   None
!
! Outputs:
!   None
!
! Dependencies:
!   None
!
! Side effects:
!   None
!
! History:
!   11/2013 -
!-------------------------------------------------------------------------------
MODULE AMV_EN_WINDS_INC

   USE TYPE_KINDS_AIT
   USE GEOCAT_CONSTANTS
   IMPLICIT NONE

   INTEGER(LONG), PARAMETER :: CSWV_CLEAR = sym%YES
   INTEGER(LONG), PARAMETER :: CSWV_CLOUD = sym%NO
   CHARACTER(len=*), PARAMETER :: TARGET_CLEAR = "CS"
   CHARACTER(len=*), PARAMETER :: TARGET_CLOUD = "CT"

   INTEGER(SHORT), PARAMETER :: Location_Dimensions = 2
   INTEGER(SHORT), PARAMETER :: PIXEL_OFFSET = 2

   INTEGER(SHORT), PARAMETER :: BUFFER_SEGMENTS_POLAR = 21
   INTEGER(SHORT), PARAMETER :: BUFFER_SEGMENTS_GEO = 7
   REAL(SINGLE), PARAMETER :: MIN_PERCENT_PRESS_VALUES_POLAR = 0.01
   REAL(SINGLE), PARAMETER :: MIN_PERCENT_PRESS_VALUES_GEO = 0.02

   ! default box spacing
   INTEGER(SHORT), PARAMETER :: NOMINAL_BOX_SIZE = 15

   ! Hurricane Sandy test
   !INTEGER(SHORT), PARAMETER :: NOMINAL_BOX_SIZE = 11

   ! 1-min mesoscale test
   !INTEGER(SHORT), PARAMETER :: NOMINAL_BOX_SIZE = 5

   INTEGER(SHORT), PARAMETER :: NOMINAL_SWIR_BOX_SIZE = 7

   REAL(SINGLE), PARAMETER ::  IR_GRADIENT_THRESHOLD_POLAR = 2.0

   ! aab Tandem (dbscan)
   ! lower gradient threshold for LWIR winds
   !REAL(SINGLE), PARAMETER ::  IR_GRADIENT_THRESHOLD_GEO = 4.0
   REAL(SINGLE), PARAMETER ::  IR_GRADIENT_THRESHOLD_GEO = 2.0

   REAL(SINGLE), PARAMETER ::  WVCS_GRADIENT_THRESHOLD = 1.5
   REAL(SINGLE), PARAMETER ::  WVCT_GRADIENT_THRESHOLD = 2.0
   REAL(SINGLE), PARAMETER ::  VISIBLE_GRADIENT_THRESHOLD = 12.0
   ! aab SWIR Mods - VIIRS M11 channel is treated as a visible channel as
   !                 it's a 2.25um reflectance. But we need different thresholds
   REAL(SINGLE), PARAMETER ::  VISIBLE_GRADIENT_THRESHOLD_VIIRS = 2.0

   ! aab Tandem (dbscan)
   ! lower gradient threshold for SWIR winds
   !REAL(SINGLE), PARAMETER ::  SWIR_GRADIENT_THRESHOLD = 3.0
   REAL(SINGLE), PARAMETER ::  SWIR_GRADIENT_THRESHOLD = 2.0

   REAL(SINGLE), PARAMETER ::  IR_COLD_THRESHOLD = 0.25
   REAL(SINGLE), PARAMETER ::  WVCT_COLD_THRESHOLD = .99
   REAL(SINGLE), PARAMETER ::  WVCS_COLD_THRESHOLD = 0.20
   REAL(SINGLE), PARAMETER ::  ACCEL_THRESHOLD = 10.0

   ! baseline
   !REAL(SINGLE), PARAMETER ::  ACCEL_THRESHOLD_VZ = 5.0
   ! modified threshold to capture low level winds around tropical cyclones
   REAL(SINGLE), PARAMETER ::  ACCEL_THRESHOLD_VZ = 7.5

   REAL(SINGLE), PARAMETER :: STDDEV_THRESHOLD = 1.0
   REAL(SINGLE), PARAMETER :: PRESSURE_CONSISTENCY_THRESHOLD = 100.0

   REAL(SINGLE), PARAMETER :: CORR_MIN_POLAR = 0.5              ! min for entire target scene
   REAL(SINGLE), PARAMETER :: CORR_MIN_GEO = 0.6                ! min for entire target scene
   REAL(SINGLE), PARAMETER :: MIN_VALID_REFLECTANCE = 0.0       ! min valid value for reflectance in percent
   REAL(SINGLE), PARAMETER :: MAX_VALID_REFLECTANCE = 200.0     ! max valid value for reflectance in percent
   REAL(SINGLE), PARAMETER :: MIN_VALID_BT = 150.0              ! min valid value for Brightness temp
   REAL(SINGLE), PARAMETER :: MAX_VALID_BT = 340.0              ! max valid value for Brightness temp
   REAL(SINGLE), PARAMETER :: COHERENCE_THRESHOLD_PCT = 0.8
   REAL(SINGLE), PARAMETER :: SAMPLE_THRESHOLD_PCT = 0.8
   REAL(SINGLE), PARAMETER :: SIGMA_1 = 1.0                     ! 1 sigma cutoff value of distribution
   REAL(SINGLE), PARAMETER :: SIGMA_3 = 3.0                     ! 3 sigma cutoff value of distribution
   REAL(SINGLE), PARAMETER :: LOWER_GAUSSIAN_EXPONENT = -10.0

   ! nested tracking parameters

   REAL(SINGLE), PARAMETER :: EPS_POLAR = 3.3                    ! neighborhood radius in pixels
   REAL(SINGLE), PARAMETER :: EPS_GEO = 0.5

   ! aab Tandem (dbscan)
   ! use larger neighborhood radius for the hi-resolution visible winds
   REAL(SINGLE), PARAMETER :: EPS_GEO_VZ = 1.0
   
   REAL(DOUBLE), PARAMETER :: CORR_COEFF_5X5_GEO        = 0.8   ! 5x5 correlation threshold

   ! new variables - 1/25/16
   REAL(DOUBLE), PARAMETER :: CORR_COEFF_5X5_POLAR_CSWV = 0.0
   ! aab Tandem mod 
   ! CorrCoeff values for Tandem VPW
   REAL(DOUBLE), PARAMETER :: CORR_COEFF_5X5_POLAR_CLD  = 0.6 
   REAL(DOUBLE), PARAMETER :: CORR_COEFF_5X5_POLAR_CLD_S  = 0.6  ! Single-Sat Triplet
   REAL(DOUBLE), PARAMETER :: CORR_COEFF_5X5_POLAR_CLD_D  = 0.7  ! Dual-Sat Triplet
   REAL(DOUBLE), PARAMETER :: CORR_COEFF_5X5_POLAR_CLD_T  = 0.8  ! Three-Sat Triplet

   INTEGER(LONG), PARAMETER :: DEFAULT_TIME_INTERVAL_POLAR = 30

   INTEGER(SHORT), PARAMETER :: SCALE_FACTOR = 10
   INTEGER(SHORT), PARAMETER :: BRTTEMP_MIN = 1
   INTEGER(SHORT), PARAMETER :: BRTTEMP_MAX = 340 * SCALE_FACTOR
   REAL(SINGLE), PARAMETER :: MIN_HISTOGRAM_VALUE = 0.0
   REAL(SINGLE), PARAMETER :: MAX_HISTOGRAM_VALUE = 199.0
   INTEGER(SHORT), PARAMETER :: NUMBER_OF_SLOTS = 200
   REAL(SINGLE), PARAMETER :: INTERVAL_LENGTH = (MAX_HISTOGRAM_VALUE - MIN_HISTOGRAM_VALUE) / REAL(NUMBER_OF_SLOTS - 1)


   ! Flag values
   INTEGER(SHORT), PARAMETER :: BOX_ON_EDGE_FAILURE        = -2
   INTEGER(SHORT), PARAMETER :: ZERO_GRADIENT_FAILURE      = -1
   INTEGER(SHORT), PARAMETER :: GOOD_TARGET                =  0
   INTEGER(SHORT), PARAMETER :: GRADIENT_THRESHOLD_FAILURE =  1
   INTEGER(SHORT), PARAMETER :: EARTH_EDGE_FAILURE         =  2
   INTEGER(SHORT), PARAMETER :: CLOUD_AMOUNT_FAILURE       =  3
   INTEGER(SHORT), PARAMETER :: BAD_PRESS_FAILURE          =  4
   INTEGER(SHORT), PARAMETER :: BAD_BT_FAILURE             =  5
   INTEGER(SHORT), PARAMETER :: MULTIPLE_LAYERS_FAILURE    =  6
   INTEGER(SHORT), PARAMETER :: COHERENCY_FAILURE          =  7
   INTEGER(SHORT), PARAMETER :: CORRELATION_FAILURE        =  8
   INTEGER(SHORT), PARAMETER :: U_ACCELERATION_FAILURE     =  9
   INTEGER(SHORT), PARAMETER :: V_ACCELERATION_FAILURE     = 10
   INTEGER(SHORT), PARAMETER :: UV_ACCELERATION_FAILURE    = 11
   INTEGER(SHORT), PARAMETER :: SLOW_WIND_FAILURE          = 12
   INTEGER(SHORT), PARAMETER :: TERMINATOR_FAILURE         = 13
   INTEGER(SHORT), PARAMETER :: PRESS_THRESHOLD_FAILURE    = 14
   ! Error 15 is assigned in feature_tracking utils
   INTEGER(SHORT), PARAMETER :: GROSS_ERROR_FAILURE        = 16
   INTEGER(SHORT), PARAMETER :: CTP_CONSISTENCY_FAILURE    = 17
   INTEGER(SHORT), PARAMETER :: SEARCH_NOT_FULL_FAILURE    = 18
   INTEGER(SHORT), PARAMETER :: EE_REJECT_FLAG             = 19
   ! Error 20 is assigned in feature_tracking utils
   ! Error 21 is assigned in feature_tracking utils
   ! Error 22 is assigned in feature_tracking utils

   ! WCB - add cloud height quality flag
   INTEGER(BYTE), PARAMETER :: CTH_DQF_GOOD_RETREVIAL = 0
   INTEGER(BYTE), PARAMETER :: CTH_DQF_MARGINAL_RETREVIAL = 1
   INTEGER(BYTE), PARAMETER :: CTH_DQF_RETREVIAL_ATTEMPTED = 2
   INTEGER(BYTE), PARAMETER :: CTH_DQF_BAD_RETREVIAL = 3
   INTEGER(BYTE), PARAMETER :: CTH_DQF_OPAQUE_RETREVIAL = 4

   ! 4-pt centered difference kernel
   REAL(SINGLE), DIMENSION(5), PARAMETER :: Kernel = &
       (/ -1.0 / 12.0, &
          8.0 / 12.0, &
          0.0, &
          -8.0 / 12.0, &
          1.0 / 12.0 /)

   !INTEGER(LONG), PARAMETER :: Max_Wind_Records = 1700000 !Configurable
   !INTEGER(SHORT), PARAMETER :: MAX_PARAMETERS = 85
   ! increased for stereo winds and second QI value (QINF)
   INTEGER(SHORT), PARAMETER :: MAX_PARAMETERS = 90
   REAL(SINGLE), PARAMETER :: PMIN_VISIBLE = 700.0
   ! aab SWIR Mods - VIIRS M11 channel is treated as a visible channel as
   !                 it's a 2.25um reflectance. But we need different thresholds
   REAL(SINGLE), PARAMETER :: PMIN_VISIBLE_VIIRS = 300.0

   REAL(SINGLE), PARAMETER :: PMIN_SWIR = 700.0
   REAL(SINGLE), PARAMETER :: PMIN_CTWV = 100.0
   REAL(SINGLE), PARAMETER :: PMIN_LWIR = 100.0
   REAL(SINGLE), PARAMETER :: PMAX_CTWV = 350.0
   REAL(SINGLE), PARAMETER :: PMAX_CTWV_MODIS = 600.0
   REAL(SINGLE), PARAMETER :: PMIN_CSWV10 = 450.0
   REAL(SINGLE), PARAMETER :: PMAX_CSWV10 = 700.0
   REAL(SINGLE), PARAMETER :: PMAX_ALL_WINDS = 1000.0
   REAL(SINGLE), PARAMETER :: CLR_CLDY_PRESS_CUTOFF = 600.0
   REAL(SINGLE), PARAMETER :: MAX_SOLAR_ZEN_VISIBLE = 80.0
   REAL(SINGLE), PARAMETER :: MIN_SOLAR_ZEN_SWIR = 90.0
   REAL(SINGLE), PARAMETER :: MAX_SOLAR_ZEN_SWIR = 200.0
   REAL(SINGLE), PARAMETER :: CTP_MAX = 1100.0

   ! Gross error thresholds
   REAL(SINGLE), PARAMETER :: VEC_DIFF_VZ     =  6.0
   REAL(SINGLE), PARAMETER :: VEC_DIFF_SWIR   =  7.0
   REAL(SINGLE), PARAMETER :: VEC_DIFF_WVCT8  =  8.5 ! AAB update from 10.0 to 8.5
   REAL(SINGLE), PARAMETER :: VEC_DIFF_WVCS8  = 12.0
   REAL(SINGLE), PARAMETER :: VEC_DIFF_WVCS9  = 12.0
   REAL(SINGLE), PARAMETER :: VEC_DIFF_WVCS10 = 12.0
   REAL(SINGLE), PARAMETER :: VEC_DIFF_LWIR   =  8.0 ! AAB update from 10.0 to 8.0
   REAL(SINGLE), PARAMETER :: VEC_DIFF_LWIR_POLAR   = 7.0

   REAL(SINGLE), PARAMETER, PUBLIC :: SHEAR_PMIN =  100.0
   REAL(SINGLE), PARAMETER, PUBLIC :: SHEAR_PMAX = 1000.0

   ! WCB
   ! satellite zenith angle cutoff
   REAL(SINGLE), PARAMETER, PUBLIC :: ZENITH_ANGLE_CUTOFF = 70.0

   ! QI parameters
   REAL(SINGLE), PARAMETER :: INIT_MISSING_VALUE_QI = -0.98
   REAL(SINGLE), PARAMETER :: MIN_SPD = 0.0             ! Minimum speed accepted by automatic quality control (AQC)
   REAL(SINGLE), PARAMETER :: W_SPD = 1.0               ! AQC wind speed weight
   REAL(SINGLE), PARAMETER :: W_DIR = 1.0               ! AQC wind direction weight
   REAL(SINGLE), PARAMETER :: W_VEC = 1.0               ! AQC wind vector weight
   REAL(SINGLE), PARAMETER :: W_UC = 0.0                ! AQC wind u-component weight
   REAL(SINGLE), PARAMETER :: W_VC = 0.0                ! AQC wind v-component weight
   REAL(SINGLE), PARAMETER :: W_LC = 2.0                ! AQC buddy check weight
   REAL(SINGLE), PARAMETER :: W_FC = 1.0                ! AQC forecast weight
   ! set forecast weight back to 1.0
   !REAL(SINGLE), PARAMETER :: W_FC = 0.0                ! AQC forecast weight
   REAL(SINGLE), PARAMETER :: S1 = 0.2                  ! speed test parameter 1 (fraction)
   REAL(SINGLE), PARAMETER :: S2 = 1.0                  ! speed test parameter 2 (offset)
   REAL(SINGLE), PARAMETER :: S3 = 3.0                  ! speed test parameter 3 (exp. for normalization)
   REAL(SINGLE), PARAMETER :: D1 = 20.0                 ! direction test parameter 1  (exp. dependency)
   REAL(SINGLE), PARAMETER :: D2 = 10.0                 ! direction test parameter 2A (fraction)
   REAL(SINGLE), PARAMETER :: D22= 10.0                 ! direction test parameter 2B (offset)
   REAL(SINGLE), PARAMETER :: D3 = 4.0                  ! direction test parameter 3  (exp. for normalization)
   REAL(SINGLE), PARAMETER :: VEC1 = 0.2                ! vector test parameter 1 (fraction)
   REAL(SINGLE), PARAMETER :: VEC2 = 1.0                ! vector test parameter 2 (offset)
   REAL(SINGLE), PARAMETER :: VEC3 = 3.0                ! vector test parameter 3 (exp. for normalization)
   REAL(SINGLE), PARAMETER :: L1 = 0.2                  ! local con parameter 1 (fraction)
   REAL(SINGLE), PARAMETER :: L2 = 1.0                  ! local con parameter 2 (offset)
   REAL(SINGLE), PARAMETER :: L3 = 3.0                  ! local con parameter 3 (exp. for normalization)
   REAL(SINGLE), PARAMETER :: LOC_PRES_DIF = 50.0       ! max pressure difference (mb)
   REAL(SINGLE), PARAMETER :: LOC_BOX_DEF = 1.0         ! collocation box area (degrees)
   REAL(SINGLE), PARAMETER :: F1 = 0.4                  ! forecast parameter 1 (fraction)
   REAL(SINGLE), PARAMETER :: F2 = 1.0                  ! forecast parameter 2 (offset)
   REAL(SINGLE), PARAMETER :: F3 = 2.0                  ! forecast parameter 3 (exp. for normalization)
   REAL(SINGLE), PARAMETER :: U1 = 1.0                  ! u-component paramter 1 (fraction)
   REAL(SINGLE), PARAMETER :: U2 = 1.0                  ! u-component paramter 2 (offset)
   REAL(SINGLE), PARAMETER :: U3 = 2.0                  ! u-component paramter 3 (exp. for normalization)
   REAL(SINGLE), PARAMETER :: V1 = 1.0                  ! v-component paramter 1 (fraction)
   REAL(SINGLE), PARAMETER :: V2 = 1.0                  ! v-component paramter 2 (offset)
   REAL(SINGLE), PARAMETER :: V3 = 2.0                  ! v-component paramter 3 (exp. for normalization)

   ! EE parameters
   !CHARACTER(LEN=9) :: Predictors = 'EE_COEFFS' !Configurable
   CHARACTER(LEN=256) :: Predictors
   INTEGER(SHORT), PARAMETER :: MAX_NUM_PREDICTORS = 10
   REAL(SINGLE), PARAMETER :: PRESSURE_OFFSET = 200.0
   REAL(SINGLE), PARAMETER :: EE_LIMIT_BAND02 = 5.5        ! Band 02 EE cutoff.
   REAL(SINGLE), PARAMETER :: EE_SPD_LIMIT_BAND02 = 30.0   ! Band 02 Speed cutoff.
   REAL(SINGLE), PARAMETER :: EE_QI_LIMIT_BAND02 = 0.95    ! Band 02 QI cutoff.
   REAL(SINGLE), PARAMETER :: EE_LIMIT_BAND07 = 5.0        ! Band 07 EE cutoff.
   REAL(SINGLE), PARAMETER :: EE_SPD_LIMIT_BAND07 = 30.0   ! Band 07 Speed cutoff.
   REAL(SINGLE), PARAMETER :: EE_QI_LIMIT_BAND07 = 0.95    ! Band 07 QI cutoff.
   REAL(SINGLE), PARAMETER :: EE_LIMIT_BAND08 = 5.0        ! Band 08 EE cutoff. Clear Sky.
   REAL(SINGLE), PARAMETER :: EE_SPD_LIMIT_BAND08 = 30.0   ! Band 08 Speed cutoff. Clear Sky.
   REAL(SINGLE), PARAMETER :: EE_QI_LIMIT_BAND08 = 0.95    ! Band 08 QI cutoff. Clear Sky.
   REAL(SINGLE), PARAMETER :: EE_LIMIT_BAND10 = 5.0        ! Band 10 EE cutoff. Clear Sky.
   REAL(SINGLE), PARAMETER :: EE_SPD_LIMIT_BAND10 = 30.0   ! Band 10 Speed cutoff. Clear Sky.
   REAL(SINGLE), PARAMETER :: EE_QI_LIMIT_BAND10 = 0.95    ! Band 10 QI cutoff. Clear Sky.
   REAL(SINGLE), PARAMETER :: EE_LIMIT_BAND14 = 4.5        ! Band 14 EE cutoff.
   REAL(SINGLE), PARAMETER :: EE_SPD_LIMIT_BAND14 = 25.0   ! Band 14 Speed cutoff.
   REAL(SINGLE), PARAMETER :: EE_QI_LIMIT_BAND14 = 0.9     ! Band 14 QI cutoff.

   ! Land Mask
   INTEGER(SHORT), PARAMETER :: LAND_BINARY_MASK        = 1
   INTEGER(SHORT), PARAMETER :: WATER_BINARY_MASK       = 0


   ! aab Tandem (dbscan) - (increased from 18 to 20)
   INTEGER(LONG), PARAMETER :: DBSCAN_Output_Variables = 20 


   !----------------------------------
   ! ABI channel
   !----------------------------------
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN1  =  1
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN2  =  2
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN3  =  3
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN4  =  4
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN5  =  5
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN6  =  6
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN7  =  7
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN8  =  8
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN9  =  9
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN10 = 10
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN11 = 11
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN12 = 12
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN13 = 13
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN14 = 14
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN15 = 15
   INTEGER(LONG), PUBLIC, PARAMETER :: NATIVE_ABI_CHN16 = 16


END MODULE AMV_EN_WINDS_INC
